<?php
/**
 * Class for checking that a date is valid for a localized environment 
 * 
 * @package frontend
 * @subpackage lib
 * @author Diego Cebrián
 */
 
/**
 * Class for checking that a date is valid for a localized environment 
 *
 * @package frontend
 * @subpackage lib
 * @author Diego Cebrián
 */
class myDateValidator extends sfValidator
{

  /**
   * Function to start the validation class. <br />
   * 
   * The parameters array is composed of: <br />
   * 
   * <ul>
   * 
   *  <li>date_error: The string that will be shown when the date is not valid 
   *  </li>
   * 
   * </ul>
   *
   * @param unknown_type $context
   * @param unknown_type $parameters
   * @return unknown
   */
  public function initialize($context, $parameters = null)
  {
    // initialize parent
    parent::initialize($context, $parameters);
 
    // set defaults
    $this->setParameter('date_error', 'Invalid date');
 
    $this->getParameterHolder()->add($parameters);
 
    return true;
  }
 
  /**
   * 
   * Function that execute the validation with the parameters passed in 
   * initialize, except the value, that is passed here by the validation helper, 
   * and it's value is the value filled in the field form to check
   *
   * @param string &$value
   * @param string &$error
   * @return boolean
   */
  public function execute(&$value, &$error)
  {
 
    //check date
    if (!MyTools::isValidDate($value)) {
      $error = $this->getParameter('date_error');
      return false;
    }
    else return true;
  }
}