<?php
// auto-generated by sfPropelCrud
// date: 2008/11/12 22:08:20

/**
 * Article actions.
 *
 * @package    frontend
 * @subpackage modules-article
 * @author     Diego Cebrián Martínez
 */

/**
 * Article actions.
 *
 * @package    frontend
 * @subpackage modules-article
 * @author     Diego Cebrián Martínez
 */
class articleActions extends sfActions
{
  /**
   * It shows the first article
   *
   * @return unknown
   */
  public function executeIndex()
  {
    return $this->forward('article', 'show?id=1');
  }

  /**
   * It shows a list of the articles
   *
   */
  public function executeList()
  {
    $this->articles = ArticlePeer::doSelect(new Criteria());
  }

  /**
   * Show the article correponding to the id passed as HTTP parameter
   *
   */
  public function executeShow()
  {  	
    $this->article = ArticlePeer::retrieveByPk($this->getRequestParameter('id'));
    $this->forward404Unless($this->article);
    $this->author = $this->article->getUser();
  }
  
  /**
   * Show the first article in the correct language. Is the first page that the
   * program shows to the visitor, and catch the languages from the navigator
   * to get the first selected and show all the information in this one.
   *
   */
  public function executeInit()
  { 		
	  $languages=$this->getRequest()->getLanguages();
	  $this->getUser()->setCulture(substr($languages[0],0,2));
    $this->article = ArticlePeer::retrieveByPk($this->getRequestParameter('id'));
    $this->forward404Unless($this->article);
    $this->author = $this->article->getUser();
    $this->setTemplate('show');
  }

  /**
   * Action to show a form to create a new article
   *
   */
  public function executeCreate()
  {
    $this->article = new Article();

    $this->setTemplate('edit');
  }

  /**
   * Action to show a form to edit an article
   *
   */
  public function executeEdit()
  {
    $this->article = ArticlePeer::retrieveByPk($this->getRequestParameter('id'));
    $this->forward404Unless($this->article);
  }

  /**
   * Function to update the content of an article geting the data from the 
   * requested parameters by HTTP
   *
   * @return unknown
   */
  public function executeUpdate()
  {
    if (!$this->getRequestParameter('id'))
    {
      $article = new Article();
    }
    else
    {
      $article = ArticlePeer::retrieveByPk($this->getRequestParameter('id'));
      $this->forward404Unless($article);
    }

    $article->setId($this->getRequestParameter('id'));
    $article->setAuthorId($this->getRequestParameter('author_id') ? $this->getRequestParameter('author_id') : null);
    $article->setTitle($this->getRequestParameter('title'));
    $article->setText($this->getRequestParameter('text'));

    $article->save();

    return $this->redirect('article/show?id='.$article->getId());
  }

  /**
   * Delete an article
   *
   * @return url
   */
  public function executeDelete()
  {
    $article = ArticlePeer::retrieveByPk($this->getRequestParameter('id'));

    $this->forward404Unless($article);

    $article->delete();

    return $this->redirect('article/list');
  }
}
