<?php
/**
 * This file represent the content of the web when there is not any action from 
 * other module. Here are programmed the errors and the contact form.
 * 
 * @author Diego Cebrián
 * @package    frontend
 * @subpackage modules-content
 */

/**
 * This class represent the content of the web when there is not any action from 
 * other module. Here are programmed the errors and the contact form.
 *
 * @package    frontend
 * @subpackage modules-content
 * @author     Diego Cebrián Martínez
 */
class contentActions extends sfActions
{
  /**
   * Executes index action: return to the principal page
   *
   */
  public function executeIndex()
  {
    $this->forward('default', 'module');
  }
  
  /**
   * Site maintenance
   *
   */
  public function executeUnavailable()
  {
  }
  /**
   * Show error in credentials request
   *
   */
  public function executeCredentials()
  {
  }
  /**
   * Show the disabled application message
   *
   */
  public function executeDisabled()
  {
  }
  /**
   * Page not found
   *
   */
  public function executeError404()
  {
  }
  /**
   * Server error
   *
   */
  public function executeError500()
  {
  }
  /**
   * Action to show a login error, or an acces to an action restricted due to a
   * login error
   *
   */
  public function executeLogin()
  {
  }
  /**
   * Error that shows that an acction is not allowed to a logged user
   *
   */
  public function executeNotAllowed()
  {
  }
  /**
   * Shows that the apply form was sende
   *
   */
  public function executeApplied()
  {
  }
  /**
   * Action for showing an apply form to get access to Gesport
   *
   * @return unknown
   */
  public function executeApply()
  {
  	
    //Show the form
    if ($this->getRequest()->getMethod() != sfRequest::POST)
    {
	    $this->name=$this->getRequestParameter('name');
	    $this->lastName=$this->getRequestParameter('last_name');
	    $this->nickname=$this->getRequestParameter('nickname');
	    $this->email=$this->getRequestParameter('email');
	    $this->bornAt=$this->getRequestParameter('born_at');
	    $this->role=$this->getRequestParameter('role');
      return sfView::SUCCESS;
    }
    else{
    	
      $this->getRequest()->setAttribute('name', $this->getRequestParameter('name'));
      $this->getRequest()->setAttribute('last_name', $this->getRequestParameter('last_name'));
      $this->getRequest()->setAttribute('nickname', $this->getRequestParameter('nickname'));
      $this->getRequest()->setAttribute('email', $this->getRequestParameter('email'));
      $this->getRequest()->setAttribute('born_at', $this->getRequestParameter('born_at'));
      $this->getRequest()->setAttribute('role', $this->getRequestParameter('role'));
      
      $raw_email = $this->sendEmail('mail', 'applyNewUser');
      //debur function (noly in dev mode)
      $this->logMessage($raw_email, 'debug');	
      
    	$this->forward('content', 'applied');
    }
  }
  /**
   * Action to handle errors in Apply form
   *
   * @return unknown
   */
  public function handleErrorApply(){
  	$this->name=$this->getRequestParameter('name');
    $this->lastName=$this->getRequestParameter('last_name');
    $this->nickname=$this->getRequestParameter('nickname');
    $this->email=$this->getRequestParameter('email');
    $this->bornAt=$this->getRequestParameter('born_at');
    $this->role=$this->getRequestParameter('role');
  	
    return sfView::SUCCESS;
  }
	  
}
