<?php
/**
 * Form to get the data from a applier
 * 
 * @package    frontend
 * @subpackage modules-content-templates
 */
?>

<?php use_helper('Object') ?>
<?php use_helper('Validation') ?>
 
<?php slot('header'); ?>
<?php echo image_tag('admin/help', 'alt=help class=error_ico')?>
  <h1 class="help"><?php echo __('Help for').': '.__('Apply form') ?></h1>
  <p class="help"><?php echo __('Enter the requested data') ?></p>
  <p class="help"><?php echo __('Emphasided fields are mandatory').': <label class="mandatory">'.__('Mandatory field').'</label>' ?></p>
  <p class="help"><?php echo __('Clicking on the button closed to date field will display a dynamic calendar') ?></p>
  <p class="help"><?php echo __('For manual date editing, please use this format').': '.format_date('1981-06-20') ?></p>
<?php end_slot(); ?>

<h1><?php echo __('Apply for an account')?></h1>
<?php echo form_tag('@register') ?>

<p><?php echo __('Please, fill in the form')?>.</p>

  <div class="form_row">
    <?php echo __(form_error('name')) ?>
    <div class="form_label_left"><label for="name"><?php echo __('First name')?>:</label></div>
    <div class="form_field_left"><?php echo input_tag('name', $name,  array('size' => 26, 'maxlength' => 26)) ?></div>
  </div>
  
  <div class="form_row">
    <?php echo __(form_error('last_name')) ?>
    <div class="form_label_left"><label for="last_name"><?php echo __('Last name')?>:</label></div>
    <div class="form_field_left"><?php echo input_tag('last_name', $lastName,  array('size' => 40, 'maxlength' => 40)) ?></div>
  </div>  
  
  <div class="form_row">
    <?php echo __(form_error('nickname')) ?>
    <div class="form_label_left"><label for="nick_name" class="mandatory"><?php echo __('Wanted nickname')?>:</label></div>
    <div class="form_field_left"><?php echo input_tag('nickname', $nickname,  array('size' => 15, 'maxlength' => 15)) ?></div>
  </div>
    
  <div class="form_row">
    <?php echo __(form_error('email')) ?>
    <div class="form_label_left"><label for="email" class="mandatory"><?php echo __('Email')?>:</label></div>
    <div class="form_field_left"><?php echo input_tag('email', $email,  array (
    'size' => 40,
    )) ?></div>
  </div>
  
  <div class="form_row">
    <?php echo __(form_error('born_at')) ?>
    <div class="form_label_left"><label for="born_at" class="mandatory"><?php echo __('Born at')?>:</label></div>
    <div class="form_field_left"><?php echo input_date_tag('born_at', null, array ('rich' => true,)) ?></div>
  </div>
   
  <div class="form_row">
    <?php echo __(form_error('role')) ?>
    <div class="form_label_left"><label for="role"><?php echo __('You are (please select what will be you main activity in Gesport)')?>:</label></div>
    <div class="form_field_left"><?php echo select_tag('role', options_for_select(array(__('Coach') => __('Coach'), __('Athlete') => __('Athlete')))) ?></div>
  </div>   
<?php echo input_hidden_tag('referer', $sf_request->getAttribute('referer')) ?>
<hr />
  
  <div class="form_row">  
    <?php echo submit_tag(__('Send Apply')) ?>
  </div>
</form>