<?php
// auto-generated by sfPropelCrud
// date: 2008/10/21 00:24:55

/**
 * Macrocycle Actions for page layout
 * @package    frontend
 * @subpackage modules-macrocycle
 * @author Diego Cebrián
 */

/**
 * Macrocycle actions for page layout
 *
 * @package    frontend
 * @subpackage modules-macrocycle
 * @author     Diego Cebrián Martínez
 */
class macrocycleActions extends sfActions
{
  /**
   * Default action of macrocycle, it returns the list
   *
   * @return unknown
   */
  public function executeIndex()
  {
    return $this->forward('macrocycle', 'list');
  }

  /**
   * List of all macrocycles
   *
   */
  public function executeList()
  {
    $this->macrocycles = MacrocyclePeer::doSelect(new Criteria());
  }


  /**
   * Show the the macrocycle of the current date for the current user
   *
   */
  public function executeShowCurrent()
  {
    $this->period = MacrocyclePeer::retrieveCurrentByUserId($this->getRequestParameter('user_id'));
    $this->forward404Unless($this->period);
    $this->mesocycle = MesocyclePeer::retrieveCurrentByUserId($this->getRequestParameter('user_id'));
    $this->user = $this->period->getSeason()->getUser();
    $this->forward404Unless($this->user);
    $this->forwardIf($this->period->getSeason()->getUser()->getCoachId()!=$this->getUser()->getAttribute('user_id',0 , 'athlete'), 'content', 'notAllowed');
    
    $this->setTemplate('show');
  }


  /**
   * Show a macrocycle
   *
   */
  public function executeShow()
  {
    $this->period = MacrocyclePeer::retrieveByUserIdAndPk($this->getRequestParameter('user_id'), $this->getRequestParameter('macrocycle_id')); 
    $this->forward404Unless($this->period);
    $this->mesocycle = MesocyclePeer::retrieveCurrentByUserId($this->getRequestParameter('user_id'));
    $this->user = $this->period->getSeason()->getUser(); 
    $this->forward404Unless($this->user);
    $this->forwardIf($this->period->getSeason()->getUser()->getCoachId()!=$this->getUser()->getAttribute('user_id',0 , 'athlete'), 'content', 'notAllowed');
  }
  
  /**
   * To edit a macrocycle from Coach View
   *
   * @return unknown
   */
  public function executeEdit()
  {
    //Show the form
    if ($this->getRequest()->getMethod() != sfRequest::POST)
    {
      //retrieve data for the form
      $this->period = MacrocyclePeer::retrieveByUserIdAndPk($this->getRequestParameter('user_id'), $this->getRequestParameter('macrocycle_id'));
      $this->forward404Unless($this->period);
      $this->user = $this->period->getSeason()->getUser();
      $this->forward404Unless($this->user);
      //access control
      $this->forwardIf($this->period->getSeason()->getUser()->getCoachId()!=$this->getUser()->getAttribute('user_id',0 , 'athlete'), 'content', 'notAllowed');
      
      // display the form
      $this->form_action="macrocycle_edit";
      $this->getRequest()->getParameterHolder()->set('referer', $this->getRequest()->getReferer());
      
      return sfView::SUCCESS;
    }
    //Recover data and update the season
    else
    {
      $this->period = MacrocyclePeer::retrieveByUserIdAndPk($this->getRequestParameter('user_id'), $this->getRequestParameter('macrocycle_id'));
      $this->forward404Unless($this->period);
      $this->user = $this->period->getSeason()->getUser();
      $this->forward404Unless($this->user);
      //access control
      $this->forwardIf($this->period->getSeason()->getUser()->getCoachId()!=$this->getUser()->getAttribute('user_id',0 , 'athlete'), 'content', 'notAllowed');
      
      //update and save
      $macrocycle=$this->update($this->period);
      $macrocycle->save();
      
      //redirect to selected page
      $this->redirect('@season_show?season_id='.$this->period->getSeasonId().'&user_id='.$this->user->getId());
    }
  }
  
  
  /**
   * When an error in editing from Coach View occurs it returns to the edit form
   *
   * @return unknown
   */
  
  public function handleErrorEdit()
  {
    $this->period = MacrocyclePeer::retrieveByUserIdAndPk($this->getRequestParameter('user_id'), $this->getRequestParameter('macrocycle_id'));
    $this->forward404Unless($this->period);
    $this->user = $this->period->getSeason()->getUser();
    $this->forward404Unless($this->user);
    //access control
    $this->forwardIf($this->period->getSeason()->getUser()->getCoachId()!=$this->getUser()->getAttribute('user_id',0 , 'athlete'), 'content', 'notAllowed');
    
    $this->period->setDescription($this->getRequestParameter('description'));
    $this->period->setSeasonId($this->getRequestParameter('season_id') ? $this->getRequestParameter('season_id') : null);
    $this->period->setTheoricIntensity1($this->getRequestParameter('theoric_intensity1'));
    $this->period->setTheoricIntensity2($this->getRequestParameter('theoric_intensity2'));
    $this->period->setTheoricIntensity3($this->getRequestParameter('theoric_intensity3'));
    $this->period->setTheoricVolume($this->getRequestParameter('theoric_volume'));
    return sfView::SUCCESS;
  }

  /**
   * Action for delete a macrocycle
   *
   * @return unknown
   */
  public function executeDelete()
  {
    $this->period = MacrocyclePeer::retrieveByUserIdAndPk($this->getRequestParameter('user_id'), $this->getRequestParameter('macrocycle_id'));
    $this->forward404Unless($this->period);
    $this->user = $this->period->getSeason()->getUser();
    $this->forward404Unless($this->user);
    $this->mesocycle = MesocyclePeer::retrieveCurrentByUserId($this->getRequestParameter('user_id'));
    //access control
    $this->forwardIf($this->period->getSeason()->getUser()->getCoachId()!=$this->getUser()->getAttribute('user_id',0 , 'athlete'), 'content', 'notAllowed');
    try {
      $this->period->delete();
      return $this->redirect('@season_show?season_id='.$this->period->getSeasonId().'&user_id='.$this->user->getId());
    }
    //if the macrocycle is used in other class, advert that can't be deleted
    catch (PropelException $e){    	
      $this->message = ' is still used in Gesport and can not be deleted.';
      $this->setTemplate('notDeleted');  
    }
    catch (Exception $e){
      $this->message = ' cannot be deleted.';
      $this->setTemplate('notDeleted');  
    }
  }  
  
  /**
   * Creation form Coach View
   *
   * @return unknown
   */
  public function executeAdd()
  {
    //Show the form
    if ($this->getRequest()->getMethod() != sfRequest::POST)
    {
      $this->user = UserPeer::retrieveByPk($this->getRequestParameter('user_id'));
      $this->forward404Unless($this->user);
      $this->season = SeasonPeer::retrieveByUserIdAndPk($this->getRequestParameter('user_id'), $this->getRequestParameter('season_id'));
      $this->forward404Unless($this->season);
      $this->period = new Macrocycle();
      $this->forward404Unless($this->period);
      $this->period->setSeason($this->season);
      
      $this->forwardIf($this->user->getCoachId()!=$this->getUser()->getAttribute('user_id',0 , 'athlete'), 'content', 'notAllowed');
      // display the form
      $this->form_action="macrocycle_add";
      $this->getRequest()->getParameterHolder()->set('referer', $this->getRequest()->getReferer());

      return sfView::SUCCESS;
    }
    //Recover data and create the season
    else
    {
      // handle the form submission
      
      $this->user = UserPeer::retrieveByPk($this->getRequestParameter('user_id'));
      $this->forward404Unless($this->user);
      $this->season = SeasonPeer::retrieveByUserIdAndPk($this->getRequestParameter('user_id'), $this->getRequestParameter('season_id'));
      $this->forward404Unless($this->season);
      $this->period = new Macrocycle();
      $this->forward404Unless($this->period); 
      $this->period->setSeason($this->season);
      $macrocycle=$this->update($this->period);
        
      $macrocycle->save();
      
      // redirect to the page of the user
      return $this->redirect('@season_show?season_id='.$this->season->getId().'&user_id='.$this->user->getId());
    }
  }
    
  /**
   * When an error in adding from Coach View occurs it returns to the add form
   *
   * @return unknown
   */
  public function handleErrorAdd()
  {
    $this->user = UserPeer::retrieveByPk($this->getRequestParameter('user_id'));
    $this->forward404Unless($this->user);
    $this->season = SeasonPeer::retrieveByUserIdAndPk($this->getRequestParameter('user_id'), $this->getRequestParameter('season_id'));
    $this->forward404Unless($this->season);
    $this->period = new Macrocycle();
    $this->forward404Unless($this->period);
    $this->period->setSeason($this->season); 
    $this->period->setDescription($this->getRequestParameter('description'));
    $this->period->setSeasonId($this->getRequestParameter('season_id') ? $this->getRequestParameter('season_id') : null);
    $this->period->setTheoricIntensity1($this->getRequestParameter('theoric_intensity1'));
    $this->period->setTheoricIntensity2($this->getRequestParameter('theoric_intensity2'));
    $this->period->setTheoricIntensity3($this->getRequestParameter('theoric_intensity3'));
    $this->period->setTheoricVolume($this->getRequestParameter('theoric_volume'));
    return sfView::SUCCESS;
  }

  /**
   * Action to show all macrocycles of a season
   *
   */
  public function executeSeason()
  {
  	$this->season= SeasonPeer::retrieveByPK($this->getRequestParameter('season_id'));
    $c=new Criteria();
    $c->add(MacrocyclePeer::SEASON_ID, $this->getRequestParameter('season_id'));
    $c->addJoin(MacrocyclePeer::SEASON_ID, SeasonPeer::ID);
    $this->macrocycles = MacrocyclePeer::doSelect($c);
    $this->forward404Unless($this->macrocycles);
    $this->user =  UserPeer::retrieveByPk($this->getRequestParameter('user_id'));
    $this->forward404Unless($this->user);
    $this->forwardIf($this->user->getCoachId()!=$this->getUser()->getAttribute('user_id',0 , 'athlete'), 'content', 'notAllowed');
    
  }

  /**
   * Action to update the macrocycle data with the fields of the form
   *
   * @param Macrocycle $macrocycle
   * @return Macrocycle
   */
  public function update($macrocycle)
  {
    $macrocycle->setDescription($this->getRequestParameter('description'));
    if ($this->getRequestParameter('start_at'))
    {
      list($d, $m, $y) = sfI18N::getDateForCulture($this->getRequestParameter('start_at'), $this->getUser()->getCulture());
      $macrocycle->setStartAt("$y-$m-$d");
    }
    if ($this->getRequestParameter('last_day_at'))
    {
      list($d, $m, $y) = sfI18N::getDateForCulture($this->getRequestParameter('last_day_at'), $this->getUser()->getCulture());
      $macrocycle->setLastDayAt("$y-$m-$d");
    }
    $macrocycle->setSeasonId($this->getRequestParameter('season_id') ? $this->getRequestParameter('season_id') : null);
    $macrocycle->setTheoricIntensity1($this->getRequestParameter('theoric_intensity1'));
    $macrocycle->setTheoricIntensity2($this->getRequestParameter('theoric_intensity2'));
    $macrocycle->setTheoricIntensity3($this->getRequestParameter('theoric_intensity3'));
    $macrocycle->setTheoricVolume($this->getRequestParameter('theoric_volume'));

    return $macrocycle;
  }
}
