<?php
// auto-generated by sfPropelCrud
// date: 2008/11/25 17:23:50

/**
 * Template to show a component with a list of macrocycles
 * 
 * @author Diego Cebrián
 * @package    frontend
 * @subpackage modules-macrocycle-templates
 * @uses     array macrocycle: the list of macrocycles
 * @uses  User user: the user which owns the macrocycles
 */
 
 
?>
<h2><?php echo __('Macrocycles for').' '.$user.' '.__('in Season').' '.$season; ?></h2>

<table>
<thead>
<tr>
  <th><?php echo __('Description'); ?></th>
  <th><?php echo __('Start at'); ?></th>
  <th><?php echo __('Last day at'); ?></th>
  <th><?php echo __('Theoric intensity'); ?></th>
  <th><?php echo __('Reported intensity'); ?></th>
  <th><?php echo __('Theoric volume'); ?></th>
  <th><?php echo __('Reported volume'); ?></th>
  <th><?php echo __('Options'); ?></th>
</tr>
</thead>
<tbody>
<?php foreach ($macrocycles as $period): ?>
<tr>
      <td><?php echo $period->getDescription() ?></td>
      <td><?php echo format_date($period->getStartAt(), 'D').', '.format_date($period->getStartAt(), 'EEEE') ?></td>
      <td><?php echo format_date($period->getLastDayAt(), 'D').', '.format_date($period->getLastDayAt(), 'EEEE') ?></td>
      <td>
        <table>
          <tr>
            <td>
              <?php echo $period->getIntensity1LowLimit().'-'.$period->getIntensity1HighLimit().' %'; ?>
            </td>
            <td>
              <?php echo $period->getTheoricIntensity1().' '.$period->getVolumeUnit(); ?>
            </td>
          </tr>
          <tr>
            <td>
              <?php echo $period->getIntensity2LowLimit().'-'.$period->getIntensity2HighLimit().' %'; ?>
            </td>
            <td>
              <?php echo $period->getTheoricIntensity2().' '.$period->getVolumeUnit(); ?>
            </td>
          </tr>
          <tr>
            <td>
              <?php echo $period->getIntensity3LowLimit().'-'.$period->getIntensity3HighLimit().' %'; ?>
            </td>
            <td>
              <?php echo $period->getTheoricIntensity3().' '.$period->getVolumeUnit(); ?>
            </td>
          </tr>
        </table>
      </td>
      <td>
        <table>
          <tr>
            <td>
              <?php echo $period->getReportedIntensity1().' '.$period->getVolumeUnit(); ?>
            </td>
          </tr>
          <tr>
            <td>
              <?php echo $period->getReportedIntensity2().' '.$period->getVolumeUnit(); ?>
            </td>
          </tr>
          <tr>
            <td>
              <?php echo $period->getReportedIntensity3().' '.$period->getVolumeUnit(); ?>
            </td>
          </tr>
        </table>
      </td>
      <td><?php echo $period->getTheoricVolume() ?></td>
      <td><?php echo $period->getReportedVolume() ?></td>
      <td><?php echo link_to(__('Show'), '@macrocycle_show?user_id='.$user->getId().'&macrocycle_id='.$period->getId()) ?></td>
      <td><?php echo link_to(__('Edit'), '@macrocycle_edit?user_id='.$user->getId().'&macrocycle_id='.$period->getId()) ?></td>
      <td><?php echo link_to(__('Add mesocycle'), '@mesocycle_add?user_id='.$user->getId().'&macrocycle_id='.$period->getId()) ?></td>
  </tr>
<?php endforeach; ?>
</tbody>
</table>
