<?php

/**
 * Mail Actions
 * @package    frontend
 * @subpackage modules-mail
 * @author Diego Cebrián
 */

/**
 * Mail Actions
 * @package    frontend
 * @subpackage modules-mail
 * @author     Diego Cebrián Martínez
 */

class mailActions extends sfActions
{
  /**
   * Executes index action
   *
   */
  public function executeIndex()
  {
    $this->forward('default', 'module');
  }
  /**
   * Mail to revoer the password
   *
   */
  public function executeSendPassword()
  {
    $mail = new sfMail();
    $mail->addAddress($this->getRequestParameter('email'));
    $mail->setFrom('Gesport <'.sfConfig::get('app_mail_admin').'>');
    $mail->setSubject('Gesport password recovery');
   
    $mail->setPriority(1);
   
    $mail->addEmbeddedImage(sfConfig::get('sf_web_dir').'/images/gesport_logo.gif', 'CID1', 'Gesport Logo', 'base64', 'image/gif');
   
    $this->mail = $mail;
   
    $this->nickname = $this->getRequest()->getAttribute('nickname');
    $this->password = $this->getRequest()->getAttribute('password');
  }
  
  /**
   * Send a mail to an user tha the admin or coach had created
   *
   */
  public function executeCreateUser()
  {
    $mail = new sfMail();
    $mail->addAddress($this->getRequestParameter('email'));
    $mail->setFrom('Gesport <'.sfConfig::get('app_mail_admin').'>');
    $mail->setSubject('Gesport created user');
   
    $mail->setPriority(1);
   
    $mail->addEmbeddedImage(sfConfig::get('sf_web_dir').'/images/gesport_logo.gif', 'CID1', 'Gesport Logo', 'base64', 'image/gif');
    $this->mail = $mail;
      
    $this->nickname = $this->getRequest()->getAttribute('nickname');
    $this->name = $this->getRequest()->getAttribute('name');
    $this->password = $this->getRequest()->getAttribute('password');
  }
  
  /**
   * Send mail to the admin to advise of a new user apply
   *
   */
  public function executeApplyNewUser()
  {
    $mail = new sfMail();
    $mail->addAddress(sfConfig::get('app_mail_admin'));
    $mail->setFrom('Gesport <'.sfConfig::get('app_mail_admin').'>');
    $mail->setSubject('Apply for a new user');
   
    $mail->setPriority(1);
   
    $mail->addEmbeddedImage(sfConfig::get('sf_web_dir').'/images/gesport_logo.gif', 'CID1', 'Gesport Logo', 'base64', 'image/gif');
   
    $this->mail = $mail;
   
    $this->nickname = $this->getRequest()->getAttribute('nickname');
    $this->name = $this->getRequest()->getAttribute('name');
    $this->lastName = $this->getRequest()->getAttribute('last_name');
    $this->bornAt = $this->getRequest()->getAttribute('born_at');
    $this->email = $this->getRequest()->getAttribute('email');
    $this->role = $this->getRequest()->getAttribute('role');
  }
	  
}
