<?php

/**
 * Menu Actions
 * @package    frontend
 * @subpackage modules-menu
 * @author Diego Cebrián
 */

/**
 * Menu Actions
 * @package    frontend
 * @subpackage modules-menu
 * @author     Diego Cebrián Martínez
 */

class menuComponents extends sfComponents
{
	/**
	 * Show the menu
	 *
	 */
	public function executeMenu()
	{
		$this->menugroups= Array();
		$groupPosition=0;
		$context=$this->getContext();
		if(!$context->getUser()->isAuthenticated()){
			$this->menugroups[$groupPosition]['name']="User";
      $this->menugroups[$groupPosition]['menuitem'][1]['name']='Sign in';
      $this->menugroups[$groupPosition]['menuitem'][1]['target']='@login';
      $this->menugroups[$groupPosition]['menuitem'][1]['param']='';
      $this->menugroups[$groupPosition]['menuitem'][2]['name']='Register';
      $this->menugroups[$groupPosition]['menuitem'][2]['target']='@register';
      $this->menugroups[$groupPosition]['menuitem'][2]['param']='';
			$groupPosition++;
		}else{
			$this->menugroups[$groupPosition]['name']="User";
			$this->menugroups[$groupPosition]['menuitem'][1]['name']='Sign out';
      $this->menugroups[$groupPosition]['menuitem'][1]['target']='@logout';
      $this->menugroups[$groupPosition]['menuitem'][1]['param']='confirm='.__('Are you sure?');
			$this->menugroups[$groupPosition]['menuitem'][2]['name']=__('Data of ').$this->getUser()->getNickname();
			$this->menugroups[$groupPosition]['menuitem'][2]['target']='@user_self';
      $this->menugroups[$groupPosition]['menuitem'][2]['param']='';
			$groupPosition++;
			if($context->getUser()->getIsAdmin()){
        $this->menugroups[$groupPosition]['name']="Administrator";
        $this->menugroups[$groupPosition]['menuitem'][1]['name']='Units';
        $this->menugroups[$groupPosition]['menuitem'][1]['target']='@unit';
        $this->menugroups[$groupPosition]['menuitem'][1]['param']='';
        $this->menugroups[$groupPosition]['menuitem'][2]['name']='Units type';
        $this->menugroups[$groupPosition]['menuitem'][2]['target']='@unit_type';
        $this->menugroups[$groupPosition]['menuitem'][2]['param']='';
        $this->menugroups[$groupPosition]['menuitem'][3]['name']='Units conversion factor';
        $this->menugroups[$groupPosition]['menuitem'][3]['target']='@conversion';
        $this->menugroups[$groupPosition]['menuitem'][3]['param']='';
        $this->menugroups[$groupPosition]['menuitem'][4]['name']='Users';
        $this->menugroups[$groupPosition]['menuitem'][4]['target']='@users?page=1';
        $this->menugroups[$groupPosition]['menuitem'][4]['param']='';
				$groupPosition++;
			}
			if($context->getUser()->getIsCoach()){
				$this->menugroups[$groupPosition]['name']="Coach";
        $this->menugroups[$groupPosition]['menuitem'][1]['name']='Athlets';
        $this->menugroups[$groupPosition]['menuitem'][1]['target']='@athletes';
        $this->menugroups[$groupPosition]['menuitem'][1]['param']='';
				$groupPosition++;
			}
			if($context->getUser()->getIsAthlete()){
				$this->menugroups[$groupPosition]['name']="Athlet";
        $this->menugroups[$groupPosition]['menuitem'][1]['name']='View my training day';
        $this->menugroups[$groupPosition]['menuitem'][1]['target']='@session_athlete';
        $this->menugroups[$groupPosition]['menuitem'][1]['param']='';
        $this->menugroups[$groupPosition]['menuitem'][2]['name']='Report feedback';
        $this->menugroups[$groupPosition]['menuitem'][2]['target']='@sessions_not_reported';
        $this->menugroups[$groupPosition]['menuitem'][2]['param']='';
				$groupPosition++;
			}
		}
		$this->menugroups[$groupPosition]['name']="About Gesport";
    $this->menugroups[$groupPosition]['menuitem'][1]['name']='About';
    $this->menugroups[$groupPosition]['menuitem'][1]['target']='@enter';
    $this->menugroups[$groupPosition]['menuitem'][1]['param']='';
    $this->menugroups[$groupPosition]['menuitem'][2]['name']='Report an error';
    $this->menugroups[$groupPosition]['menuitem'][2]['target']='https://forja.rediris.es/forum/forum.php?forum_id=1655';
    $this->menugroups[$groupPosition]['menuitem'][2]['param']='target=\'_blank\'';
    $this->menugroups[$groupPosition]['menuitem'][3]['name']='Make a suggestion';
    $this->menugroups[$groupPosition]['menuitem'][3]['target']='https://forja.rediris.es/forum/forum.php?forum_id=1654';
    $this->menugroups[$groupPosition]['menuitem'][3]['param']='target=\'_blank\'';
		$groupPosition++;
		$this->menugroups[$groupPosition]['name']="Concurso Universitario de Software Libre";
		$this->menugroups[$groupPosition]['menuitem'][1]['name']='Portada';
		$this->menugroups[$groupPosition]['menuitem'][1]['target']='http://www.concursosoftwarelibre.org/';
    $this->menugroups[$groupPosition]['menuitem'][1]['param']='target=\'_blank\'';
		$groupPosition++;
		$this->menugroups[$groupPosition]['name']="Diego Cebrián";
    $this->menugroups[$groupPosition]['menuitem'][1]['name']='Developing Gesport';
    $this->menugroups[$groupPosition]['menuitem'][1]['target']='http://gesport-blog.serincas.com';
    $this->menugroups[$groupPosition]['menuitem'][1]['param']='target=\'_blank\'';
    $this->menugroups[$groupPosition]['menuitem'][2]['name']='Serincas';
    $this->menugroups[$groupPosition]['menuitem'][2]['target']='http://serincas.com';
    $this->menugroups[$groupPosition]['menuitem'][2]['param']='target=\'_blank\'';
	}
}
