<?php
// auto-generated by sfPropelCrud
// date: 2008/10/21 00:24:55

/**
 * Mesocycle Actions for page layout
 * @package    frontend
 * @subpackage modules-mesocycle
 * @author Diego Cebrián
 */

/**
 * Mesocycle actions for page layout
 *
 * @package    frontend
 * @subpackage modules-mesocycle
 * @author     Diego Cebrián Martínez
 */
class mesocycleActions extends sfActions
{
  /**
   * Default action of mesocycle, it returns the list
   *
   * @return unknown
   */
  public function executeIndex()
  {
    return $this->forward('mesocycle', 'list');
  }


  /**
   * List of all mesocycles
   *
   */
  public function executeList()
  {
    $this->mesocycles = MesocyclePeer::doSelect(new Criteria());
  }


  /**
   * Show the the mesocycle of the current date for the current user
   *
   */
  public function executeShowCurrent()
  {
    $this->period = MesocyclePeer::retrieveCurrentByUserId($this->getRequestParameter('user_id'));
    $this->forward404Unless($this->period);
    $this->microcycle = MicrocyclePeer::retrieveCurrentByUserId($this->getRequestParameter('user_id'));
    $this->user = $this->period->getMacrocycle()->getSeason()->getUser();
    $this->forward404Unless($this->user);
    $this->forwardIf($this->period->getMacrocycle()->getSeason()->getUser()->getCoachId()!=$this->getUser()->getAttribute('user_id',0 , 'athlete'), 'content', 'notAllowed');
    
    $this->setTemplate('show');
  }


  /**
   * Show a mesocycle
   *
   */
  public function executeShow()
  {
    $this->period = MesocyclePeer::retrieveByUserIdAndPk($this->getRequestParameter('user_id'), $this->getRequestParameter('mesocycle_id')); 
    $this->forward404Unless($this->period);
    $this->microcycle = MicrocyclePeer::retrieveCurrentByUserId($this->getRequestParameter('user_id'));
    $this->user = $this->period->getMacrocycle()->getSeason()->getUser(); 
    $this->forward404Unless($this->user);
    $this->forwardIf($this->period->getMacrocycle()->getSeason()->getUser()->getCoachId()!=$this->getUser()->getAttribute('user_id',0 , 'athlete'), 'content', 'notAllowed');
  }
  
  /**
   * To edit a mesocycle from Coach View
   *
   * @return unknown
   */
  public function executeEdit()
  {
    //Show the form
    if ($this->getRequest()->getMethod() != sfRequest::POST)
    {
      //retrieve data for the form
      $this->period = MesocyclePeer::retrieveByUserIdAndPk($this->getRequestParameter('user_id'), $this->getRequestParameter('mesocycle_id'));
      $this->forward404Unless($this->period);
      $this->user = $this->period->getMacrocycle()->getSeason()->getUser();
      $this->forward404Unless($this->user);
      //access control
      $this->forwardIf($this->period->getMacrocycle()->getSeason()->getUser()->getCoachId()!=$this->getUser()->getAttribute('user_id',0 , 'athlete'), 'content', 'notAllowed');
      
      // display the form
      $this->form_action="mesocycle_edit";
      $this->getRequest()->getParameterHolder()->set('referer', $this->getRequest()->getReferer());
      
      return sfView::SUCCESS;
    }
    //Recover data and update the macrocycle
    else
    {
      $this->period = MesocyclePeer::retrieveByUserIdAndPk($this->getRequestParameter('user_id'), $this->getRequestParameter('mesocycle_id'));
      $this->forward404Unless($this->period);
      $this->user = $this->period->getMacrocycle()->getSeason()->getUser();
      $this->forward404Unless($this->user);
      //access control
      $this->forwardIf($this->period->getMacrocycle()->getSeason()->getUser()->getCoachId()!=$this->getUser()->getAttribute('user_id',0 , 'athlete'), 'content', 'notAllowed');
      
      //update and save
      $mesocycle=$this->update($this->period);
      $mesocycle->save();
      
      //redirect to selected page
      $this->redirect('@macrocycle_show?macrocycle_id='.$this->period->getMacrocycleId().'&user_id='.$this->user->getId());
    }
  }  
  /**
   * When an error in editing from Coach View occurs it returns to the edit form
   *
   * @return unknown
   */
 
  
  public function handleErrorEdit()
  {
    $this->period = MesocyclePeer::retrieveByUserIdAndPk($this->getRequestParameter('user_id'), $this->getRequestParameter('mesocycle_id'));
    $this->forward404Unless($this->period);
    $this->user = $this->period->getMacrocycle()->getSeason()->getUser();
    $this->forward404Unless($this->user);
    //access control
    $this->forwardIf($this->period->getMacrocycle()->getSeason()->getUser()->getCoachId()!=$this->getUser()->getAttribute('user_id',0 , 'athlete'), 'content', 'notAllowed');
    
    $this->period->setDescription($this->getRequestParameter('description'));
    $this->period->setMacrocycleId($this->getRequestParameter('macrocycle_id') ? $this->getRequestParameter('macrocycle_id') : null);
    $this->period->setTheoricIntensity1($this->getRequestParameter('theoric_intensity1'));
    $this->period->setTheoricIntensity2($this->getRequestParameter('theoric_intensity2'));
    $this->period->setTheoricIntensity3($this->getRequestParameter('theoric_intensity3'));
    $this->period->setTheoricVolume($this->getRequestParameter('theoric_volume'));
    return sfView::SUCCESS;
  }

  /**
   * Action for delete a mesocycle
   *
   * @return unknown
   */

  public function executeDelete()
  {
    $this->period = MesocyclePeer::retrieveByUserIdAndPk($this->getRequestParameter('user_id'), $this->getRequestParameter('mesocycle_id'));
    $this->forward404Unless($this->period);
    $this->user = $this->period->getMacrocycle()->getSeason()->getUser();
    $this->forward404Unless($this->user);
    //access control
    $this->forwardIf($this->period->getMacrocycle()->getSeason()->getUser()->getCoachId()!=$this->getUser()->getAttribute('user_id',0 , 'athlete'), 'content', 'notAllowed');
    try {
      $this->period->delete();
      return $this->redirect('@macrocycle_show?macrocycle_id='.$this->period->getMacrocycleId().'&user_id='.$this->user->getId());
    }
    //if the mesocycle is used in other class, advert that can't be deleted
    catch (PropelException $e){
      $this->message = ' is still used in Gesport and can not be deleted.';
      $this->setTemplate('notDeleted');  
    }
    catch (Exception $e){
      $this->message = ' cannot be deleted.';
      $this->setTemplate('notDeleted');  
    }
  }  
  
  /**
   * Create a mesocycle form Coach View
   *
   * @return unknown
   */
  public function executeAdd()
  {
    //Show the form
    if ($this->getRequest()->getMethod() != sfRequest::POST)
    {
      $this->user = UserPeer::retrieveByPk($this->getRequestParameter('user_id'));
      $this->forward404Unless($this->user);
      $this->macrocycle = MacrocyclePeer::retrieveByUserIdAndPk($this->getRequestParameter('user_id'), $this->getRequestParameter('macrocycle_id'));
      $this->forward404Unless($this->macrocycle);
      $this->period = new Mesocycle();
      $this->forward404Unless($this->period);
      $this->period->setMacrocycle($this->macrocycle);
      
      $this->forwardIf($this->user->getCoachId()!=$this->getUser()->getAttribute('user_id',0 , 'athlete'), 'content', 'notAllowed');
      // display the form
      $this->form_action="mesocycle_add";
      $this->getRequest()->getParameterHolder()->set('referer', $this->getRequest()->getReferer());

      return sfView::SUCCESS;
    }
    //Recover data and create the macrocycle
    else
    {
      // handle the form submission
      
      $this->user = UserPeer::retrieveByPk($this->getRequestParameter('user_id'));
      $this->forward404Unless($this->user);
      $this->macrocycle = MacrocyclePeer::retrieveByUserIdAndPk($this->getRequestParameter('user_id'), $this->getRequestParameter('macrocycle_id'));
      $this->forward404Unless($this->macrocycle);
      $this->period = new Mesocycle();
      $this->forward404Unless($this->period); 
      $this->period->setMacrocycle($this->macrocycle);
      $mesocycle=$this->update($this->period);
        
      $mesocycle->save();
      
      // redirect to the page of the user
      return $this->redirect('@macrocycle_show?macrocycle_id='.$this->macrocycle->getId().'&user_id='.$this->user->getId());
    }
  }
    
  /**
   * When an error in adding from Coach View occurs it returns to the add form
   *
   * @return unknown
   */
  
  public function handleErrorAdd()
  {
    $this->user = UserPeer::retrieveByPk($this->getRequestParameter('user_id'));
    $this->forward404Unless($this->user);
    $this->macrocycle = MacrocyclePeer::retrieveByUserIdAndPk($this->getRequestParameter('user_id'), $this->getRequestParameter('macrocycle_id'));
    $this->forward404Unless($this->macrocycle);
    $this->period = new Mesocycle();
    $this->forward404Unless($this->period); 
    $this->period->setMacrocycle($this->macrocycle);
    $this->period->setDescription($this->getRequestParameter('description'));
    $this->period->setMacrocycleId($this->getRequestParameter('macrocycle_id') ? $this->getRequestParameter('macrocycle_id') : null);
    $this->period->setTheoricIntensity1($this->getRequestParameter('theoric_intensity1'));
    $this->period->setTheoricIntensity2($this->getRequestParameter('theoric_intensity2'));
    $this->period->setTheoricIntensity3($this->getRequestParameter('theoric_intensity3'));
    $this->period->setTheoricVolume($this->getRequestParameter('theoric_volume'));
    return sfView::SUCCESS;
  }

  /**
   * Action to show all mesocycles of a macrocycle
   *
   */
  public function executeMacrocycle()
  {
  	$this->macrocycle= MacrocyclePeer::retrieveByPK($this->getRequestParameter('macrocycle_id'));
    $c=new Criteria();
    $c->add(MesocyclePeer::MACROCYCLE_ID, $this->getRequestParameter('macrocycle_id'));
    $c->addJoin(MesocyclePeer::MACROCYCLE_ID, MacrocyclePeer::ID);
    $this->mesocycles = MesocyclePeer::doSelect($c);
    $this->forward404Unless($this->mesocycles);
    $this->user =  UserPeer::retrieveByPk($this->getRequestParameter('user_id'));
    $this->forward404Unless($this->user);
    $this->forwardIf($this->user->getCoachId()!=$this->getUser()->getAttribute('user_id',0 , 'athlete'), 'content', 'notAllowed');
    
  }


  /**
   * Action to update the mesocycle data with the fields of the form
   *
   * @param Mesocycle $mesocycle
   * @return Mesocycle
   */
  public function update($mesocycle)
  {
    $mesocycle->setDescription($this->getRequestParameter('description'));
    if ($this->getRequestParameter('start_at'))
    {
      list($d, $m, $y) = sfI18N::getDateForCulture($this->getRequestParameter('start_at'), $this->getUser()->getCulture());
      $mesocycle->setStartAt("$y-$m-$d");
    }
    if ($this->getRequestParameter('last_day_at'))
    {
      list($d, $m, $y) = sfI18N::getDateForCulture($this->getRequestParameter('last_day_at'), $this->getUser()->getCulture());
      $mesocycle->setLastDayAt("$y-$m-$d");
    }
    $mesocycle->setMacrocycleId($this->getRequestParameter('macrocycle_id') ? $this->getRequestParameter('macrocycle_id') : null);
    $mesocycle->setTheoricIntensity1($this->getRequestParameter('theoric_intensity1'));
    $mesocycle->setTheoricIntensity2($this->getRequestParameter('theoric_intensity2'));
    $mesocycle->setTheoricIntensity3($this->getRequestParameter('theoric_intensity3'));
    $mesocycle->setTheoricVolume($this->getRequestParameter('theoric_volume'));

    return $mesocycle;
  }
}
