<?php
// auto-generated by sfPropelCrud
// date: 2008/10/21 00:24:55

/**
 * Microcycle Actions for page layout
 * @package    frontend
 * @subpackage modules-microcycle
 * @author Diego Cebrián
 */

/**
 * Microcycle actions for page layout
 *
 * @package    frontend
 * @subpackage modules-microcycle
 * @author     Diego Cebrián Martínez
 */
class microcycleActions extends sfActions
{
  /**
   * Default action of microcycle, it returns the list
   *
   * @return unknown
   */
  public function executeIndex()
  {
    return $this->forward('microcycle', 'list');
  }


  /**
   * List of all microcycles
   *
   */
  public function executeList()
  {
    $this->microcycles = MicrocyclePeer::doSelect(new Criteria());
  }
  
  /**
   * Show the the microcycle of the current date for the current user
   *
   */

  public function executeShowCurrent()
  {
    $this->period = MicrocyclePeer::retrieveCurrentByUserId($this->getRequestParameter('user_id'));
    $this->forward404Unless($this->period);
    $this->session = SessionPeer::retrieveCurrentByUserId($this->getRequestParameter('user_id'));
    $this->user = $this->period->getMesocycle()->getMacrocycle()->getSeason()->getUser();
    $this->forward404Unless($this->user);
    $this->forwardIf($this->period->getMesocycle()->getMacrocycle()->getSeason()->getUser()->getCoachId()!=$this->getUser()->getAttribute('user_id',0 , 'athlete'), 'content', 'notAllowed');
    
    $this->setTemplate('show');
  }

  /**
   * Show a microcycle
   *
   */

  public function executeShow()
  {
    $this->period = MicrocyclePeer::retrieveByUserIdAndPk($this->getRequestParameter('user_id'), $this->getRequestParameter('microcycle_id')); 
    $this->forward404Unless($this->period);
    $this->user = $this->period->getMesocycle()->getMacrocycle()->getSeason()->getUser(); 
    $this->forward404Unless($this->user);
    $this->forwardIf($this->period->getMesocycle()->getMacrocycle()->getSeason()->getUser()->getCoachId()!=$this->getUser()->getAttribute('user_id',0 , 'athlete'), 'content', 'notAllowed');
  }
  
  /**
   * To edit a microcycle from Coach View
   *
   * @return unknown
   */
  public function executeEdit()
  {
    //Show the form
    if ($this->getRequest()->getMethod() != sfRequest::POST)
    {
      //retrieve data for the form
      $this->period = MicrocyclePeer::retrieveByUserIdAndPk($this->getRequestParameter('user_id'), $this->getRequestParameter('microcycle_id'));
      $this->forward404Unless($this->period);
      $this->user = $this->period->getMesocycle()->getMacrocycle()->getSeason()->getUser();
      $this->forward404Unless($this->user);
      $this->mesocycle = $this->period->getMesocycle();
      $this->forward404Unless($this->mesocycle);
      //access control
      $this->forwardIf($this->period->getMesocycle()->getMacrocycle()->getSeason()->getUser()->getCoachId()!=$this->getUser()->getAttribute('user_id',0 , 'athlete'), 'content', 'notAllowed');
      
      // display the form
      $this->form_action="microcycle_edit";
      $this->getRequest()->getParameterHolder()->set('referer', $this->getRequest()->getReferer());
      
      return sfView::SUCCESS;
    }
    //Recover data and update the mesocycle
    else
    {
      $this->period = MicrocyclePeer::retrieveByUserIdAndPk($this->getRequestParameter('user_id'), $this->getRequestParameter('microcycle_id'));
      $this->forward404Unless($this->period);
      $this->user = $this->period->getMesocycle()->getMacrocycle()->getSeason()->getUser();
      $this->forward404Unless($this->user);
      $this->mesocycle = $this->period->getMesocycle();
      $this->forward404Unless($this->mesocycle);
      //access control
      $this->forwardIf($this->period->getMesocycle()->getMacrocycle()->getSeason()->getUser()->getCoachId()!=$this->getUser()->getAttribute('user_id',0 , 'athlete'), 'content', 'notAllowed');
      
      //update and save
      $microcycle=$this->update($this->period);
      $microcycle->save();
      
      //redirect to selected page
      $this->redirect('@mesocycle_show?mesocycle_id='.$this->period->getMesocycleId().'&user_id='.$this->user->getId());
    }
  }
  
  /**
   * When an error in editing from Coach View occurs it returns to the edit form
   *
   * @return unknown
   */
  
  public function handleErrorEdit()
  {
    $this->period = MicrocyclePeer::retrieveByUserIdAndPk($this->getRequestParameter('user_id'), $this->getRequestParameter('microcycle_id'));
    $this->forward404Unless($this->period);
    $this->user = $this->period->getMesocycle()->getMacrocycle()->getSeason()->getUser();
    $this->forward404Unless($this->user);
    $this->mesocycle = $this->period->getMesocycle();
    $this->forward404Unless($this->mesocycle);
    //access control
    $this->forwardIf($this->period->getMesocycle()->getMacrocycle()->getSeason()->getUser()->getCoachId()!=$this->getUser()->getAttribute('user_id',0 , 'athlete'), 'content', 'notAllowed');
    
    $this->period->setDescription($this->getRequestParameter('description'));
    $this->period->setMesocycleId($this->getRequestParameter('mesocycle_id') ? $this->getRequestParameter('mesocycle_id') : null);
    $this->period->setTheoricIntensity1($this->getRequestParameter('theoric_intensity1'));
    $this->period->setTheoricIntensity2($this->getRequestParameter('theoric_intensity2'));
    $this->period->setTheoricIntensity3($this->getRequestParameter('theoric_intensity3'));
    $this->period->setTheoricVolume($this->getRequestParameter('theoric_volume'));
    return sfView::SUCCESS;
  }
  /**
   * Action for delete a microcycle
   *
   * @return unknown
   */

  public function executeDelete()
  {
    $this->period = MicrocyclePeer::retrieveByUserIdAndPk($this->getRequestParameter('user_id'), $this->getRequestParameter('microcycle_id'));
    $this->forward404Unless($this->period);
    $this->user = $this->period->getMesocycle()->getMacrocycle()->getSeason()->getUser();
    $this->forward404Unless($this->user);
    //access control
    $this->forwardIf($this->period->getMesocycle()->getMacrocycle()->getSeason()->getUser()->getCoachId()!=$this->getUser()->getAttribute('user_id',0 , 'athlete'), 'content', 'notAllowed');
    try {
      $this->period->delete();
      return $this->redirect('@mesocycle_show?mesocycle_id='.$this->period->getMesocycleId().'&user_id='.$this->user->getId());
    }
    //if the microcycle is used in other class, advert that can't be deleted
    catch (PropelException $e){
      $this->message = ' is still used in Gesport and can not be deleted.';
      $this->setTemplate('notDeleted');  
    }
    catch (Exception $e){
      $this->message = ' cannot be deleted.';
      $this->setTemplate('notDeleted');  
    }
  }  
  

  
  /**
   * Create a microcycle form Coach View
   *
   * @return unknown
   */
  public function executeAdd()
  {
    //Show the form
    if ($this->getRequest()->getMethod() != sfRequest::POST)
    {
      $this->user = UserPeer::retrieveByPk($this->getRequestParameter('user_id'));
      $this->forward404Unless($this->user);
      $this->mesocycle = MesocyclePeer::retrieveByUserIdAndPk($this->getRequestParameter('user_id'), $this->getRequestParameter('mesocycle_id'));
      $this->forward404Unless($this->mesocycle);
      $this->period = new Microcycle();
      $this->forward404Unless($this->period);
      $this->period->setMesocycle($this->mesocycle);
      
      $this->forwardIf($this->user->getCoachId()!=$this->getUser()->getAttribute('user_id',0 , 'athlete'), 'content', 'notAllowed');
      // display the form
      $this->form_action="microcycle_add";
      $this->getRequest()->getParameterHolder()->set('referer', $this->getRequest()->getReferer());

      return sfView::SUCCESS;
    }
    //Recover data and create the mesocycle
    else
    {
      // handle the form submission
      
      $this->user = UserPeer::retrieveByPk($this->getRequestParameter('user_id'));
      $this->forward404Unless($this->user);
      $this->mesocycle = MesocyclePeer::retrieveByUserIdAndPk($this->getRequestParameter('user_id'), $this->getRequestParameter('mesocycle_id'));
      $this->forward404Unless($this->mesocycle);
      $this->period = new Microcycle();
      $this->forward404Unless($this->period); 
      $this->period->setMesocycle($this->mesocycle);
      $microcycle=$this->update($this->period);
        
      $microcycle->saveAndCreate();
      
      // redirect to the page of the user
      return $this->redirect('@mesocycle_show?mesocycle_id='.$this->mesocycle->getId().'&user_id='.$this->user->getId());
    }
  }
    
  /**
   * When an error in adding from Coach View occurs it returns to the add form
   *
   * @return unknown
   */
  
  public function handleErrorAdd()
  {
    $this->user = UserPeer::retrieveByPk($this->getRequestParameter('user_id'));
    $this->forward404Unless($this->user);
    $this->mesocycle = MesocyclePeer::retrieveByUserIdAndPk($this->getRequestParameter('user_id'), $this->getRequestParameter('mesocycle_id'));
    $this->forward404Unless($this->mesocycle);
    $this->period = new Microcycle();
    $this->forward404Unless($this->period);
    $this->period->setMesocycle($this->mesocycle); 
    $this->period->setDescription($this->getRequestParameter('description'));
    $this->period->setMesocycleId($this->getRequestParameter('mesocycle_id') ? $this->getRequestParameter('mesocycle_id') : null);
    $this->period->setTheoricIntensity1($this->getRequestParameter('theoric_intensity1'));
    $this->period->setTheoricIntensity2($this->getRequestParameter('theoric_intensity2'));
    $this->period->setTheoricIntensity3($this->getRequestParameter('theoric_intensity3'));
    $this->period->setTheoricVolume($this->getRequestParameter('theoric_volume'));
    return sfView::SUCCESS;
  }
  
  /**
   * Action to show all microcycles of a mesocycle
   *
   */

  public function executeMesocycle()
  {
  	$this->mesocycle= MesocyclePeer::retrieveByPK($this->getRequestParameter('mesocycle_id'));
    $c=new Criteria();
    $c->add(MicrocyclePeer::MESOCYCLE_ID, $this->getRequestParameter('mesocycle_id'));
    $c->addJoin(MicrocyclePeer::MESOCYCLE_ID, MesocyclePeer::ID);
    $this->microcycles = MicrocyclePeer::doSelect($c);
    $this->forward404Unless($this->microcycles);
    $this->user =  UserPeer::retrieveByPk($this->getRequestParameter('user_id'));
    $this->forward404Unless($this->user);
    $this->forwardIf($this->user->getCoachId()!=$this->getUser()->getAttribute('user_id',0 , 'athlete'), 'content', 'notAllowed');
    
  }


  /**
   * Action to update the microcycle data with the fields of the form
   *
   * @param Microcycle $microcycle
   * @return Microcycle
   */
  public function update($microcycle)
  {
    $microcycle->setDescription($this->getRequestParameter('description'));
    if ($this->getRequestParameter('start_at'))
    {
      list($d, $m, $y) = sfI18N::getDateForCulture($this->getRequestParameter('start_at'), $this->getUser()->getCulture());
      $microcycle->setStartAt("$y-$m-$d");
    }
    if ($this->getRequestParameter('last_day_at'))
    {
      list($d, $m, $y) = sfI18N::getDateForCulture($this->getRequestParameter('last_day_at'), $this->getUser()->getCulture());
      $microcycle->setLastDayAt("$y-$m-$d");
    }
    $microcycle->setMesocycleId($this->getRequestParameter('mesocycle_id') ? $this->getRequestParameter('mesocycle_id') : null);
    $microcycle->setTheoricIntensity1($this->getRequestParameter('theoric_intensity1'));
    $microcycle->setTheoricIntensity2($this->getRequestParameter('theoric_intensity2'));
    $microcycle->setTheoricIntensity3($this->getRequestParameter('theoric_intensity3'));
    $microcycle->setTheoricVolume($this->getRequestParameter('theoric_volume'));

    return $microcycle;
  }
}
