<?php
// auto-generated by sfPropelCrud
// date: 2008/11/25 17:23:50


/**
 * Template to show a form to add a new microcycle to a mesocycle
 * 
 * @author Diego Cebrián
 * @package    frontend
 * @subpackage modules-microcycle-templates
 * @uses User user: the user to add
 * @uses Mesocycle mesocycle: the mesocycle in wich the microcycle is included
 * @uses Microcycle period: the microcycle where the data is put on
 */
?>
<?php use_helper('Object') ?>
<?php use_helper('Validation') ?>
<?php use_helper('Javascript') ?>
<?php
echo javascript_tag('
               function calculate_total(){ 
                document.getElementById("theoric_volume").value = ((parseFloat(document.getElementById("theoric_intensity1").value))+(parseFloat(document.getElementById("theoric_intensity2").value))+(parseFloat(document.getElementById("theoric_intensity3").value)))
               }
               '                 
               )
               ?>
 
<?php slot('header'); ?>
<?php echo image_tag('admin/help', 'alt=help class=error_ico')?>
  <h1 class="help"><?php echo __('Help for').': '.__('Create microcycle') ?></h1>
  <p class="help"><?php echo __('Enter the requested data') ?></p>
  <p class="help"><?php echo __('Emphasided fields are mandatory').': <label class="mandatory">'.__('Mandatory field').'</label>' ?></p>
  <p class="help"><?php echo __('Clicking on the button closed to date field will display a dynamic calendar') ?></p>
  <p class="help"><?php echo __('For manual date editing, please use this format').': '.format_date('1981-06-20') ?></p>
<?php end_slot(); ?>

<h1><?php echo __('Microcycle for').' '.$user.' '.__('for').' '.__('mesocycle').' '.$mesocycle;?></h1>

    <?php 
       include_component('microcycle', 'Mesocycle', array('user_id'=> $user->getId(), 'mesocycle_id' => $mesocycle->getId()));
    ?>
<?php echo form_tag('@microcycle_add?user_id='.$user->getId().'&mesocycle_id='.$mesocycle->getId()) ?>

  <div class="form_row">
    <?php echo __(form_error('mesocycle_id')) ?>
    <div class="form_label_left"><label for="nickname"><?php echo __('Mesocycle')?>:</label></div>
    <div class="form_field_left"><?php echo $mesocycle ?>, <?php echo __('from') ?> <?php echo format_date($mesocycle->getStartAt(), 'D').', '.format_date($mesocycle->getStartAt(), 'EEEE') ?> <?php echo __('to') ?> <?php echo format_date($mesocycle->getStartAt(), 'D').', '.format_date($mesocycle->getStartAt(), 'EEEE') ?></div>
  </div>
  
  <div class="form_row">
    <?php echo __(form_error('description')) ?>
    <div class="form_label_left"><label for="description" class="mandatory"><?php echo __('Description')?>:</label></div>
    <div class="form_field_left"><?php echo object_input_tag($period, 'getDescription', array (
  'size' => 80,
)) ?></div>
  </div>
  <div class="form_row">
    <?php echo __(form_error('start_at')) ?>
    <div class="form_label_left"><label for="start_at" class="mandatory"><?php echo __('Start at')?>:</label></div>
    <div class="form_field_left"><?php echo object_input_date_tag($period, 'getStartAt', array (
  'rich' => true,
)) ?></div>
  </div>
  <div class="form_row">
    <?php echo __(form_error('last_day_at')) ?>
    <div class="form_label_left"><label for="last_day_at" class="mandatory"><?php echo __('Last day at')?>:</label></div>
    <div class="form_field_left"><?php echo object_input_date_tag($period, 'getLastDayAt', array (
  'rich' => true,
)) ?></div>
  </div> 
  
  <div class="form_row">
    <?php echo __(form_error('theoric_intensity')) ?>
    <div class="form_label_left"><label for="theoric_intensity"><?php echo __('Theoric intensity')?>:</label></div>
    <div class="form_field_left">
        <table>
          <tr>
            <td>
              <?php echo $period->getIntensity1LowLimit().'-'.$period->getIntensity1HighLimit().' %'; ?>
            </td>
            <td>
              <?php echo object_input_tag($period, 'getTheoricIntensity1', array (
            'size' => 7, 'onChange' => 'calculate_total()',
            )).' '.$period->getVolumeUnit(); ?>
            </td>
          </tr>
          <tr>
            <td>
              <?php echo $period->getIntensity2LowLimit().'-'.$period->getIntensity2HighLimit().' %'; ?>
            </td>
            <td>
              <?php echo object_input_tag($period, 'getTheoricIntensity2', array (
            'size' => 7, 'onChange' => 'calculate_total()',
            )).' '.$period->getVolumeUnit(); ?>
            </td>
          </tr>
          <tr>
            <td>
              <?php echo $period->getIntensity3LowLimit().'-'.$period->getIntensity3HighLimit().' %'; ?>
            </td>
            <td>
              <?php echo object_input_tag($period, 'getTheoricIntensity3', array (
            'size' => 7, 'onChange' => 'calculate_total()',
            )).' '.$period->getVolumeUnit(); ?>
            </td>
          </tr>
        </table>
    </div>

  </div>
  <div class="form_row">
    <?php echo __(form_error('theoric_volume')) ?>
    <div class="form_label_left"><label for="theoric_volume"><?php echo __('Theoric volume')?>:</label></div>
    <div class="form_field_left"><?php echo object_input_tag($period, 'getTheoricVolume', array (
  'size' => 7,'readonly'=>'readonly'
)) ?></div>
  </div>
<hr />
<?php echo submit_tag(__('Save')) ?>
&nbsp;<?php echo link_to(__('Cancel'), '@mesocycle_show?user_id='.$user->getId().'&mesocycle_id='.$mesocycle->getId()) ?>
</form>
