<?php
// auto-generated by sfPropelCrud
// date: 2008/11/25 17:23:50

/**
 * Season Actions for page layout
 * @package    frontend
 * @subpackage modules-season
 * @author Diego Cebrián
 */

/**
 * Season actions for page layout
 *
 * @package    frontend
 * @subpackage modules-season
 * @author     Diego Cebrián Martínez
 */
class seasonActions extends sfActions
{
  /**
   * Default action of season, it returns the list
   *
   * @return unknown
   */
  public function executeIndex()
  {
    return $this->forward('season', 'list');
  }


  /**
   * List of all season
   *
   */
  public function executeList()
  {
    $this->seasons = SeasonPeer::doSelect(new Criteria());
  }
  /**
   * Show the the microcycle of the current date for the current user
   *
   */

  public function executeShowCurrent()
  {
    $this->period = SeasonPeer::retrieveCurrentByUserId($this->getRequestParameter('user_id'));
    $this->forward404Unless($this->period);
    $this->macrocycle = MacrocyclePeer::retrieveCurrentByUserId($this->getRequestParameter('user_id'));
    $this->user = $this->period->getUser();
    $this->forward404Unless($this->user);
    $this->forwardIf($this->period->getUser()->getCoachId()!=$this->getUser()->getAttribute('user_id',0 , 'athlete'), 'content', 'notAllowed');
    
    $this->setTemplate('show');
  }

  /**
   * Show a season
   *
   */

  public function executeShow()
  {
    $this->period = SeasonPeer::retrieveByUserIdAndPk($this->getRequestParameter('user_id'), $this->getRequestParameter('season_id')); 
    $this->forward404Unless($this->period);
    $this->macrocycle = MacrocyclePeer::retrieveCurrentByUserId($this->getRequestParameter('user_id'));
    $this->user = $this->period->getUser(); 
    $this->forward404Unless($this->user);
    $this->forwardIf($this->period->getUser()->getCoachId()!=$this->getUser()->getAttribute('user_id',0 , 'athlete'), 'content', 'notAllowed');
  }
  
  /**
   * To edit a season from Coach View
   *
   * @return unknown
   */
  public function executeEdit()
  {
    //Show the form
    if ($this->getRequest()->getMethod() != sfRequest::POST)
    {
    	//retrieve data for the form
	    $this->period = SeasonPeer::retrieveByUserIdAndPk($this->getRequestParameter('user_id'), $this->getRequestParameter('season_id'));
	    $this->forward404Unless($this->period);
	    $this->user = $this->period->getUser();
      $this->forward404Unless($this->user);
      //access control
	    $this->forwardIf($this->period->getUser()->getCoachId()!=$this->getUser()->getAttribute('user_id',0 , 'athlete'), 'content', 'notAllowed');
	    
      // display the form
      
			$directorioPrototype = sfConfig::get('sf_prototype_web_dir');
			$this->getResponse()->addJavascript($directorioPrototype.'/js/prototype');
      $this->form_action="season_edit";
      $this->getRequest()->getParameterHolder()->set('referer', $this->getRequest()->getReferer());
      
	    return sfView::SUCCESS;
    }
    //Recover data and update the season
    else
    {
      $this->period = SeasonPeer::retrieveByUserIdAndPk($this->getRequestParameter('user_id'), $this->getRequestParameter('season_id'));
      $this->forward404Unless($this->period);
      $this->user = $this->period->getUser();
      $this->forward404Unless($this->user);
      //access control
      $this->forwardIf($this->period->getUser()->getCoachId()!=$this->getUser()->getAttribute('user_id',0 , 'athlete'), 'content', 'notAllowed');
      
      //update and save
      $season=$this->update($this->period);
      $season->save();
      
      //redirect to selected page
      $this->redirect('@athlete_show?id='.$this->user->getId().'&season='.$season->getId());
    }
  }
  
  /**
   * When an error in editing from Coach View occurs it returns to the edit form
   *
   * @return unknown
   */
  
  public function handleErrorEdit()
  {
    
  	$this->period = SeasonPeer::retrieveByUserIdAndPk($this->getRequestParameter('user_id'), $this->getRequestParameter('season_id'));
  	$this->forward404Unless($this->period);
  	$this->user = $this->period->getUser();
  	$this->forward404Unless($this->user);
  	//access control
  	$this->forwardIf($this->period->getUser()->getCoachId()!=$this->getUser()->getAttribute('user_id',0 , 'athlete'), 'content', 'notAllowed');
    $this->period->setDescription($this->getRequestParameter('description'));
    $this->period->setUserId($this->getRequestParameter('user_id') ? $this->getRequestParameter('user_id') : null);
    $this->period->setTheoricIntensity1($this->getRequestParameter('theoric_intensity1'));
    $this->period->setTheoricIntensity2($this->getRequestParameter('theoric_intensity2'));
    $this->period->setTheoricIntensity3($this->getRequestParameter('theoric_intensity3'));
    $this->period->setIntensity1LowLimit($this->getRequestParameter('intensity1_low_limit'));
    $this->period->setIntensity1HighLimit($this->getRequestParameter('intensity1_high_limit'));
    $this->period->setIntensity2HighLimit($this->getRequestParameter('intensity2_high_limit'));
    $this->period->setIntensity3HighLimit($this->getRequestParameter('intensity3_high_limit'));
    $this->period->setVolumeUnitId($this->getRequestParameter('volume_unit_id'));
    $this->period->setTheoricVolume($this->getRequestParameter('theoric_volume'));
    return sfView::SUCCESS;
  }
  /**
   * Action for delete a season
   *
   * @return unknown
   */

  public function executeDelete()
  {

    $this->period = SeasonPeer::retrieveByUserIdAndPk($this->getRequestParameter('user_id'), $this->getRequestParameter('season_id'));
    $this->forward404Unless($this->period);
    $this->user = $this->period->getUser();
    $this->forward404Unless($this->user);
    //access control
    $this->forwardIf($this->period->getUser()->getCoachId()!=$this->getUser()->getAttribute('user_id',0 , 'athlete'), 'content', 'notAllowed');
    
    try{
	    $this->period->delete();
	    return $this->redirect('@athlete_show?id='.$this->user->getId());
    }
    //if the user is used in other class, advert that can't be deleted
    catch (PropelException $e){
      $this->macrocycle = MacrocyclePeer::retrieveCurrentByUserId($this->getRequestParameter('user_id'));
      $this->message = ' is still used in Gesport and can not be deleted.';
      $this->setTemplate('notDeleted');  
    }
    catch (Exception $e){
      $this->macrocycle = MacrocyclePeer::retrieveCurrentByUserId($this->getRequestParameter('user_id'));
      $this->message = ' cannot be deleted.';
      $this->setTemplate('notDeleted'); 
    }
  }  
  
  /**
   * Create a season form Coach View
   *
   * @return unknown
   */
  public function executeAdd()
  {
    //Show the form
    if ($this->getRequest()->getMethod() != sfRequest::POST)
    {
      $this->user = UserPeer::retrieveByPk($this->getRequestParameter('user_id'));
      $this->forward404Unless($this->user);
      $this->period = new Season();
      $this->forward404Unless($this->period);
      
      $this->forwardIf($this->user->getCoachId()!=$this->getUser()->getAttribute('user_id',0 , 'athlete'), 'content', 'notAllowed');
      // display the form
      $this->form_action="season_add";
      $this->getRequest()->getParameterHolder()->set('referer', $this->getRequest()->getReferer());

      return sfView::SUCCESS;
    }
    //Recover data and create the season
    else
    {
      // handle the form submission
      $this->user = UserPeer::retrieveByPk($this->getRequestParameter('user_id'));
      $this->forward404Unless($this->user);
      $this->forwardIf($this->user->getCoachId()!=$this->getUser()->getAttribute('user_id',0 , 'athlete'), 'content', 'notAllowed');
      $this->period = new Season();
      $this->forward404Unless($this->period);   
      $season=$this->update($this->period);
        
      $season->save();
      
      // redirect to the page of the user
      return $this->redirect('@athlete_show?id='.$this->user->getId().'&season='.$season->getId());
    }
  }
  
    
  /**
   * When an error in adding from Coach View occurs it returns to the add form
   *
   * @return unknown
   */
  public function handleErrorAdd()
  {
    $this->user =  UserPeer::retrieveByPk($this->getRequestParameter('user_id'));
    $this->period = new Season();
    $this->forward404Unless($this->user);
    $this->forwardIf($this->user->getCoachId()!=$this->getUser()->getAttribute('user_id',0 , 'athlete'), 'content', 'notAllowed');
    $this->forward404Unless($this->period);
    $this->period->setDescription($this->getRequestParameter('description'));
    $this->period->setUserId($this->getRequestParameter('user_id') ? $this->getRequestParameter('user_id') : null);
    $this->period->setTheoricIntensity1($this->getRequestParameter('theoric_intensity1'));
    $this->period->setTheoricIntensity2($this->getRequestParameter('theoric_intensity2'));
    $this->period->setTheoricIntensity3($this->getRequestParameter('theoric_intensity3'));
    $this->period->setIntensity1LowLimit($this->getRequestParameter('intensity1_low_limit'));
    $this->period->setIntensity1HighLimit($this->getRequestParameter('intensity1_high_limit'));
    $this->period->setIntensity2HighLimit($this->getRequestParameter('intensity2_high_limit'));
    $this->period->setIntensity3HighLimit($this->getRequestParameter('intensity3_high_limit'));
    $this->period->setVolumeUnitId($this->getRequestParameter('volume_unit_id'));
    $this->period->setTheoricVolume($this->getRequestParameter('theoric_volume'));
    return sfView::SUCCESS;
  }
  /**
   * Action to show all seasons of an athlete
   *
   */

  public function executeMyAthlete()
  {
    $c=new Criteria();
    $c->add(SeasonPeer::USER_ID, $this->getRequestParameter('user_id'));
    $this->seasons = SeasonPeer::doSelect($c);
    $this->user =  UserPeer::retrieveByPk($this->getRequestParameter('user_id'));
    $this->forward404Unless($this->user);
    $this->forwardIf($this->user->getCoachId()!=$this->getUser()->getAttribute('user_id',0 , 'athlete'), 'content', 'notAllowed');
    
  }


  /**
   * Action to update the season data with the fields of the form
   *
   * @param Season $season
   * @return Season
   */  
  protected function update($season){
    $season->setDescription($this->getRequestParameter('description'));
    if ($this->getRequestParameter('start_at'))
    {
      list($d, $m, $y) = sfI18N::getDateForCulture($this->getRequestParameter('start_at'), $this->getUser()->getCulture());
      $season->setStartAt("$y-$m-$d");
    }
    if ($this->getRequestParameter('last_day_at'))
    {
      list($d, $m, $y) = sfI18N::getDateForCulture($this->getRequestParameter('last_day_at'), $this->getUser()->getCulture());
      $season->setLastDayAt("$y-$m-$d");
    }
    $season->setUserId($this->getRequestParameter('user_id') ? $this->getRequestParameter('user_id') : null);
   // $season->setTheoricIntensity($this->getRequestParameter('theoric_intensity'));
    $season->setTheoricIntensity1($this->getRequestParameter('theoric_intensity1'));
    $season->setTheoricIntensity2($this->getRequestParameter('theoric_intensity2'));
    $season->setTheoricIntensity3($this->getRequestParameter('theoric_intensity3'));
    $season->setIntensity1LowLimit($this->getRequestParameter('intensity1_low_limit'));
    $season->setIntensity1HighLimit($this->getRequestParameter('intensity1_high_limit'));
    $season->setIntensity2HighLimit($this->getRequestParameter('intensity2_high_limit'));
    $season->setIntensity3HighLimit($this->getRequestParameter('intensity3_high_limit'));
    $season->setVolumeUnitId($this->getRequestParameter('volume_unit_id'));
    //$season->setVolumeUnitTypeId($season->getUnitRelatedByVolumeUnitId()->getUnitTypeId());
    
    $season->setTheoricVolume($this->getRequestParameter('theoric_volume'));
    return $season;
  }
}
