<?php
// auto-generated by sfPropelCrud
// date: 2008/11/25 17:23:50

/**
 * Template to show a component with a list of seasons
 * 
 * @author Diego Cebrián
 * @package    frontend
 * @subpackage modules-season-templates
 * @uses     array seasons: the list of seasons
 * @uses  User user: the user which owns the seasons
 */
?>
<h2><?php echo __('Seasons for').' '.$user->__toString(); ?></h2>

<table>
<thead>
<tr>
  <th><?php echo __('Description'); ?></th>
  <th><?php echo __('Start at'); ?></th>
  <th><?php echo __('Last day at'); ?></th>
  <th><?php echo __('Theoric intensity') ?></th>
  <th><?php echo __('Reported intensity'); ?></th>
  <th><?php echo __('Theoric volume'); ?></th>
  <th><?php echo __('Reported volume'); ?></th>
  <th><?php echo __('Options'); ?></th>
</tr>
</thead>
<tbody>
<?php foreach ($seasons as $period): ?>
<tr>
      <td><?php echo $period->getDescription() ?></td>
      <td><?php echo format_date($period->getStartAt(), 'D').', '.format_date($period->getStartAt(), 'EEEE') ?></td>
      <td><?php echo format_date($period->getLastDayAt(), 'D').', '.format_date($period->getLastDayAt(), 'EEEE') ?></td>
      <td>
        <table>
          <tr>
            <td>
              <?php echo $period->getIntensity1LowLimit().'-'.$period->getIntensity1HighLimit().' %'; ?>
            </td>
            <td>
              <?php echo $period->getTheoricIntensity1().' '.$period->getVolumeUnit(); ?>
            </td>
          </tr>
          <tr>
            <td>
              <?php echo ($period->getIntensity1HighLimit()+1).'-'.$period->getIntensity2HighLimit().' %'; ?>
            </td>
            <td>
              <?php echo $period->getTheoricIntensity2().' '.$period->getVolumeUnit(); ?>
            </td>
          </tr>
          <tr>
            <td>
              <?php echo ($period->getIntensity2HighLimit()+1).'-'.$period->getIntensity3HighLimit().' %'; ?>
            </td>
            <td>
              <?php echo $period->getTheoricIntensity3().' '.$period->getVolumeUnit(); ?>
            </td>
          </tr>
        </table>
      <td>
        <table>
          <tr>
            <td>
              <?php echo $period->getReportedIntensity1().' '.$period->getVolumeUnit(); ?>
            </td>
          </tr>
          <tr>
            <td>
              <?php echo $period->getReportedIntensity2().' '.$period->getVolumeUnit(); ?>
            </td>
          </tr>
          <tr>
            <td>
              <?php echo $period->getReportedIntensity3().' '.$period->getVolumeUnit(); ?>
            </td>
          </tr>
        </table>
        </td>
      <td><?php echo $period->getTheoricVolume() ?></td>
      <td><?php echo $period->getReportedVolume() ?></td>
      <td><?php echo link_to(__('Show'), '@season_show?user_id='.$user->getId().'&season_id='.$period->getId()) ?></td>
      <td><?php echo link_to(__('Edit'), '@season_edit?user_id='.$user->getId().'&season_id='.$period->getId()) ?></td>
      <td><?php echo link_to(__('Add macrocycle'), '@macrocycle_add?user_id='.$user->getId().'&season_id='.$period->getId()) ?></td>
  </tr>
<?php endforeach; ?>
</tbody>
</table>
