<?php
// auto-generated by sfPropelCrud
// date: 2008/11/25 17:23:50


/**
 * Template to show a form to edit a season
 * 
 * @author Diego Cebrián
 * @package    frontend
 * @subpackage modules-season-templates
 * @uses User user: the user which owns the season
 * @uses Season period: the season  to edit
 */
?>
<?php use_helper('Object') ?>
<?php use_helper('Validation') ?>
<?php use_helper('Javascript') ?>

 
<?php slot('header'); ?>
<?php echo image_tag('admin/help', 'alt=help class=error_ico')?>
  <h1 class="help"><?php echo __('Help for').': '.__('Edit season') ?></h1>
  <p class="help"><?php echo __('Enter the requested data') ?></p>
  <p class="help"><?php echo __('Emphasided fields are mandatory').': <label class="mandatory">'.__('Mandatory field').'</label>' ?></p>
  <p class="help"><?php echo __('Clicking on the button closed to date field will display a dynamic calendar') ?></p>
  <p class="help"><?php echo __('For manual date editing, please use this format').': '.format_date('1981-06-20') ?></p>
<?php end_slot(); ?>

<h2><?php echo __('Season').' '.$period.' '.__('for').' '.$user ?> </h2>

<?php echo form_tag('@season_edit?season_id='.$period->getId().'&user_id='.$user->getId()) ?>

 <?php echo input_hidden_tag('user_id', $user->getId()) ?>
 <?php echo input_hidden_tag('season_id', $period->getId()) ?> 

  <div class="form_row">
    <?php echo __(form_error('user_id')) ?>
    <div class="form_label_left"><label for="user_id"><?php echo __('User')?>:</label></div>
    <div class="form_field_left"><?php echo $user; ?><?php echo input_hidden_tag('user_id', $user->getId()) ?> </div>
  </div>

  <div class="form_row">
    <?php echo __(form_error('description')) ?>
    <div class="form_label_left"><label for="description" class="mandatory"><?php echo __('Description')?>:</label></div>
    <div class="form_field_left"><?php echo $period->getDescription(); ?><?php echo object_input_hidden_tag($period, 'getDescription') ?> </div>
  </div>

    <?php echo __(form_error('season_id')) ?>
<?php echo input_hidden_tag('season_id', $period->getId()) ?>
  
  <div class="form_row">
    <?php echo __(form_error('start_at')) ?>
    <div class="form_label_left"><label for="start_at" class="mandatory"><?php echo __('Start at')?>:</label></div>
    <div class="form_field_left"><?php echo object_input_date_tag($period, 'getStartAt', array (
  'rich' => true,
)) ?></div>
  </div>
  <div class="form_row">
    <?php echo __(form_error('last_day_at')) ?>
    <div class="form_label_left"><label for="last_day_at" class="mandatory"><?php echo __('Last day at')?>:</label></div>
    <div class="form_field_left"><?php echo object_input_date_tag($period, 'getLastDayAt', array (
  'rich' => true,
)) ?></div>
  </div>
    <div class="form_row">
    <?php echo __(form_error('theoric_intensity')) ?>
    <div class="form_label_left"><label for="theoric_intensity"><?php echo __('Theoric intensity')?>:</label></div>
    <div class="form_field_left">
        <table>
          <tr>
            <td>
              <?php
               echo javascript_tag('function change_numeric_field(target, origin, add){ 
                document.getElementById(target).value= (parseFloat(document.getElementById(origin).value)+add)
               }
               function change_field(target, origin){ 
                document.getElementById(target).value= document.getElementById(origin).options[document.getElementById(origin).selectedIndex].text
               }   
               function calculate_total(){ 
                document.getElementById("theoric_volume").value = ((parseFloat(document.getElementById("theoric_intensity1").value))+(parseFloat(document.getElementById("theoric_intensity2").value))+(parseFloat(document.getElementById("theoric_intensity3").value)))
               }
               '                 
                )              
               ?>
              <?php echo object_input_tag($period, 'getIntensity1LowLimit', array ('size' => 2)).'-'.object_input_tag($period, 'getIntensity1HighLimit', array ('size' => 2, 'onChange' => 'change_numeric_field("intensity_2_low_limit", "intensity1_high_limit", 1)' )).' %'; ?>
            </td>
            <td>
              <?php echo object_input_tag($period, 'getTheoricIntensity1', array ('size' => 7, 'onChange' => 'calculate_total()')).' '.object_select_tag($period, 'getVolumeUnitId', array('related_class' => 'Unit', 'include_blank' => false, 'onChange' => 'change_field("unit2", "volume_unit_id");change_field("unit3", "volume_unit_id");change_field("unit4", "volume_unit_id")', )); ?>
            </td>
          </tr>
          <tr>
            <td>
              <?php echo input_tag('intensity_2_low_limit', null, array ('size' => 2, 'readonly'=>'readonly')).'-'.object_input_tag($period, 'getIntensity2HighLimit', array ('size' => 2, 'onChange' => 'change_numeric_field("intensity_3_low_limit", "intensity2_high_limit", 1)' )).' %'; ?>
            </td>
            <td>
              <?php echo object_input_tag($period, 'getTheoricIntensity2', array ('size' => 7, 'onChange' => 'calculate_total()')).' '.input_tag('unit2', null, array ('size' => 15, 'readonly'=>'readonly')); ?>
            </td>
          </tr>
          <tr>
            <td>
              <?php echo input_tag('intensity_3_low_limit', null, array ('size' => 2, 'readonly'=>'readonly')).'-'.object_input_tag($period, 'getIntensity3HighLimit', array ('size' => 2)).' %'; ?>
            </td>
            <td>
              <?php echo object_input_tag($period, 'getTheoricIntensity3', array ('size' => 7, 'onChange' => 'calculate_total()')).' '.input_tag('unit3', null, array ('size' => 15, 'readonly'=>'readonly')); ?>
            </td>
          </tr>
        </table>
    </div>

  </div>
  <div class="form_row">
    <?php echo __(form_error('theoric_volume')) ?>
    <div class="form_label_left"><label for="theoric_volume"><?php echo __('Theoric volume')?>:</label></div>
    <div class="form_field_left"><?php echo object_input_tag($period, 'getTheoricVolume', array (
  'size' => 7,
)).input_tag('unit4', null, array ('size' => 15, 'readonly'=>'readonly')) ?></div>
  </div>
<hr />
<?php echo submit_tag(__('Save')) ?>
<?php if ($period->getId()): ?>
  &nbsp;<?php echo link_to(__('Delete'), '@season_delete?season_id='.$period->getId().'&user_id='.$user->getId(), 'post=true&confirm='.__('Are you sure?')) ?>
  &nbsp;<?php echo link_to(__('Cancel'), '@season_show?season_id='.$period->getId().'&user_id='.$user->getId()) ?>
<?php else: ?>
  &nbsp;<?php echo link_to(__('Cancel'), '@season_show?season_id='.$period->getId().'&user_id='.$user->getId()) ?>
<?php endif; ?>
</form>
<?php echo javascript_tag('change_field("unit2", "volume_unit_id");change_field("unit3", "volume_unit_id");change_field("unit4", "volume_unit_id")') ?>