<?php
// auto-generated by sfPropelCrud
// date: 2008/11/25 17:23:50

/**
 * Template to show a season
 * 
 * @author Diego Cebrián
 * @package    frontend
 * @subpackage modules-season-templates
 * @uses User user: the user which owns the season
 * @uses Season period: the season where the data is put on
 */
?>
 
<?php slot('header'); ?>
<?php echo image_tag('admin/help', 'alt=help class=error_ico')?>
  <h1 class="help"><?php echo __('Help for').': '.__('Show season') ?></h1>
  <p class="help"><?php echo __('This view shows one of the seasons for your athlete, with its caracteristics and the list of the Macrocycles') ?></p>
  <p class="help"><?php echo __('You can view the Mesocycles clicking in Show in the list, Edit the Mesocycle clicking in Edit in the list and add a Microcycle to a Mesocycle clicking  in Add microcycle'); ?></p>
  <p class="help"><?php echo __('The menu in the bottom allows you to add new Macrocycles, edit the Season, click to select the current Macrocycle by date, or access to the high level (the athlete Seasons list)') ?></p>
<?php end_slot(); ?>

<h1><?php echo __('Season').' '.$period->getDescription().' '.__('for').' '.$user ?></h1>

<div class="top_show">
  <div class="left_show">
    <div class="form_row">
      <div class="form_label_left"><label for="start_at"><?php echo  __('Start at')?>: </label></div>
      <div class="form_field_left"><?php echo format_date($period->getStartAt(), 'D').', '.format_date($period->getStartAt(), 'EEEE') ?></div>
    </div>
    <div class="form_row">
      <div class="form_label_left"><label for="last_day_at"><?php echo __('Last day at')?>: </label></div>
      <div class="form_field_left"><?php echo format_date($period->getLastDayAt(), 'D').', '.format_date($period->getLastDayAt(), 'EEEE') ?></div>
    </div>
  </div>
</div>

<div class="top_show">
  <div class="left_show"> 
    <div class="form_row">
      <div class="form_label_left"><label for="theoric_volume"><?php echo __('Theoric volume')?>: </label></div>
      <div class="form_field_left"><?php echo $period->getTheoricVolume() ?></div>
    </div>
  </div>
  <div class="right_show">
    <div class="form_row">
      <div class="form_label_left"><label for="reported_volume"><?php echo __('Reported volume')?>: </label></div>
      <div class="form_field_left"><?php echo $period->getReportedVolume() ?></div>
    </div>
  </div>
</div>
<div class="top_show">
  <div class="left_show"> 
    <div class="form_row">
      <div class="form_label_left"><label for="theoric_intensity">
        <?php echo __('Theoric intensity')?>: </label>
      </div>
      <div class="form_field_left">
        <table>
          <tr>
            <td>
              <?php echo $period->getIntensity1LowLimit().'-'.$period->getIntensity1HighLimit().' %'; ?>
            </td>
            <td>
              <?php echo $period->getTheoricIntensity1().' '.$period->getVolumeUnit(); ?>
            </td>
          </tr>
          <tr>
            <td>
              <?php echo $period->getIntensity2LowLimit().'-'.$period->getIntensity2HighLimit().' %'; ?>
            </td>
            <td>
              <?php echo $period->getTheoricIntensity2().' '.$period->getVolumeUnit(); ?>
            </td>
          </tr>
          <tr>
            <td>
              <?php echo $period->getIntensity3LowLimit().'-'.$period->getIntensity3HighLimit().' %'; ?>
            </td>
            <td>
              <?php echo $period->getTheoricIntensity3().' '.$period->getVolumeUnit(); ?>
            </td>
          </tr>
        </table>
      </div>
    </div>
  </div>
  <div class="right_show"> 
    <div class="form_row">
      <div class="form_label_left"><label for="reported_intensity"><?php echo __('Reported intensity')?>: </label></div>
      <div class="form_field_left">
        <table>
          <tr>
            <td>
              <?php echo $period->getReportedIntensity1().' '.$period->getVolumeUnit(); ?>
            </td>
          </tr>
          <tr>
            <td>
              <?php echo $period->getReportedIntensity2().' '.$period->getVolumeUnit(); ?>
            </td>
          </tr>
          <tr>
            <td>
              <?php echo $period->getReportedIntensity3().' '.$period->getVolumeUnit(); ?>
            </td>
          </tr>
        </table>
      </div>
    </div>
  </div>
</div>
<div class="top_show">

</div>
<div class="top_show">
<hr />
    <?php include_component('macrocycle', 'Season', array('user_id'=> $user->getId(), 'season_id' => $period->getId())) ?>
    <h3><?php echo __('Actions') ?></h3>
    <ul class="actions">
    <?php if($macrocycle){ ?>
      <li class="actions_item"><?php echo link_to(__('Show current macrocycle'), '@macrocycle_show?user_id='.$user->getId().'&macrocycle_id='.$macrocycle->getId() ) ?></li>
      <li class="actions_item"><?php echo link_to(__('Add mesocycle to current macrocycle'), '@mesocycle_add?user_id='.$user->getId().'&macrocycle_id='.$macrocycle->getId() ) ?></li>
    <?php } ?>
      <li class="actions_item"><?php echo link_to(__('Add macrocycle'), '@macrocycle_add?season_id='.$period->getId().'&user_id='.$user->getId() ) ?></li>
      <li class="actions_item"><?php echo link_to(__('Show current user'), '@athlete_show?id='.$user->getId() ) ?></li>
      <li class="actions_item"><?php echo link_to(__('Edit'), '@season_edit?user_id='.$user->getId().'&season_id='.$period->getId() ) ?></li>
    </ul>
</div>
<hr />
&nbsp;<?php echo link_to(__('List my athletes'), '@athletes') ?>