<?php
// auto-generated by sfPropelCrud
// date: 2009/03/18 03:38:02
/**
 * @author Diego Cebrián
 */

/**
 * session actions.
 *
 * @package    gesport
 * @subpackage session
 * @author     Diego Cebrián
 */
class sessionActions extends sfActions
{
  public function executeIndex()
  {
    return $this->forward('session', 'list');
  }

  public function executeList()
  {
    $this->sessions = SessionPeer::doSelect(new Criteria());
  }

  
  /**
   * Show the session of the current date for the current user
   *
   */

  public function executeShowCurrent()
  {
    $this->session = SessionPeer::retrieveCurrentByUserId($this->getRequestParameter('user_id'));
    $this->forward404Unless($this->session);
    $this->user = $this->session->getMicrocycle()->getMesocycle()->getMacrocycle()->getSeason()->getUser();
    $this->forward404Unless($this->user);
    $this->forwardIf($this->session->getMicrocycle()->getMesocycle()->getMacrocycle()->getSeason()->getUser()->getCoachId()!=$this->getUser()->getAttribute('user_id',0 , 'athlete'), 'content', 'notAllowed');
    
    $this->setTemplate('show');
  }
  
  /**
   * Show a selected session
   *
   */
  public function executeShow()
  {
    $this->session = SessionPeer::retrieveByUserIdAndPk($this->getRequestParameter('user_id'), $this->getRequestParameter('session_id')); 
    $this->forward404Unless($this->session);
    $this->user = $this->session->getMicrocycle()->getMesocycle()->getMacrocycle()->getSeason()->getUser(); 
    $this->forward404Unless($this->user);
    $this->forwardIf($this->session->getMicrocycle()->getMesocycle()->getMacrocycle()->getSeason()->getUser()->getCoachId()!=$this->getUser()->getAttribute('user_id',0 , 'athlete'), 'content', 'notAllowed');
  }

  
  /**
   * Show a selected session
   *
   */
  public function executeShowToday()
  { 
	  if ($this->getRequest()->getMethod() != sfRequest::POST){    
	    $this->sessions = SessionPeer::retrieveByUserIdAndDate($this->getUser()->getAttribute('user_id',0 , 'athlete')); 
	    $this->forward404Unless($this->sessions);
	    $this->user = $this->sessions[0]->getMicrocycle()->getMesocycle()->getMacrocycle()->getSeason()->getUser(); 
	    $this->forward404Unless($this->user);
	    $this->forwardIf($this->sessions[0]->getMicrocycle()->getMesocycle()->getMacrocycle()->getSeason()->getUserId()!=$this->getUser()->getAttribute('user_id',0 , 'athlete'), 'content', 'notAllowed');
	  }
  }
  
  /**
   * Show a selected session
   *
   */
  public function executeShowReport()
  {
    if ($this->getRequest()->getMethod() != sfRequest::POST){    
	    $this->session = SessionPeer::retrieveByUserIdAndPk($this->getUser()->getAttribute('user_id',0 , 'athlete'), $this->getRequestParameter('session_id')); 
	    $this->forward404Unless($this->session);
	    $this->user = $this->session->getMicrocycle()->getMesocycle()->getMacrocycle()->getSeason()->getUser(); 
	    $this->forward404Unless($this->user);
	    $this->forwardIf($this->session->getMicrocycle()->getMesocycle()->getMacrocycle()->getSeason()->getUserId()!=$this->getUser()->getAttribute('user_id',0 , 'athlete'), 'content', 'notAllowed');
	    $this->sessions=Array(0=>$this->session);
	    	    
	    $this->setTemplate('showToday'); 
    }
    else{    
      $this->session = SessionPeer::retrieveByUserIdAndDate($this->getUser()->getAttribute('user_id',0 , 'athlete')); 
      $this->forward404Unless($this->session);
      $this->user = $this->session->getMicrocycle()->getMesocycle()->getMacrocycle()->getSeason()->getUser(); 
      $this->forward404Unless($this->user);
      $this->forwardIf($this->session->getMicrocycle()->getMesocycle()->getMacrocycle()->getSeason()->getUserId()!=$this->getUser()->getAttribute('user_id',0 , 'athlete'), 'content', 'notAllowed');
      
      $session=$this->updateReport($this->session);
      $session->save();
      $this->session->getMicrocycle()->calculateReportedValues();
      
      $this->redirect('@sessions_not_reported');
    }   
  }
  


  public function executeNotReported()
  {  
    $this->user = UserPeer::retrieveByPK($this->getUser()->getAttribute('user_id',0 , 'athlete')) ;
    $this->forward404Unless($this->user);
    $this->sessions = SessionPeer::retrieveNotReportedByUserId($this->user->getId()); 
    $this->forward404Unless($this->sessions);
    
  }
  
  /**
   * To edit a session from Coach View
   *
   * @return unknown
   */
  public function executeEdit()
  {
    //Show the form
    if ($this->getRequest()->getMethod() != sfRequest::POST)
    {
      //retrieve data for the form
      $this->session = SessionPeer::retrieveByUserIdAndPk($this->getRequestParameter('user_id'), $this->getRequestParameter('session_id'));
      $this->forward404Unless($this->session);
      $this->user = $this->session->getMicrocycle()->getMesocycle()->getMacrocycle()->getSeason()->getUser();
      $this->forward404Unless($this->user);
      $this->microcycle = $this->session->getMicrocycle();
      $this->forward404Unless($this->microcycle);
      //access control
      $this->forwardIf($this->session->getMicrocycle()->getMesocycle()->getMacrocycle()->getSeason()->getUser()->getCoachId()!=$this->getUser()->getAttribute('user_id',0 , 'athlete'), 'content', 'notAllowed');
      
      // display the form
      $this->form_action="session_edit";
      $this->getRequest()->getParameterHolder()->set('referer', $this->getRequest()->getReferer());
      
      return sfView::SUCCESS;
    }
    //Recover data and update the microcycle
    else
    {
      $this->session = SessionPeer::retrieveByUserIdAndPk($this->getRequestParameter('user_id'), $this->getRequestParameter('session_id'));
      $this->forward404Unless($this->session);
      $this->user = $this->session->getMicrocycle()->getMesocycle()->getMacrocycle()->getSeason()->getUser();
      $this->forward404Unless($this->user);
      $this->microcycle = $this->session->getMicrocycle();
      $this->forward404Unless($this->microcycle);
      //access control
      $this->forwardIf($this->session->getMicrocycle()->getMesocycle()->getMacrocycle()->getSeason()->getUser()->getCoachId()!=$this->getUser()->getAttribute('user_id',0 , 'athlete'), 'content', 'notAllowed');
      
      //update and save
      $session=$this->update($this->session);
      $session->save();
      $this->microcycle->calculateReportedValues();
      
      //redirect to selected page
      $this->redirect('@microcycle_show?microcycle_id='.$this->session->getMicrocycleId().'&user_id='.$this->user->getId());
    }
  }
  
  /**
   * When an error in editing from Coach View occurs it returns to the edit form
   *
   * @return unknown
   */
  
  public function handleErrorEdit()
  {
    $this->session = SessionPeer::retrieveByUserIdAndPk($this->getRequestParameter('user_id'), $this->getRequestParameter('session_id'));
    $this->forward404Unless($this->session);
    $this->user = $this->session->getMicrocycle()->getMesocycle()->getMacrocycle()->getSeason()->getUser();
    $this->forward404Unless($this->user);
    $this->microcycle = $this->session->getMicrocycle();
    $this->forward404Unless($this->microcycle);
    //access control
    $this->forwardIf($this->session->getMicrocycle()->getMesocycle()->getMacrocycle()->getSeason()->getUser()->getCoachId()!=$this->getUser()->getAttribute('user_id',0 , 'athlete'), 'content', 'notAllowed');
    
    $this->session->setDescription($this->getRequestParameter('description'));
    $this->session->setMicrocycleId($this->getRequestParameter('microcycle_id') ? $this->getRequestParameter('microcycle_id') : null);
    $this->session->setTheoricIntensity1($this->getRequestParameter('theoric_intensity1'));
    $this->session->setTheoricIntensity2($this->getRequestParameter('theoric_intensity2'));
    $this->session->setTheoricIntensity3($this->getRequestParameter('theoric_intensity3'));
    $this->session->setTheoricVolume($this->getRequestParameter('theoric_volume'));
    return sfView::SUCCESS;
  }
  /**
   * Action for delete a session
   *
   * @return unknown
   */

  public function executeDelete()
  {
    $this->session = SessionPeer::retrieveByUserIdAndPk($this->getRequestParameter('user_id'), $this->getRequestParameter('session_id'));
    $this->forward404Unless($this->session);
    $this->user = $this->session->getMicrocycle()->getMesocycle()->getMacrocycle()->getSeason()->getUser();
    $this->forward404Unless($this->user);
    //access control
    $this->forwardIf($this->session->getMicrocycle()->getMesocycle()->getMacrocycle()->getSeason()->getUser()->getCoachId()!=$this->getUser()->getAttribute('user_id',0 , 'athlete'), 'content', 'notAllowed');
    try {
      $this->session->delete();
      return $this->redirect('@microcycle_show?microcycle_id='.$this->session->getMicrocycleId().'&user_id='.$this->user->getId());
    }
    //if the session is used in other class, advert that can't be deleted
    catch (PropelException $e){
      $this->message = ' is still used in Gesport and can not be deleted.';
      $this->setTemplate('notDeleted');  
    }
    catch (Exception $e){
      $this->message = ' cannot be deleted.';
      $this->setTemplate('notDeleted');  
    }
  }  
  
  
  /**
   * Create a session form Coach View
   *
   * @return unknown
   */
  public function executeAdd()
  {
    //Show the form
    if ($this->getRequest()->getMethod() != sfRequest::POST)
    {
      $this->user = UserPeer::retrieveByPk($this->getRequestParameter('user_id'));
      $this->forward404Unless($this->user);
      $this->microcycle = MicrocyclePeer::retrieveByUserIdAndPk($this->getRequestParameter('user_id'), $this->getRequestParameter('microcycle_id'));
      $this->forward404Unless($this->microcycle);
      $this->session = new Session();
      $this->forward404Unless($this->session);
      $this->session->setMicrocycle($this->microcycle);
      
      $this->forwardIf($this->user->getCoachId()!=$this->getUser()->getAttribute('user_id',0 , 'athlete'), 'content', 'notAllowed');
      // display the form
      $this->form_action="session_add";
      $this->getRequest()->getParameterHolder()->set('referer', $this->getRequest()->getReferer());

      return sfView::SUCCESS;
    }
    //Recover data and create the microcycle
    else
    {
      // handle the form submission
      
      $this->user = UserPeer::retrieveByPk($this->getRequestParameter('user_id'));
      $this->forward404Unless($this->user);
      $this->microcycle = MicrocyclePeer::retrieveByUserIdAndPk($this->getRequestParameter('user_id'), $this->getRequestParameter('microcycle_id'));
      $this->forward404Unless($this->microcycle);
      $this->session = new Session();
      $this->forward404Unless($this->session); 
      $this->session->setMicrocycle($this->microcycle);
      $session=$this->update($this->session);
        
      $session->save();
      $this->microcycle->calculateReportedValues();
      
      // redirect to the page of the user
      return $this->redirect('@microcycle_show?microcycle_id='.$this->microcycle->getId().'&user_id='.$this->user->getId());
    }
  }
    
  /**
   * When an error in adding from Coach View occurs it returns to the add form
   *
   * @return unknown
   */
  
  public function handleErrorAdd()
  {
    $this->user = UserPeer::retrieveByPk($this->getRequestParameter('user_id'));
    $this->forward404Unless($this->user);
    $this->microcycle = MicrocyclePeer::retrieveByUserIdAndPk($this->getRequestParameter('user_id'), $this->getRequestParameter('microcycle_id'));
    $this->forward404Unless($this->microcycle);
    $this->session = new Session();
    $this->forward404Unless($this->session);
    $this->session->setMicrocycle($this->microcycle); 
    $this->session->setDescription($this->getRequestParameter('description'));
    $this->session->setMicrocycleId($this->getRequestParameter('microcycle_id') ? $this->getRequestParameter('microcycle_id') : null);
    $this->session->setTheoricIntensity1($this->getRequestParameter('theoric_intensity1'));
    $this->session->setTheoricIntensity2($this->getRequestParameter('theoric_intensity2'));
    $this->session->setTheoricIntensity3($this->getRequestParameter('theoric_intensity3'));
    $this->session->setTheoricVolume($this->getRequestParameter('theoric_volume'));
    return sfView::SUCCESS;
  }


  public function update($session)
  {
    if ($this->getRequestParameter('date'))
    {
      list($d, $m, $y) = sfI18N::getDateForCulture($this->getRequestParameter('date'), $this->getUser()->getCulture());
      $session->setDate("$y-$m-$d");
    }
    $session->setDescription($this->getRequestParameter('description'));
    $session->setMicrocycleId($this->getRequestParameter('microcycle_id') ? $this->getRequestParameter('microcycle_id') : null);
    $session->setTheoricVolume($this->getRequestParameter('theoric_volume'));
    $session->setTheoricIntensity1($this->getRequestParameter('theoric_intensity1'));
    $session->setTheoricIntensity2($this->getRequestParameter('theoric_intensity2'));
    $session->setTheoricIntensity3($this->getRequestParameter('theoric_intensity3'));
    $session->setReportedVolume($this->getRequestParameter('reported_volume'));
    $session->setWakeUpHr($this->getRequestParameter('wake_up_hr'));
    $session->setFeedback($this->getRequestParameter('feedback'));
    $session->setReportedIntensity1($this->getRequestParameter('reported_intensity1'));
    $session->setReportedIntensity2($this->getRequestParameter('reported_intensity2'));
    $session->setReportedIntensity3($this->getRequestParameter('reported_intensity3'));

    return $session;
  }

  public function updateReport($session)
  {
    $session->setReportedVolume($this->getRequestParameter('reported_volume'));
    $session->setWakeUpHr($this->getRequestParameter('wake_up_hr'));
    $session->setFeedback($this->getRequestParameter('feedback'));
    $session->setReportedIntensity1($this->getRequestParameter('reported_intensity1'));
    $session->setReportedIntensity2($this->getRequestParameter('reported_intensity2'));
    $session->setReportedIntensity3($this->getRequestParameter('reported_intensity3'));
    $this->session->setNewReport(1);
    $this->session->setReported(1);

    return $session;
  }
}
