<?php
// auto-generated by sfPropelCrud
// date: 2008/11/25 17:23:50


/**
 * Template to show a form to add a new session to a microcycle
 * 
 * @author Diego Cebrián
 * @package    frontend
 * @subpackage modules-session-templates
 * @uses User user: the owner of the session
 * @uses Microcycle microcycle: the microcycle in wich the microcycle is included
 * @uses Session session: the session where the data is put on
 */
?>
<?php use_helper('Object') ?>
<?php use_helper('Validation') ?>
<?php use_helper('Javascript') ?>
<?php
echo javascript_tag('
               function calculate_total(){ 
                document.getElementById("theoric_volume").value = ((parseFloat(document.getElementById("theoric_intensity1").value))+(parseFloat(document.getElementById("theoric_intensity2").value))+(parseFloat(document.getElementById("theoric_intensity3").value)))
               }
               function calculate_reported_total(){ 
                document.getElementById("reported_volume").value = ((parseFloat(document.getElementById("reported_intensity1").value))+(parseFloat(document.getElementById("reported_intensity2").value))+(parseFloat(document.getElementById("reported_intensity3").value)))
               }
               '                 
               )
               ?>

<?php slot('header'); ?>
<?php echo image_tag('admin/help', 'alt=help class=error_ico')?>
  <h1 class="help"><?php echo __('Help for').': '.__('Edit session') ?></h1>
  <p class="help"><?php echo __('Enter the requested data') ?></p>
  <p class="help"><?php echo __('Emphasided fields are mandatory').': <label class="mandatory">'.__('Mandatory field').'</label>' ?></p>
  <p class="help"><?php echo __('Clicking on the button closed to date field will display a dynamic calendar') ?></p>
  <p class="help"><?php echo __('For manual date editing, please use this format').': '.format_date('1981-06-20') ?></p>
<?php end_slot(); ?>

<h1><?php echo __('Session for').' '.$user.' '.__('at').' '.$session;?></h1>

<?php echo form_tag('@session_edit?user_id='.$user->getId().'&session_id='.$session->getId()) ?>

 <?php echo input_hidden_tag('user_id', $user->getId()) ?>
 <?php echo input_hidden_tag('microcycle_id', $session->getMicrocycleId()) ?>
 <?php echo input_hidden_tag('session_id', $session->getId()) ?> 
 
  <div class="form_row">
    <?php echo __(form_error('microcycle_id')) ?>
    <div class="form_label_left"><label for="nickname"><?php echo __('Microcycle')?>:</label></div>
    <div class="form_field_left"><?php echo $microcycle ?>, <?php echo __('from') ?> <?php echo format_date($microcycle->getStartAt(), 'D').', '.format_date($microcycle->getStartAt(), 'EEEE') ?> <?php echo __('to') ?> <?php echo format_date($microcycle->getStartAt(), 'D').', '.format_date($microcycle->getStartAt(), 'EEEE') ?></div>
  </div>
  
  <div class="form_row">
    <?php echo __(form_error('date')) ?>
    <div class="form_label_left"><label for="start_at" class="mandatory"><?php echo __('Date')?>:</label></div>
    <div class="form_field_left"><?php echo object_input_date_tag($session, 'getDate', array (
  'rich' => true,
)) ?></div>
  </div>
  
  <div class="form_row">
    <?php echo __(form_error('description')) ?>
    <div class="form_label_left"><label for="description" class="mandatory"><?php echo __('Description')?>:</label></div>
    <div class="form_field_left"><?php echo object_input_tag($session, 'getDescription', array (
  'size' => 40,
)) ?></div>
  </div>
  
  <div class="form_row">
    <?php echo __(form_error('wake_up_hr')) ?>
    <div class="form_label_left"><label for="description" class="mandatory"><?php echo __('Wake up HR')?>:</label></div>
    <div class="form_field_left"><?php echo object_input_tag($session, 'getWakeUpHr', array (
  'size' => 3,
)) ?></div>
  </div>
 
  <div class="form_row">
    <?php echo __(form_error('theoric_intensity')) ?>
    <div class="form_label_left"></div>
    <div class="form_field_left">
        <table>
          <tr>
            <th colspan="2">
              <label for="theoric_intensity"><?php echo __('Theoric intensity')?>:</label>
            </th>
            <th colspan="2">
              <label for="reported_intensity"><?php echo __('Reported intensity')?>:</label>
            </th>
          </tr>
          <tr>
            <td>
              <?php echo $session->getIntensity1LowLimit().'-'.$session->getIntensity1HighLimit().' %'; ?>
            </td>
            <td>
              <?php echo object_input_tag($session, 'getTheoricIntensity1', array (
            'size' => 7, 'onChange' => 'calculate_total()',
            )).' '.$session->getVolumeUnit(); ?>
            </td>
            <td>
              <?php echo object_input_tag($session, 'getReportedIntensity1', array (
            'size' => 7, 'onChange' => 'calculate_reported_total()',
            )).' '.$session->getVolumeUnit(); ?>
            </td>
          </tr>
          <tr>
            <td>
              <?php echo $session->getIntensity2LowLimit().'-'.$session->getIntensity2HighLimit().' %'; ?>
            </td>
            <td>
              <?php echo object_input_tag($session, 'getTheoricIntensity2', array (
            'size' => 7, 'onChange' => 'calculate_total()',
            )).' '.$session->getVolumeUnit(); ?>
            </td>
            <td>
              <?php echo object_input_tag($session, 'getReportedIntensity2', array (
            'size' => 7, 'onChange' => 'calculate_reported_total()',
            )).' '.$session->getVolumeUnit(); ?>
            </td>
          </tr>
          <tr>
            <td>
              <?php echo $session->getIntensity3LowLimit().'-'.$session->getIntensity3HighLimit().' %'; ?>
            </td>
            <td>
              <?php echo object_input_tag($session, 'getTheoricIntensity3', array (
            'size' => 7, 'onChange' => 'calculate_total()',
            )).' '.$session->getVolumeUnit(); ?>
            </td>
            <td>
              <?php echo object_input_tag($session, 'getReportedIntensity3', array (
            'size' => 7, 'onChange' => 'calculate_reported_total()',
            )).' '.$session->getVolumeUnit(); ?>
            </td>
          </tr>
        </table>
    </div>

  </div>
  <div class="form_row">
    <?php echo __(form_error('theoric_volume')) ?>
    <div class="form_label_left"><label for="theoric_volume"><?php echo __('Theoric volume')?>:</label></div>
    <div class="form_field_left"><?php echo object_input_tag($session, 'getTheoricVolume', array (
  'size' => 7,'readonly'=>'readonly'
)) ?></div>
  </div>
  <div class="form_row">
    <?php echo __(form_error('reported_volume')) ?>
    <div class="form_label_left"><label for="reported_volume"><?php echo __('Reported volume')?>:</label></div>
    <div class="form_field_left"><?php echo object_input_tag($session, 'getReportedVolume', array (
  'size' => 7,'readonly'=>'readonly'
)) ?></div>
  </div>
<hr />
<?php echo submit_tag(__('Save')) ?>
&nbsp;<?php echo link_to(__('Cancel'), '@microcycle_show?user_id='.$user->getId().'&microcycle_id='.$microcycle->getId()) ?>
</form>

