<?php
// auto-generated by sfPropelCrud
// date: 2008/11/25 17:23:50


/**
 * Template to show a form to edit a session by athlete
 * 
 * @author Diego Cebrián
 * @package    frontend
 * @subpackage modules-session-templates
 * @uses User user: the owner of the session
 * @uses Microcycle microcycle: the microcycle in wich the microcycle is included
 * @uses Session session: the session where the data is put on
 */
?>
 
<?php slot('header'); ?>
<?php echo image_tag('admin/help', 'alt=help class=error_ico')?>
  <h1 class="help"><?php echo __('Help for').': '.__('Show sessions for today') ?></h1>
  <p class="help"><?php echo __('This view shows the sessions for you to do today') ?></p>
  <p class="help"><?php echo __('You can feedback filling in the fields and clicking Send') ?></p>
<?php end_slot(); ?>

<?php use_helper('Object') ?>
<?php use_helper('Validation') ?>
<?php use_helper('Javascript') ?>
<?php
echo javascript_tag('
               function calculate_total(){ 
                document.getElementById("theoric_volume").value = ((parseFloat(document.getElementById("theoric_intensity1").value))+(parseFloat(document.getElementById("theoric_intensity2").value))+(parseFloat(document.getElementById("theoric_intensity3").value)))
               }
               function calculate_reported_total(){ 
                document.getElementById("reported_volume").value = ((parseFloat(document.getElementById("reported_intensity1").value))+(parseFloat(document.getElementById("reported_intensity2").value))+(parseFloat(document.getElementById("reported_intensity3").value)))
               }
               '                 
               )
               ?>
<?php foreach($sessions as $session){ ?>

<h1><?php echo __('Session').' '.format_date($session->getDate(), 'D').' '.__('for').' '.$user; ?></h1>

<?php echo form_tag('@session_report?user_id='.$user->getId().'&session_id='.$session->getId()) ?>

 <?php echo input_hidden_tag('user_id', $user->getId()) ?>
 <?php echo input_hidden_tag('microcycle_id', $session->getMicrocycleId()) ?>
 <?php echo input_hidden_tag('session_id', $session->getId()) ?> 
 
<div class="top_show">
    <div class="form_row">
      <div class="form_label_left"><label for="date"><?php echo __('Date')?>: </label></div>
      <div class="form_field_left"><?php echo format_date($session->getDate(), 'D').', '.format_date($session->getDate(),'EEEE') ?></div>
    </div>
    <div class="form_row">
      <div class="form_label_left"><label for="decription"><?php echo __('Description')?>: </label></div>
      <div class="form_field_left"><?php echo $session->getDescription() ?></div>
    </div>
    <div class="form_row">
      <div class="form_label_left"><label for="feedback"><?php echo __('Feedback')?>:</label></div>
      <div class="form_field_left"><?php echo object_input_tag($session, 'getFeedback', array (
  'size' => 30,
)) ?></div>
    </div>
  
  <div class="form_row">
    <?php echo __(form_error('wake_up_hr')) ?>
    <div class="form_label_left"><label for="description" class="mandatory"><?php echo __('Wake up HR')?>:</label></div>
    <div class="form_field_left"><?php echo object_input_tag($session, 'getWakeUpHr', array (
  'size' => 3,
)) ?></div>
</div>

<div class="top_show">
  <div class="left_show"> 
    <div class="form_row">
      <div class="form_label_left"><label for="theoric_volume"><?php echo __('Theoric volume')?>: </label></div>
      <div class="form_field_left"><?php echo $session->getTheoricVolume() ?></div>
    </div>
  </div>
  <div class="right_show">
    <div class="form_row">
      <div class="form_label_left"><label for="reported_volume"><?php echo __('Reported volume')?>: </label></div>
      <div class="form_field_left"><?php echo object_input_tag($session, 'getReportedVolume', array (
  'size' => 7, 'readonly'=>'readonly'
)) ?></div>
    </div>
  </div>
</div>

<div class="top_show">
  <div class="left_show"> 
    <div class="form_row">
      <div class="form_label_left"><label for="theoric_intensity">
        <?php echo __('Theoric intensity')?>: </label>
      </div>
      <div class="form_field_left">
        <table>
          <tr>
            <td>
              <?php echo $session->getIntensity1LowLimit().'-'.$session->getIntensity1HighLimit().' %'; ?>
            </td>
            <td>
              <?php echo $session->getTheoricIntensity1().' '.$session->getVolumeUnit(); ?>
            </td>
          </tr>
          <tr>
            <td>
              <?php echo $session->getIntensity2LowLimit().'-'.$session->getIntensity2HighLimit().' %'; ?>
            </td>
            <td>
              <?php echo $session->getTheoricIntensity2().' '.$session->getVolumeUnit(); ?>
            </td>
          </tr>
          <tr>
            <td>
              <?php echo $session->getIntensity3LowLimit().'-'.$session->getIntensity3HighLimit().' %'; ?>
            </td>
            <td>
              <?php echo $session->getTheoricIntensity3().' '.$session->getVolumeUnit(); ?>
            </td>
          </tr>
        </table>
      </div>
    </div>
  </div>
  <div class="right_show"> 
    <div class="form_row">
      <div class="form_label_left"><label for="reported_intensity"><?php echo __('Reported intensity')?>: </label></div>
      <div class="form_field_left">
        <table>
          <tr>
            <td>
              <?php echo object_input_tag($session, 'getReportedIntensity1', array (
            'size' => 7, 'onChange' => 'calculate_reported_total()',
            )).' '.$session->getVolumeUnit(); ?>
            </td>
          </tr>
          <tr>
            <td>
              <?php echo object_input_tag($session, 'getReportedIntensity2', array (
            'size' => 7, 'onChange' => 'calculate_reported_total()',
            )).' '.$session->getVolumeUnit(); ?>
            </td>
          </tr>
          <tr>
            <td>
              <?php echo object_input_tag($session, 'getReportedIntensity3', array (
            'size' => 7, 'onChange' => 'calculate_reported_total()',
            )).' '.$session->getVolumeUnit(); ?>
            </td>
          </tr>
        </table>
      </div>
    </div>
  </div>
</div>
</div>
<div class="bottom_show">
<hr />
<?php echo submit_tag(__('Save')) ?>
</div>
</form>
<?php } ?>