<?php
// auto-generated by sfPropelCrud
// date: 2008/11/10 10:25:00
/**
 * Unit Actions for page layout
 * @package    frontend
 * @subpackage modules-unit
 * @author Diego Cebrián
 */

/**
 * Unit actions for page layout
 *
 * @package    frontend
 * @subpackage modules-unit
 * @author     Diego Cebrián Martínez
 */
class unitActions extends sfActions
{
  /**
   * Default action of unit, it returns the list
   *
   * @return unknown
   */
  public function executeIndex()
  {
    return $this->forward('unit', 'list');
  }


  /**
   * List of all units
   *
   */
  public function executeList()
  {
    $this->units = UnitPeer::doSelect(new Criteria());
  }

  /**
   * Show an unit
   *
   */
  public function executeShow()
  {
    $this->unit = UnitPeer::retrieveByPk($this->getRequestParameter('id'));
    $this->forward404Unless($this->unit);
  }

  /**
   * Action that creates a new unit and show the form to fill the fields
   *
   */
  public function executeCreate()
  {
    $this->unit = new Unit();

    $this->setTemplate('edit');
  }

  /**
   * Action that show a form to modify a unit
   *
   */
  public function executeEdit()
  {
    $this->unit = UnitPeer::retrieveByPk($this->getRequestParameter('id'));
    $this->forward404Unless($this->unit);
  }
   
  /**
   * Action to save the modified or created unit
   *
   * @return unknown
   */

  public function executeUpdate()
  {
    if (!$this->getRequestParameter('id'))
    {
      $unit = new Unit();
    }
    else
    {
      $unit = UnitPeer::retrieveByPk($this->getRequestParameter('id'));
      $this->forward404Unless($unit);
    }

    $unit->setId($this->getRequestParameter('id'));
    $unit->setSymbol($this->getRequestParameter('symbol', 0));
    $unit->setUnitTypeId($this->getRequestParameter('unit_type_id') ? $this->getRequestParameter('unit_type_id') : null);
    $unit->setDescription($this->getRequestParameter('description', 0));

    $unit->save();

    return $this->redirect('@unit');
  }
   
  /**
   * Action to delete an unit
   *
   * @return unknown
   */

  public function executeDelete()
  {
    $unit = UnitPeer::retrieveByPk($this->getRequestParameter('id'));

    $this->forward404Unless($unit);
    
    try{
      $unit->delete();
      return $this->redirect('@unit');
    }
    catch(PropelException $e){
    	$this->unit = $unit; 
      $this->message = ' is still used in Gesport and can not be deleted.';
      $this->setTemplate('notDeleted'); 
    }
  }
}
