<?php
// auto-generated by sfPropelCrud
// date: 2008/11/11 20:22:38
/**
 * User Actions for page layout
 * @package    frontend
 * @subpackage modules-user
 * @author Diego Cebrián
 */

/**
 * User actions for page layout
 *
 * @package    frontend
 * @subpackage modules-user
 * @author     Diego Cebrián Martínez
 */
class userActions extends sfActions
{
  /**
   * Default action of user, it returns the list
   * It predefines the links for the layout
   *
   * @return unknown
   */
	public function executeIndex()
	{
    $this->actionShow='user_show';
    $this->actionEdit='user_edit';
    $this->actionCreate='user_create';
		return $this->forward('user', 'list');
	}


  /**
   * List of all user with actions predefined
   *
   */
  public function executeList()
  {
    $this->actionShow='user_show';
    $this->actionEdit='user_edit';
    $this->actionCreate='user_create';
    $pager = new sfPropelPager('User', sfConfig::get('app_pager_users_max'));
	  $pager->setCriteria(new Criteria());
	  $pager->setPage($this->getRequestParameter('page', 1));
	  $pager->init();
	    
    $this->user_pager = $pager;
  }

  /**
   * Show an User
   *
   */
	public function executeShow()
	{
    $this->actionList='users';
    $this->actionEdit='user_edit';
		$this->user = UserPeer::retrieveByPk($this->getRequestParameter('id'));
		$this->forward404Unless($this->user);
	}

  /**
   * Action that creates a new user, show the form to fill the fields and recover 
   * the information to save it
   *
   */
	public function executeCreate()
	{
    //Show the form
    if ($this->getRequest()->getMethod() != sfRequest::POST)
    {
      $this->user = new User();
      $this->forward404Unless($this->user);
      // display the form
      $this->form_action="user_create";
      $this->getRequest()->getParameterHolder()->set('referer', $this->getRequest()->getReferer());

      return sfView::SUCCESS;
    }
    //Recover data and create the user
    else
    {
      // handle the form submission
      $this->user = new User();
      $this->forward404Unless($this->user);   
      $user=$this->update($this->user);
	    if ($this->getRequestParameter('born_at'))
	    {
	      list($d, $m, $y) = sfI18N::getDateForCulture($this->getRequestParameter('born_at'), $this->getUser()->getCulture());
	      $user->setBornAt("$y-$m-$d");
	    }
      
      $password = $user->generatePassword();

      $this->getRequest()->setAttribute('password', $password);
      $this->getRequest()->setAttribute('nickname', $user->getNickname());
      $this->getRequest()->setAttribute('name', $user->__toString());
     
      $raw_email = $this->sendEmail('mail', 'createUser');
      $this->logMessage($raw_email, 'debug');
        
      $user->save();
      
      // redirect to the page of the new user
      return $this->redirect('@user_show?id='.$user->getId());
    }
  }
  
  /**
   * Action to show again the form create when anything fails
   *
   * @return unknown
   */
  public function handleErrorCreate()
  {
    $this->user = new User();
    $this->user = $this->update($this->user);
    $this->forward404Unless($this->user);
    return sfView::SUCCESS;
  }


  /**
   * Action that edits an user, show the form to fill the fields and recover 
   * the information to save it
   *
   */  
	public function executeEdit()
	{
    //Show the form
    if ($this->getRequest()->getMethod() != sfRequest::POST)
    {
      $this->user = UserPeer::retrieveByPk($this->getRequestParameter('id'));
      $this->forward404Unless($this->user);
      // display the form
      $this->form_action="user_edit";
      $this->getRequest()->getParameterHolder()->set('referer', $this->getRequest()->getReferer());

      return sfView::SUCCESS;
    }
    //Recover data and update
    else
    {
      // handle the form submission
      $this->user = UserPeer::retrieveByPk($this->getRequestParameter('id'));
      $this->forward404Unless($this->user);   
      $user=$this->update($this->user);     
      if ($this->getRequestParameter('born_at'))
      {
        list($d, $m, $y) = sfI18N::getDateForCulture($this->getRequestParameter('born_at'), $this->getUser()->getCulture());
        $user->setBornAt("$y-$m-$d");
      }
      $user->save();
      // redirect to user edited page
      return $this->redirect('@user_show?id='.$this->getRequestParameter('id'));
    }
	}
	
  
  /**
   * Action to show again the form edit when anything fails
   *
   * @return unknown
   */
  public function handleErrorEdit()
  {
    $this->user = UserPeer::retrieveByPk($this->getRequestParameter('id'));
    $this->forward404Unless($this->user);
    $this->form_action="user_edit";
    return sfView::SUCCESS;
  }
  
  /**
   * Action that delete an user
   *
   * @return unknown
   */
  public function executeDelete()
  {
    $user = UserPeer::retrieveByPk($this->getRequestParameter('id'));

    $this->forward404Unless($user);
    //try to delete the user
    try{
      $user->delete();
      return $this->redirect('@users');
    }
    //if the user is used in other class, advert that can't be deleted
    catch (PropelException $e){
      $this->user= $user;
      $this->message = ' is still used in Gesport and can not be deleted.';
      $this->setTemplate('notDeleted');  
    }
    catch (Exception $e){
      $this->user= $user;
      $this->message = ' cannot be deleted.';
      $this->setTemplate('notDeleted');  
    }
  }
  
  //All Users functions
  /**
   * Action that calls the procces to register the session of the user if id and password are fine
   *
   * @return unknown
   */
  public function executeLogin()
  {
    if ($this->getRequest()->getMethod() != sfRequest::POST)
    {
      // display the form
      $this->getRequest()->getParameterHolder()->set('referer', $this->getRequest()->getReferer());

      return sfView::SUCCESS;
    }
    else
    {
      // handle the form submission
      // redirect to last page
      return $this->redirect( '@enter');
    }
  }
  
  /**
   * Action that calls the procces to unregister the session of the user
   *
   * @return unknown
   */
  public function executeLogout()
  {
    $this->getUser()->signOut();
    
    $this->redirect('@enter');
  }
  
  
  /**
   * Action to show again the form to login when anything fails
   *
   * @return unknown
   */
  public function handleErrorLogin()
  {
    return sfView::SUCCESS;
  }

	
	//Self user functions
	

  /**
   * Show an User the information of him/herself
   *
   */
  public function executeSelf()
  {
    $this->actionPassword='user_self_password';
    $this->actionEdit='user_self_edit';
    $this->user = UserPeer::retrieveByPk($this->getUser()->getAttribute('user_id',0 , 'athlete'));
    $this->forward404Unless($this->user);
  }

  /**
   * Action that edits an user, show the form to fill the allowed fields and recover 
   * the information to save it
   *
   */  
  public function executeSelfEdit()
  {
    //Show the form
    if ($this->getRequest()->getMethod() != sfRequest::POST)
    {
      $this->user = UserPeer::retrieveByPk($this->getUser()->getAttribute('user_id',0 , 'athlete'));
      $this->forward404Unless($this->user);
      // display the form
      $this->getRequest()->getParameterHolder()->set('referer', $this->getRequest()->getReferer());

      return sfView::SUCCESS;
    }
    //Recover data and update
    else
    {
      // handle the form submission
      $this->user = UserPeer::retrieveByPk($this->getUser()->getAttribute('user_id',0 , 'athlete'));
      $this->forward404Unless($this->user);   
      $user=$this->update($this->user);
      if ($this->getRequestParameter('born_at'))
      {
        list($d, $m, $y) = sfI18N::getDateForCulture($this->getRequestParameter('born_at'), $this->getUser()->getCulture());
        $user->setBornAt("$y-$m-$d");
      }
      $user->save();
      sfContext::getInstance()->getUser()->setCulture($user->getCulture());
      // redirect to self information
      return $this->redirect('@user_self');
    }
  }

  
  /**
   * Action to show again the form edit Self when anything fails
   *
   * @return unknown
   */
  public function handleErrorSelfEdit()
  {
    $this->user = UserPeer::retrieveByPk($this->getUser()->getAttribute('user_id',0 , 'athlete'));
    $this->forward404Unless($this->user);
    return sfView::SUCCESS;
  }
  
  
  /**
   * Action that edits the password of an user
   *
   */  
  public function executeSelfPassword()
  {
  	//Show the form
    if ($this->getRequest()->getMethod() != sfRequest::POST)
    {
	    $this->user = UserPeer::retrieveByPk($this->getUser()->getAttribute('user_id',0 , 'athlete'));
	    $this->forward404Unless($this->user);
      // display the form
      $this->getRequest()->getParameterHolder()->set('referer', $this->getRequest()->getReferer());

      return sfView::SUCCESS;
    }
    //Update the data
    else
    {
      // handle the form submission
      // redirect to last page
      $this->user = UserPeer::retrieveByPk($this->getUser()->getAttribute('user_id',0 , 'athlete'));
      $this->forward404Unless($this->user);
      $this->user->setPassword($this->getRequestParameter('new_password'));
      $this->user->save();
      return $this->redirect('@user_self');
    }
  } 
  
  /**
   * Action to show again the form edit self password when anything fails
   *
   * @return unknown
   */
  public function handleErrorSelfPassword()
  {
    $this->user = UserPeer::retrieveByPk($this->getUser()->getAttribute('user_id',0 , 'athlete'));
    $this->forward404Unless($this->user);
    return sfView::SUCCESS;
  }
  

  /**
   * Action that show a form to recover the password of an user
   *
   */  
  public function executeSelfRememberPassword()
  {
    if ($this->getRequest()->getMethod() != sfRequest::POST)
    {
      // display the form

      return sfView::SUCCESS;
    }
    else
    {
    	$c = new Criteria();
      $c->add(UserPeer::EMAIL, $this->getRequestParameter('email'));
      $user = UserPeer::doSelectOne($c);
    	
      if ($user)
		  {
		    // set new random password
		    $password = $user->generatePassword();
		 
		    $this->getRequest()->setAttribute('password', $password);
		    $this->getRequest()->setAttribute('nickname', $user->getNickname());
		 
		    $raw_email = $this->sendEmail('mail', 'sendPassword');
		    $this->logMessage($raw_email, 'debug');
		 
		    // save new password
		    $user->save();
		 
		    return 'MailSent';
		  }
		  else
		  {
		    $this->getRequest()->setError('email', 'There is no gesport user with this email address. Please try again');
		 
		    return sfView::SUCCESS;
		  }
		      
      // handle the form submission
      // redirect to last page
      return $this->redirect($this->getRequestParameter('referer', '@enter'));
    }
  } 
  
  
  /**
   * Action to show again the form self remeber password when anything fails
   *
   * @return unknown
   */
  public function handleErrorSelfRememberPassword()
  {
    return sfView::SUCCESS;
  }
 
	//Coach functions
	/**
	 * This functions list only the users that the coach registered session train.
	 * It allows the access to the user informations than can modify a coach and
	 *   that can consult a coach. Starting by the seasons and the current season.
	 */
  public function executeMyAthletes()
  {
    $this->actionShow='athlete_show';
    $this->actionEdit='athlete_edit';
    $this->actionCurrentSeason='season_show_current';
    $this->actionSeasons='seasons_athlete';
    $this->user= UserPeer::retrieveByPK($this->getUser()->getAttribute('user_id',0 , 'athlete'));
    $this->forward404Unless($this->user);
    
    $this->users = $this->user->getUsersRelatedByCoachId();
  }

  /**
   * Action that creates a new athlete, show the form to fill the fields and recover 
   * the information to save it. The athlete is trained by the user (coach) that created it
   *
   */  
  public function executeAthleteCreate()
  {
    //Show the form
    if ($this->getRequest()->getMethod() != sfRequest::POST)
    {
      $this->user = new User();
      $this->coach = UserPeer::retrieveByPk($this->getUser()->getAttribute('user_id',0 , 'athlete'));
      $this->forward404Unless($this->user);
      $this->forward404Unless($this->coach);
      // display the form
      $this->form_action="athleteCreate";
      $this->getRequest()->getParameterHolder()->set('referer', $this->getRequest()->getReferer());

      return sfView::SUCCESS;
    }
    //Recover data and create the user
    else
    {
      // handle the form submission
      $this->user = new User();
      $this->coach = UserPeer::retrieveByPk($this->getUser()->getAttribute('user_id',0 , 'athlete'));
      $this->forward404Unless($this->user);  
      $this->forward404Unless($this->coach); 
      $user=$this->update($this->user);
      if ($this->getRequestParameter('born_at'))
      {
        list($d, $m, $y) = sfI18N::getDateForCulture($this->getRequestParameter('born_at'), $this->getUser()->getCulture());
        $user->setBornAt("$y-$m-$d");
      }
      
      //generate the password for the new user
      $password = $user->generatePassword();

      //Send the email to the user with the password
      $this->getRequest()->setAttribute('password', $password);
      $this->getRequest()->setAttribute('nickname', $user->getNickname());
      $this->getRequest()->setAttribute('name', $user->__toString());
     
      $raw_email = $this->sendEmail('mail', 'createUser');
      //debur function (noly in dev mode)
      $this->logMessage($raw_email, 'debug');
        
      $user->save();
      
      // redirect to the page of the new user
      return $this->redirect('@athlete_show?id='.$user->getId());
    }
  }
  
  
  /**
   * Action to show again the form create when anything fails
   *
   * @return unknown
   */
  public function handleErrorAthleteCreate()
  {
    $this->user = new User();
    $this->user = $this->update($this->user);
    $this->coach = UserPeer::retrieveByPk($this->getUser()->getAttribute('user_id',0 , 'athlete'));
    $this->forward404Unless($this->coach); 
    $this->forward404Unless($this->user);
    return sfView::SUCCESS;
  }

 
  /**
   * Action that edits an user (athlete), show the form to fill the fields and recover 
   * the information to save it
   *
   */   
  public function executeAthleteEdit()
  {
    //Show the form
    if ($this->getRequest()->getMethod() != sfRequest::POST)
    {
      $this->user = UserPeer::retrieveByPk($this->getRequestParameter('id'));
      $this->coach = UserPeer::retrieveByPk($this->getUser()->getAttribute('user_id',0 , 'athlete'));
      $this->forward404Unless($this->user);
      $this->forward404Unless($this->coach);
      $this->forwardIf($this->user->getCoachId()!=$this->getUser()->getAttribute('user_id',0 , 'athlete'), 'content', 'notAllowed');
      // display the form
      $this->form_action="athleteEdit";
      $this->getRequest()->getParameterHolder()->set('referer', $this->getRequest()->getReferer());

      return sfView::SUCCESS;
    }
    //Recover data and create the user
    else
    {
      // handle the form submission
      $this->user = UserPeer::retrieveByPk($this->getRequestParameter('id'));
      $this->coach = UserPeer::retrieveByPk($this->getUser()->getAttribute('user_id',0 , 'athlete'));
      $this->forward404Unless($this->user); 
      $this->forward404Unless($this->coach);
      $this->forwardIf($this->user->getCoachId()!=$this->getUser()->getAttribute('user_id',0 , 'athlete'), 'content', 'notAllowed');
      $user=$this->update($this->user);
      if ($this->getRequestParameter('born_at'))
      {
        list($d, $m, $y) = sfI18N::getDateForCulture($this->getRequestParameter('born_at'), $this->getUser()->getCulture());
        $user->setBornAt("$y-$m-$d");
      }  
      
      $user->save();
      
      // redirect to the page of the new user
      return $this->redirect('@athlete_show?id='.$user->getId());
    }
  }
  
  
  /**
   * Action to show again the form edit when anything fails
   *
   * @return unknown
   */
  public function handleErrorAthleteEdit()
  {
    $this->user = new User();
    $this->user = $this->update($this->user);
    $this->coach = UserPeer::retrieveByPk($this->getUser()->getAttribute('user_id',0 , 'athlete'));
    $this->forward404Unless($this->coach); 
    $this->forward404Unless($this->user);
    $this->forwardIf($this->user->getCoachId()!=$this->getUser()->getAttribute('user_id',0 , 'athlete'), 'content', 'notAllowed');
    return sfView::SUCCESS;
  }
  
  /**
   * Show an User, the information that is related to the coach view.
   *
   */
  public function executeAthleteShow()
  {
    $this->actionList='athletes';
    $this->actionEdit='athlete_edit';
    $this->user = UserPeer::retrieveByPk($this->getRequestParameter('id'));
    $this->forward404Unless($this->user);
    $this->season = SeasonPeer::retrieveCurrentByUserId($this->getRequestParameter('id'));
    $this->forwardIf($this->user->getCoachId()!=$this->getUser()->getAttribute('user_id',0 , 'athlete'), 'content', 'notAllowed');
  }
  
  //Auxiliary functions
  /**
   *  Function to save an user data from the fields of a form
   */
  protected function update($user){
    $user->setNickname($this->getRequestParameter('nickname'));
    $user->setFirstName($this->getRequestParameter('first_name'));
    $user->setLastName($this->getRequestParameter('last_name'));
    $user->setIsCoach($this->getRequestParameter('is_coach', 0));
    $user->setIsAthlete($this->getRequestParameter('is_athlete', 0));
    $user->setIsMale($this->getRequestParameter('is_male', 0));
    $user->setCoachId($this->getRequestParameter('coach_id') ? $this->getRequestParameter('coach_id') : null);
    $user->setIsAdmin($this->getRequestParameter('is_admin', 0));
    //$user->setPictureId($this->getRequestParameter('picture_id', 0));
    $user->setEmail($this->getRequestParameter('email', 0));
    if ($this->getRequestParameter('language')){
      $user->setLanguage($this->getRequestParameter('language', 0));
    }
    if ($this->getRequestParameter('country')){
      $user->setCountry($this->getRequestParameter('country', 0));
    }
    return $user;
  }
}
