<?php
// auto-generated by sfPropelCrud
// date: 2008/11/11 20:22:38

/**
 * Template to show the form to edit an athlete
 * 
 * @author Diego Cebrián
 * @package    frontend
 * @subpackage modules-user-templates
 * @uses User user: the user to edit
 * @uses User coach: the coacho of the user to edit
 */
?>
<?php use_helper('Object') ?>
<?php use_helper('Validation') ?>
 
<?php slot('header'); ?>
<?php echo image_tag('admin/help', 'alt=help class=error_ico')?>
  <h1 class="help"><?php echo __('Help for').': '.__('Edit athlete') ?></h1>
  <p class="help"><?php echo __('Enter the requested data') ?></p>
  <p class="help"><?php echo __('Emphasided fields are mandatory').': <label class="mandatory">'.__('Mandatory field').'</label>' ?></p>
  <p class="help"><?php echo __('Clicking on the button closed to date field will display a dynamic calendar') ?></p>
  <p class="help"><?php echo __('For manual date editing, please use this format').': '.format_date('1981-06-20') ?></p>
<?php end_slot(); ?>

<h1><?php echo __('Athlete edition')?></h1>

<?php echo form_tag('@athlete_edit?id='.$user->getId()) ?>

<?php echo object_input_hidden_tag($user, 'getId') ?>

  <div class="form_row">
    <?php echo __(form_error('nickname')) ?>
    <div class="form_label_left"><label for="nickname" class="mandatory"><?php echo __('Nickname')?>:</label></div>
    <div class="form_field_left"><?php echo $user->getNickname();  ?><?php echo object_input_hidden_tag($user, 'getNickname') ?></div>
  </div>
  <div class="form_row">
    <div class="form_label_left"><label for="first_name"><?php echo __('First name')?>:</label></div>
    <div class="form_field_left"><?php echo object_input_tag($user, 'getFirstName', array (
  'size' => 40,
)) ?></div>
  </div>
  <div class="form_row">
    <div class="form_label_left"><label for="last_name"><?php echo __('Last name')?>:</label></div>
    <div class="form_field_left"><?php echo object_input_tag($user, 'getLastName', array (
  'size' => 40,
)) ?></div>
  </div>
  <div class="form_row">
    <?php echo __(form_error('born_at')) ?>
    <div class="form_label_left"><label for="born_at" class="mandatory"><?php echo __('Born at')?>:</label></div>
    <div class="form_field_left"><?php echo object_input_date_tag($user, 'getBornAt', array (
  'rich' => true,
)) ?></div>
  </div>
  <?php echo object_input_hidden_tag($user, 'getIsAdmin') ?>
  <?php echo object_input_hidden_tag($user, 'getIsCoach') ?>
  <?php echo input_hidden_tag('is_athlete', '1') ?>
  <div class="form_row">
	    <div class="form_label_left"><label for="is_male"><?php echo __('Sex') ?>:</label></div>
	    <div class="form_field_left"><?php echo select_tag('is_male', options_for_select(array(
	  __('Female'),
	  __('Male'),
	), $user->getIsMale())) ?>
  </div>
  </div>
  <div class="form_row">
    <div class="form_label_left"><label for="coach"><?php echo __('Coach')?>:</label></div>
    <div class="form_field_left"><?php echo input_hidden_tag('coach_id', $coach->getId()) ?><?php echo $coach->__toString() ?></div>
  </div>
  <div class="form_row">
    <?php echo __(form_error('email')) ?>
    <div class="form_label_left"><label for="email" class="mandatory"><?php echo __('Email')?>:</label></div>
    <div class="form_field_left"><?php echo $user->getEmail() ?> <?php echo object_input_hidden_tag($user, 'getEmail', array (
  'size' => 40,
)) ?></div>
  </div>
  
  <div class="form_row">
    <div class="form_label_left"><label for="nationality"><?php echo __('Nationality')?>:</label></div>
    <div class="form_field_left"><?php echo object_select_country_tag($user, 'getCountry') ?></div>
  </div>
  
  <div class="form_row">
    <div class="form_label_left"><label for="language"><?php echo __('Language')?>:</label></div>
    <div class="form_field_left"><?php echo object_select_language_tag($user, 'getLanguage') ?></div>
  </div>
<hr />
<?php echo submit_tag(__('Save')) ?>
<?php if ($user->getId()): ?>
  &nbsp;<?php echo link_to(__('Cancel'), '@athlete_show?id='.$user->getId()) ?>
<?php else: ?>
  &nbsp;<?php echo link_to(__('Cancel'), '@athlete_show?id='.$user->getId()) ?>
<?php endif; ?>
</form>
