<?php
// auto-generated by sfPropelCrud
// date: 2008/11/11 20:22:38

/**
 * Template to show the form to create an user
 * 
 * @author Diego Cebrián
 * @package    frontend
 * @subpackage modules-user-templates
 * @uses User user: the empty user to edit
 */
?>
 
<?php slot('header'); ?>
<?php echo image_tag('admin/help', 'alt=help class=error_ico')?>
  <h1 class="help"><?php echo __('Help for').': '.__('Create user') ?></h1>
  <p class="help"><?php echo __('Enter the requested data') ?></p>
  <p class="help"><?php echo __('Emphasided fields are mandatory').': <label class="mandatory">'.__('Mandatory field').'</label>' ?></p>
  <p class="help"><?php echo __('Clicking on the button closed to date field will display a dynamic calendar') ?></p>
  <p class="help"><?php echo __('For manual date editing, please use this format').': '.format_date('1981-06-20') ?></p>
<?php end_slot(); ?>

<?php use_helper('Object') ?>
<?php use_helper('Validation') ?>

<h1><?php echo __('User')?></h1>

<?php echo form_tag('@user_create?id='.$user->getId()) ?>

<?php echo object_input_hidden_tag($user, 'getId') ?>

  <div class="form_row">
    <?php echo __(form_error('nickname')) ?>
    <div class="form_label_left"><label for="nickname" class="mandatory"><?php echo __('Nickname')?>:</label></div>
    <div class="form_field_left"><?php echo object_input_tag($user, 'getNickname', array (
  'size' => 15,
)) ?></div>
  </div>
  <div class="form_row">
    <div class="form_label_left"><label for="first_name"><?php echo __('First name')?>:</label></div>
    <div class="form_field_left"><?php echo object_input_tag($user, 'getFirstName', array (
  'size' => 40,
)) ?></div>
  </div>
  <div class="form_row">
    <div class="form_label_left"><label for="last_name"><?php echo __('Last name')?>:</label></div>
    <div class="form_field_left"><?php echo object_input_tag($user, 'getLastName', array (
  'size' => 40,
)) ?></div>
  </div>
  <div class="form_row">
    <?php echo __(form_error('born_at')) ?>
    <div class="form_label_left"><label for="born_at" class="mandatory"><?php echo __('Born at')?>:</label></div>
    <div class="form_field_left"><?php echo object_input_date_tag($user, 'getBornAt', array (
  'rich' => true,
)) ?></div>
  </div>
  <div class="form_row">
    <div class="form_label_left"><label for="is_male"><?php echo __('Sex') ?>:</label></div>
    <div class="form_field_left"><?php echo select_tag('is_male', options_for_select(array(
  __('Female'),
  __('Male'),
), $user->getIsMale())) ?>
    </div>
  </div>
  <div class="form_row">
    <div class="form_label_left"><label for="is_coach"><?php echo __('Is coach')?>:</label></div>
    <div class="form_field_left"><?php echo object_checkbox_tag($user, 'getIsCoach', array (
)) ?></div>
  </div>
  <div class="form_row">
    <div class="form_label_left"><label for="is_athlete"><?php echo __('Is athlete')?>:</label></div>
    <div class="form_field_left"><?php echo object_checkbox_tag($user, 'getIsAthlete', array (
)) ?></div>
  </div>
  <div class="form_row">
    <div class="form_label_left"><label for="is_admin"><?php echo __('Is admin')?>:</label></div>
    <div class="form_field_left"><?php echo object_checkbox_tag($user, 'getIsAdmin', array (
)) ?></div>
  </div>
  <div class="form_row">
    <div class="form_label_left"><label for="coach"><?php echo __('Coach')?>:</label></div>
    <div class="form_field_left">
	    <?php // echo select_tag('coach_id', objects_for_select(UserPeer::retrieveCoachs(new Criteria()),'getId', '__toString', $user->getCoachId())) ;?>
	    <?php echo object_select_tag($user, 'getCoachId', array(
	    'related_class'=>'User', 
	    'peer_method'=>'retrieveCoachs', 
	    'include_blank' => true,)) ?>
    </div>
  </div>
  <div class="form_row">
    <?php echo __(form_error('email')) ?>
    <div class="form_label_left"><label for="email" class="mandatory"><?php echo __('Email')?>:</label></div>
    <div class="form_field_left"><?php echo object_input_tag($user, 'getEmail', array (
  'size' => 40,
)) ?></div>
  </div>
  
  <div class="form_row">
    <div class="form_label_left"><label for="nationality"><?php echo __('Nationality')?>:</label></div>
    <div class="form_field_left"><?php echo object_select_country_tag($user, 'getCountry') ?></div>
  </div>
  
  <div class="form_row">
    <div class="form_label_left"><label for="language"><?php echo __('Language')?>:</label></div>
    <div class="form_field_left"><?php echo object_select_language_tag($user, 'getLanguage') ?></div>
  </div>
<hr />
<?php echo submit_tag(__('Save')) ?>
<?php if ($user->getId()): ?>
  &nbsp;<?php echo link_to(__('Delete'), '@user_delete?id='.$user->getId(), 'post=true&confirm='.__('Are you sure?')) ?>
  &nbsp;<?php echo link_to(__('Cancel'), '@users') ?>
<?php else: ?>
  &nbsp;<?php echo link_to(__('Cancel'), '@users') ?>
<?php endif; ?>
</form>
