<?php

/**
 * Subclass for representing a row from the 'article' table.
 *
 * 
 *

 * @package lib
 * @subpackage model
 * @author Diego Cebrián
 */ 

/**
 * @package lib
 * @subpackage model
 * @author Diego Cebrián
 *
 */ 
class Article extends BaseArticle
{
  /**
   * Get the current or param passed description
   *
   * @return string
   * @param string $culture = null
   */
  function getTitle($culture=null) {
  	if($culture){
      parent::setCulture($culture);
  	}else{
      parent::setCulture(sfContext::getInstance()->getUser()->getCulture());
  	}
    return parent::getTitle();
  }
  
  /**
   * Set the current or param passed title
   *
   * @param string $description
   * @param string $culture = null
   */
  function setTitle($description, $culture=null) {
    if($culture){
      parent::setCulture($culture);
    }else{
      parent::setCulture(sfContext::getInstance()->getUser()->getCulture());
    }
    parent::setTitle($description);
  }
  
  /**
   * Get the current or param passed text
   *
   * @return string
   * @param string $culture = null
   */
  function getText($culture=null) {  
    if($culture){
      parent::setCulture($culture);
    }else{
      parent::setCulture(sfContext::getInstance()->getUser()->getCulture());
    }
    return parent::getText();
  }
  
  /**
   * Set the current or param passed description
   *
   * @param string $description
   * @param string $culture = null
   */
  function setText($description, $culture=null) {
    if($culture){
      parent::setCulture($culture);
    }else{
      parent::setCulture(sfContext::getInstance()->getUser()->getCulture());
    }
    parent::setText($description);
  }
  
	
	/**
	 * Magic function to print when echo Object is called  
	 *
	 * @return string description of the object
   * @param string $culture = null
	 */
	function __toString() {	
		parent::setCulture(sfContext::getInstance()->getUser()->getCulture());
		return parent::getText();
	}
}
