<?php

/**
 * Subclass for performing query and update operations on the 'macrocycle' table.
 *
 * 
 *
 * @package lib
 * @subpackage model
 * @author Diego Cebrián
 */ 

/**
 * @package lib
 * @subpackage model
 * @author Diego Cebrián
 *
 */ 
class MacrocyclePeer extends BaseMacrocyclePeer
{

  public static function retrieveCurrentByUserId($user_id) {
    $c=new Criteria();
    $c->addJoin(MacrocyclePeer::SEASON_ID, SeasonPeer::ID);
    $c->add(SeasonPeer::USER_ID, $user_id);
    $c->add(MacrocyclePeer::START_AT, date('Y-m-d'), Criteria::LESS_EQUAL);
    $c->add(MacrocyclePeer::LAST_DAY_AT, date("Y-m-d"), Criteria::GREATER_EQUAL);
    return MacrocyclePeer::doSelectOne($c);
  }
  
  public static function retrieveByUserIdAndPk($user_id,$pk) {
    $c=new Criteria();
    $c->addJoin(MacrocyclePeer::SEASON_ID, SeasonPeer::ID);
    $c->add(SeasonPeer::USER_ID, $user_id);
    $c->add(MacrocyclePeer::ID, $pk);
    return MacrocyclePeer::doSelectOne($c);
  } 
}
