<?php

/**
 * Subclass for representing a row from the 'mesocycle' table.
 *
 * 
 *

 * @package lib
 * @subpackage model
 * @author Diego Cebrián
 */ 

/**
 * @package lib
 * @subpackage model
 * @author Diego Cebrián
 *
 */ 
class Mesocycle extends BaseMesocycle
{ 
  /**
   * Method to return a description when echo variable is called
   *
   * @return description of the mesocycle
   */
	public function __toString() {	
		return parent::getDescription();
	}  
	
	/**
	 * Get the season for this period
	 *
	 * @return the object seeason that contents this period
	 */
	public function getSeason() {
		return $this->getMacrocycle()->getSeason();
	}
	
	
  /**
   * @method getIntensity1LowLimit
   * @return Value of the Low limit of the first intensity level 
   */
  public function getIntensity1LowLimit() {
    return $this->getSeason()->getIntensity1LowLimit();
  }
  /**
   * @method getIntensity1HighLimit
   * @return Value of the High limit of the first intensity level 
   */
  public function getIntensity1HighLimit() {
    return $this->getSeason()->getIntensity1HighLimit();
  }

  /**
   * @method getIntensity2LowLimit
   * @return Value of the Low limit of the second intensity level 
   */
  public function getIntensity2LowLimit() {
    return $this->getSeason()->getIntensity2LowLimit();
  }
  /**
   * @method getIntensity2HighLimit
   * @return Value of the High limit of the second intensity level 
   */
  public function getIntensity2HighLimit() {
    return $this->getSeason()->getIntensity2HighLimit();
  }

  /**
   * @method getIntensity3LowLimit
   * @return Value of the Low limit of the third intensity level 
   */
  public function getIntensity3LowLimit() {
    return $this->getSeason()->getIntensity3LowLimit();
  }
  /**
   * @method getIntensity3HighLimit
   * @return Value of the High limit of the third intensity level 
   */
  public function getIntensity3HighLimit() {
    return $this->getSeason()->getIntensity3HighLimit();
  }
  /**
   * Retrieve the Volume unit from the correspondant season
   *
   * @return Unit
   */
  public function getVolumeUnit() {
    return $this->getSeason()->getVolumeUnit();
  }

  public function calculateReportedValues(){
    $intensity1=0;
    foreach ($this->getMicrocycles() as $period){
      $intensity1+=$period->getReportedIntensity1(); 
    }
    parent::setReportedIntensity1($intensity1);
    $intensity2=0;
    foreach ($this->getMicrocycles() as $period){
      $intensity2+=$period->getReportedIntensity2(); 
    }
    parent::setReportedIntensity2($intensity2);
    $intensity3=0;
    foreach ($this->getMicrocycles() as $period){
      $intensity3+=$period->getReportedIntensity3(); 
    }
    parent::setReportedIntensity3($intensity3);
    $volume=0;
    foreach ($this->getMicrocycles() as $period){
      $volume+=$period->getReportedVolume(); 
    }
    parent::setReportedVolume($volume);
    $this->save();
    $this->getMacrocycle()->calculateReportedValues();
  }
}
