<?php

/**
 * Subclass for performing query and update operations on the 'microcycle' table.
 *
 * 
 *

 * @package lib
 * @subpackage model
 * @author Diego Cebrián
 */ 

/**
 * @package lib
 * @subpackage model
 * @author Diego Cebrián
 *
 */ 
class MicrocyclePeer extends BaseMicrocyclePeer
{
  public static function retrieveCurrentByUserId($user_id) {
    $c=new Criteria();
    $c->addJoin(MicrocyclePeer::MESOCYCLE_ID, MesocyclePeer::ID);
    $c->addJoin(MesocyclePeer::MACROCYCLE_ID, MacrocyclePeer::ID);
    $c->addJoin(MacrocyclePeer::SEASON_ID, SeasonPeer::ID);
    $c->add(SeasonPeer::USER_ID, $user_id);
    $c->add(MicrocyclePeer::START_AT, date('Y-m-d'), Criteria::LESS_EQUAL);
    $c->add(MicrocyclePeer::LAST_DAY_AT, date("Y-m-d"), Criteria::GREATER_EQUAL);
    return MicrocyclePeer::doSelectOne($c);
  }
  
  public static function retrieveByUserIdAndPk($user_id,$pk) {
    $c=new Criteria();
    $c->addJoin(MicrocyclePeer::MESOCYCLE_ID, MesocyclePeer::ID);
    $c->addJoin(MesocyclePeer::MACROCYCLE_ID, MacrocyclePeer::ID);
    $c->addJoin(MacrocyclePeer::SEASON_ID, SeasonPeer::ID);
    $c->add(SeasonPeer::USER_ID, $user_id);
    $c->add(MicrocyclePeer::ID, $pk);
    return MicrocyclePeer::doSelectOne($c);
  } 
}
