<?php

/**
 * Subclass for representing a row from the 'season' table.
 *
 * 
 *
 * @package lib
 * @subpackage model
 * @author Diego Cebrián
 */ 

/**
 * @package lib
 * @subpackage model
 * @author Diego Cebrián
 *
 */
class Season extends BaseSeason
{
  
  /**
   * Method to return a description when echo variable is called
   *
   * @return description of the season
   */
	public function __toString() {	
		return parent::getDescription();
	}


  /**
   * getIntensity2LowLimit
   * @return Value of the Low limit of the second intensity level 
   */
  public function getIntensity2LowLimit() {
    return (parent::getIntensity1HighLimit()+1);
  }

  /**
   * getIntensity3LowLimit
   * @return Value of the Low limit of the second intensity level 
   */
  public function getIntensity3LowLimit() {
    return (parent::getIntensity2HighLimit()+1);
  }
  /**
   * Overloaded method to make recovering the VolumeUnit attribute easyest
   *
   * @return the object Unit that is the intensity unit
   */
  public function getVolumeUnit(){
    return parent::getUnitRelatedByVolumeUnitId();
  }

  public function calculateReportedValues(){
    $intensity1=0;
    foreach ($this->getMacrocycles() as $period){
      $intensity1+=$period->getReportedIntensity1(); 
    }
    parent::setReportedIntensity1($intensity1);
    $intensity2=0;
    foreach ($this->getMacrocycles() as $period){
      $intensity2+=$period->getReportedIntensity2(); 
    }
    parent::setReportedIntensity2($intensity2);
    $intensity3=0;
    foreach ($this->getMacrocycles() as $period){
      $intensity3+=$period->getReportedIntensity3(); 
    }
    parent::setReportedIntensity3($intensity3);
    $volume=0;
    foreach ($this->getMacrocycles() as $period){
      $volume+=$period->getReportedVolume(); 
    }
    parent::setReportedVolume($volume);
    $this->save();
  }

}
