<?php

/**
 * Subclass for representing a row from the 'session' table.
 *
 * 
 *

 * @package lib
 * @subpackage model
 * @author Diego Cebrián
 */ 

/**
 * @package lib
 * @subpackage model
 * @author Diego Cebrián
 *
 */ 
class Session extends BaseSession
{
  /**
   * Method to return a description when echo variable is called
   *
   * @return description of the session
   */
	public function __toString() {	
		return format_date(parent::getDate());
	}

  /**
   * Get the season for this period
   *
   * @return the object seeason that contents this period
   */
  public function getSeason() {
    return $this->getMicrocycle()->getMesocycle()->getMacrocycle()->getSeason();
  }
  
  
  /**
   * @method getIntensity1LowLimit
   * @return Value of the Low limit of the first intensity level 
   */
  public function getIntensity1LowLimit() {
    return $this->getSeason()->getIntensity1LowLimit();
  }
  /**
   * @method getIntensity1HighLimit
   * @return Value of the High limit of the first intensity level 
   */
  public function getIntensity1HighLimit() {
    return $this->getSeason()->getIntensity1HighLimit();
  }

  /**
   * @method getIntensity2LowLimit
   * @return Value of the Low limit of the second intensity level 
   */
  public function getIntensity2LowLimit() {
    return $this->getSeason()->getIntensity2LowLimit();
  }
  /**
   * @method getIntensity2HighLimit
   * @return Value of the High limit of the second intensity level 
   */
  public function getIntensity2HighLimit() {
    return $this->getSeason()->getIntensity2HighLimit();
  }

  /**
   * @method getIntensity3LowLimit
   * @return Value of the Low limit of the third intensity level 
   */
  public function getIntensity3LowLimit() {
    return $this->getSeason()->getIntensity3LowLimit();
  }
  /**
   * @method getIntensity3HighLimit
   * @return Value of the High limit of the third intensity level 
   */
  public function getIntensity3HighLimit() {
    return $this->getSeason()->getIntensity3HighLimit();
  }
  /**
   * Retrieve the Volume unit from the correspondant season
   *
   * @return Unit
   */
  public function getVolumeUnit() {
    return $this->getSeason()->getVolumeUnit();
  }
}
