<?php

/**
 * Subclass for performing query and update operations on the 'session' table.
 *
 * 
 *

 * @package lib
 * @subpackage model
 * @author Diego Cebrián
 */ 

/**
 * @package lib
 * @subpackage model
 * @author Diego Cebrián
 *
 */ 
class SessionPeer extends BaseSessionPeer
{
	/**
	 * Recover the sessions for today
	 *
	 * @param integer $user_id
	 * @return array of Sessions
	 */
  public static function retrieveCurrentByUserId($user_id) {
    $c=new Criteria();
    $c->addJoin(SessionPeer::MICROCYCLE_ID, MicrocyclePeer::ID);
    $c->addJoin(MicrocyclePeer::MESOCYCLE_ID, MesocyclePeer::ID);
    $c->addJoin(MesocyclePeer::MACROCYCLE_ID, MacrocyclePeer::ID);
    $c->addJoin(MacrocyclePeer::SEASON_ID, SeasonPeer::ID);
    $c->add(SeasonPeer::USER_ID, $user_id);
    $c->add(SessionPeer::DATE, date('Y-m-d'));
    return SessionPeer::doSelect($c);
  }
  
  public static function retrieveByUserIdAndPk($user_id,$pk) {
    $c=new Criteria();
    $c->add(SessionPeer::ID, $pk);
    $c->addJoin(SessionPeer::MICROCYCLE_ID, MicrocyclePeer::ID);
    $c->addJoin(MicrocyclePeer::MESOCYCLE_ID, MesocyclePeer::ID);
    $c->addJoin(MesocyclePeer::MACROCYCLE_ID, MacrocyclePeer::ID);
    $c->addJoin(MacrocyclePeer::SEASON_ID, SeasonPeer::ID);
    $c->add(SeasonPeer::USER_ID, $user_id);
    return SessionPeer::doSelectOne($c);
  } 
  
  public static function retrieveByUserIdAndDate($user_id) {
    $c=new Criteria();
    $c->add(SessionPeer::DATE, date('Y-m-d'));
    $c->addJoin(SessionPeer::MICROCYCLE_ID, MicrocyclePeer::ID);
    $c->addJoin(MicrocyclePeer::MESOCYCLE_ID, MesocyclePeer::ID);
    $c->addJoin(MesocyclePeer::MACROCYCLE_ID, MacrocyclePeer::ID);
    $c->addJoin(MacrocyclePeer::SEASON_ID, SeasonPeer::ID);
    $c->add(SeasonPeer::USER_ID, $user_id);
    return SessionPeer::doSelect($c);
  } 
  
  public static function retrieveNotReportedByUserId($user_id) {
    $c=new Criteria();
    $c->add(SessionPeer::REPORTED, 0);
    $c->addJoin(SessionPeer::MICROCYCLE_ID, MicrocyclePeer::ID);
    $c->addJoin(MicrocyclePeer::MESOCYCLE_ID, MesocyclePeer::ID);
    $c->addJoin(MesocyclePeer::MACROCYCLE_ID, MacrocyclePeer::ID);
    $c->addJoin(MacrocyclePeer::SEASON_ID, SeasonPeer::ID);
    $c->add(SeasonPeer::USER_ID, $user_id);
    return SessionPeer::doSelect($c);
  } 
}
