<?php



class SeasonMapBuilder {

	
	const CLASS_NAME = 'lib.model.map.SeasonMapBuilder';

	
	private $dbMap;

	
	public function isBuilt()
	{
		return ($this->dbMap !== null);
	}

	
	public function getDatabaseMap()
	{
		return $this->dbMap;
	}

	
	public function doBuild()
	{
		$this->dbMap = Propel::getDatabaseMap('propel');

		$tMap = $this->dbMap->addTable('season');
		$tMap->setPhpName('Season');

		$tMap->setUseIdGenerator(true);

		$tMap->addPrimaryKey('ID', 'Id', 'int', CreoleTypes::INTEGER, true, null);

		$tMap->addColumn('DESCRIPTION', 'Description', 'string', CreoleTypes::VARCHAR, false, 250);

		$tMap->addColumn('START_AT', 'StartAt', 'int', CreoleTypes::DATE, false, null);

		$tMap->addColumn('LAST_DAY_AT', 'LastDayAt', 'int', CreoleTypes::DATE, false, null);

		$tMap->addForeignKey('USER_ID', 'UserId', 'int', CreoleTypes::INTEGER, 'user', 'ID', false, null);

		$tMap->addForeignKey('VOLUME_UNIT_TYPE_ID', 'VolumeUnitTypeId', 'int', CreoleTypes::INTEGER, 'unit_type', 'ID', false, null);

		$tMap->addColumn('THEORIC_VOLUME', 'TheoricVolume', 'double', CreoleTypes::DOUBLE, false, null);

		$tMap->addColumn('REPORTED_VOLUME', 'ReportedVolume', 'double', CreoleTypes::DOUBLE, false, null);

		$tMap->addForeignKey('VOLUME_UNIT_ID', 'VolumeUnitId', 'int', CreoleTypes::INTEGER, 'unit', 'ID', false, null);

		$tMap->addForeignKey('VOLUME_SHOW_UNIT_ID', 'VolumeShowUnitId', 'int', CreoleTypes::INTEGER, 'unit', 'ID', false, null);

		$tMap->addColumn('THEORIC_INTENSITY1', 'TheoricIntensity1', 'double', CreoleTypes::DOUBLE, false, null);

		$tMap->addColumn('REPORTED_INTENSITY1', 'ReportedIntensity1', 'double', CreoleTypes::DOUBLE, false, null);

		$tMap->addColumn('INTENSITY1_LOW_LIMIT', 'Intensity1LowLimit', 'double', CreoleTypes::DOUBLE, false, null);

		$tMap->addColumn('INTENSITY1_HIGH_LIMIT', 'Intensity1HighLimit', 'double', CreoleTypes::DOUBLE, false, null);

		$tMap->addColumn('THEORIC_INTENSITY2', 'TheoricIntensity2', 'double', CreoleTypes::DOUBLE, false, null);

		$tMap->addColumn('REPORTED_INTENSITY2', 'ReportedIntensity2', 'double', CreoleTypes::DOUBLE, false, null);

		$tMap->addColumn('INTENSITY2_HIGH_LIMIT', 'Intensity2HighLimit', 'double', CreoleTypes::DOUBLE, false, null);

		$tMap->addColumn('THEORIC_INTENSITY3', 'TheoricIntensity3', 'double', CreoleTypes::DOUBLE, false, null);

		$tMap->addColumn('REPORTED_INTENSITY3', 'ReportedIntensity3', 'double', CreoleTypes::DOUBLE, false, null);

		$tMap->addColumn('INTENSITY3_HIGH_LIMIT', 'Intensity3HighLimit', 'double', CreoleTypes::DOUBLE, false, null);

	} 
} 