<?php



class SessionMapBuilder {

	
	const CLASS_NAME = 'lib.model.map.SessionMapBuilder';

	
	private $dbMap;

	
	public function isBuilt()
	{
		return ($this->dbMap !== null);
	}

	
	public function getDatabaseMap()
	{
		return $this->dbMap;
	}

	
	public function doBuild()
	{
		$this->dbMap = Propel::getDatabaseMap('propel');

		$tMap = $this->dbMap->addTable('session');
		$tMap->setPhpName('Session');

		$tMap->setUseIdGenerator(true);

		$tMap->addPrimaryKey('ID', 'Id', 'int', CreoleTypes::INTEGER, true, null);

		$tMap->addColumn('DATE', 'Date', 'int', CreoleTypes::DATE, false, null);

		$tMap->addColumn('MORNING_SESSION', 'MorningSession', 'boolean', CreoleTypes::BOOLEAN, false, null);

		$tMap->addColumn('FEEDBACK', 'Feedback', 'string', CreoleTypes::LONGVARCHAR, false, null);

		$tMap->addColumn('DESCRIPTION', 'Description', 'string', CreoleTypes::LONGVARCHAR, false, null);

		$tMap->addForeignKey('MICROCYCLE_ID', 'MicrocycleId', 'int', CreoleTypes::INTEGER, 'microcycle', 'ID', false, null);

		$tMap->addColumn('WAKE_UP_HR', 'WakeUpHr', 'double', CreoleTypes::DOUBLE, false, null);

		$tMap->addColumn('THEORIC_VOLUME', 'TheoricVolume', 'double', CreoleTypes::DOUBLE, false, null);

		$tMap->addColumn('REPORTED_VOLUME', 'ReportedVolume', 'double', CreoleTypes::DOUBLE, false, null);

		$tMap->addColumn('THEORIC_INTENSITY1', 'TheoricIntensity1', 'double', CreoleTypes::DOUBLE, false, null);

		$tMap->addColumn('REPORTED_INTENSITY1', 'ReportedIntensity1', 'double', CreoleTypes::DOUBLE, false, null);

		$tMap->addColumn('THEORIC_INTENSITY2', 'TheoricIntensity2', 'double', CreoleTypes::DOUBLE, false, null);

		$tMap->addColumn('REPORTED_INTENSITY2', 'ReportedIntensity2', 'double', CreoleTypes::DOUBLE, false, null);

		$tMap->addColumn('THEORIC_INTENSITY3', 'TheoricIntensity3', 'double', CreoleTypes::DOUBLE, false, null);

		$tMap->addColumn('REPORTED_INTENSITY3', 'ReportedIntensity3', 'double', CreoleTypes::DOUBLE, false, null);

		$tMap->addColumn('NEW_REPORT', 'NewReport', 'boolean', CreoleTypes::BOOLEAN, false, null);

		$tMap->addColumn('REPORTED', 'Reported', 'boolean', CreoleTypes::BOOLEAN, false, null);

	} 
} 