<?php


abstract class BaseSeason extends BaseObject  implements Persistent {


	
	protected static $peer;


	
	protected $id;


	
	protected $description;


	
	protected $start_at;


	
	protected $last_day_at;


	
	protected $user_id;


	
	protected $volume_unit_type_id;


	
	protected $theoric_volume;


	
	protected $reported_volume;


	
	protected $volume_unit_id;


	
	protected $volume_show_unit_id;


	
	protected $theoric_intensity1;


	
	protected $reported_intensity1;


	
	protected $intensity1_low_limit;


	
	protected $intensity1_high_limit;


	
	protected $theoric_intensity2;


	
	protected $reported_intensity2;


	
	protected $intensity2_high_limit;


	
	protected $theoric_intensity3;


	
	protected $reported_intensity3;


	
	protected $intensity3_high_limit;

	
	protected $aUser;

	
	protected $aUnitType;

	
	protected $aUnitRelatedByVolumeUnitId;

	
	protected $aUnitRelatedByVolumeShowUnitId;

	
	protected $collMacrocycles;

	
	protected $lastMacrocycleCriteria = null;

	
	protected $alreadyInSave = false;

	
	protected $alreadyInValidation = false;

	
	public function getId()
	{

		return $this->id;
	}

	
	public function getDescription()
	{

		return $this->description;
	}

	
	public function getStartAt($format = 'Y-m-d')
	{

		if ($this->start_at === null || $this->start_at === '') {
			return null;
		} elseif (!is_int($this->start_at)) {
						$ts = strtotime($this->start_at);
			if ($ts === -1 || $ts === false) { 				throw new PropelException("Unable to parse value of [start_at] as date/time value: " . var_export($this->start_at, true));
			}
		} else {
			$ts = $this->start_at;
		}
		if ($format === null) {
			return $ts;
		} elseif (strpos($format, '%') !== false) {
			return strftime($format, $ts);
		} else {
			return date($format, $ts);
		}
	}

	
	public function getLastDayAt($format = 'Y-m-d')
	{

		if ($this->last_day_at === null || $this->last_day_at === '') {
			return null;
		} elseif (!is_int($this->last_day_at)) {
						$ts = strtotime($this->last_day_at);
			if ($ts === -1 || $ts === false) { 				throw new PropelException("Unable to parse value of [last_day_at] as date/time value: " . var_export($this->last_day_at, true));
			}
		} else {
			$ts = $this->last_day_at;
		}
		if ($format === null) {
			return $ts;
		} elseif (strpos($format, '%') !== false) {
			return strftime($format, $ts);
		} else {
			return date($format, $ts);
		}
	}

	
	public function getUserId()
	{

		return $this->user_id;
	}

	
	public function getVolumeUnitTypeId()
	{

		return $this->volume_unit_type_id;
	}

	
	public function getTheoricVolume()
	{

		return $this->theoric_volume;
	}

	
	public function getReportedVolume()
	{

		return $this->reported_volume;
	}

	
	public function getVolumeUnitId()
	{

		return $this->volume_unit_id;
	}

	
	public function getVolumeShowUnitId()
	{

		return $this->volume_show_unit_id;
	}

	
	public function getTheoricIntensity1()
	{

		return $this->theoric_intensity1;
	}

	
	public function getReportedIntensity1()
	{

		return $this->reported_intensity1;
	}

	
	public function getIntensity1LowLimit()
	{

		return $this->intensity1_low_limit;
	}

	
	public function getIntensity1HighLimit()
	{

		return $this->intensity1_high_limit;
	}

	
	public function getTheoricIntensity2()
	{

		return $this->theoric_intensity2;
	}

	
	public function getReportedIntensity2()
	{

		return $this->reported_intensity2;
	}

	
	public function getIntensity2HighLimit()
	{

		return $this->intensity2_high_limit;
	}

	
	public function getTheoricIntensity3()
	{

		return $this->theoric_intensity3;
	}

	
	public function getReportedIntensity3()
	{

		return $this->reported_intensity3;
	}

	
	public function getIntensity3HighLimit()
	{

		return $this->intensity3_high_limit;
	}

	
	public function setId($v)
	{

		
		
		if ($v !== null && !is_int($v) && is_numeric($v)) {
			$v = (int) $v;
		}

		if ($this->id !== $v) {
			$this->id = $v;
			$this->modifiedColumns[] = SeasonPeer::ID;
		}

	} 
	
	public function setDescription($v)
	{

		
		
		if ($v !== null && !is_string($v)) {
			$v = (string) $v; 
		}

		if ($this->description !== $v) {
			$this->description = $v;
			$this->modifiedColumns[] = SeasonPeer::DESCRIPTION;
		}

	} 
	
	public function setStartAt($v)
	{

		if ($v !== null && !is_int($v)) {
			$ts = strtotime($v);
			if ($ts === -1 || $ts === false) { 				throw new PropelException("Unable to parse date/time value for [start_at] from input: " . var_export($v, true));
			}
		} else {
			$ts = $v;
		}
		if ($this->start_at !== $ts) {
			$this->start_at = $ts;
			$this->modifiedColumns[] = SeasonPeer::START_AT;
		}

	} 
	
	public function setLastDayAt($v)
	{

		if ($v !== null && !is_int($v)) {
			$ts = strtotime($v);
			if ($ts === -1 || $ts === false) { 				throw new PropelException("Unable to parse date/time value for [last_day_at] from input: " . var_export($v, true));
			}
		} else {
			$ts = $v;
		}
		if ($this->last_day_at !== $ts) {
			$this->last_day_at = $ts;
			$this->modifiedColumns[] = SeasonPeer::LAST_DAY_AT;
		}

	} 
	
	public function setUserId($v)
	{

		
		
		if ($v !== null && !is_int($v) && is_numeric($v)) {
			$v = (int) $v;
		}

		if ($this->user_id !== $v) {
			$this->user_id = $v;
			$this->modifiedColumns[] = SeasonPeer::USER_ID;
		}

		if ($this->aUser !== null && $this->aUser->getId() !== $v) {
			$this->aUser = null;
		}

	} 
	
	public function setVolumeUnitTypeId($v)
	{

		
		
		if ($v !== null && !is_int($v) && is_numeric($v)) {
			$v = (int) $v;
		}

		if ($this->volume_unit_type_id !== $v) {
			$this->volume_unit_type_id = $v;
			$this->modifiedColumns[] = SeasonPeer::VOLUME_UNIT_TYPE_ID;
		}

		if ($this->aUnitType !== null && $this->aUnitType->getId() !== $v) {
			$this->aUnitType = null;
		}

	} 
	
	public function setTheoricVolume($v)
	{

		if ($this->theoric_volume !== $v) {
			$this->theoric_volume = $v;
			$this->modifiedColumns[] = SeasonPeer::THEORIC_VOLUME;
		}

	} 
	
	public function setReportedVolume($v)
	{

		if ($this->reported_volume !== $v) {
			$this->reported_volume = $v;
			$this->modifiedColumns[] = SeasonPeer::REPORTED_VOLUME;
		}

	} 
	
	public function setVolumeUnitId($v)
	{

		
		
		if ($v !== null && !is_int($v) && is_numeric($v)) {
			$v = (int) $v;
		}

		if ($this->volume_unit_id !== $v) {
			$this->volume_unit_id = $v;
			$this->modifiedColumns[] = SeasonPeer::VOLUME_UNIT_ID;
		}

		if ($this->aUnitRelatedByVolumeUnitId !== null && $this->aUnitRelatedByVolumeUnitId->getId() !== $v) {
			$this->aUnitRelatedByVolumeUnitId = null;
		}

	} 
	
	public function setVolumeShowUnitId($v)
	{

		
		
		if ($v !== null && !is_int($v) && is_numeric($v)) {
			$v = (int) $v;
		}

		if ($this->volume_show_unit_id !== $v) {
			$this->volume_show_unit_id = $v;
			$this->modifiedColumns[] = SeasonPeer::VOLUME_SHOW_UNIT_ID;
		}

		if ($this->aUnitRelatedByVolumeShowUnitId !== null && $this->aUnitRelatedByVolumeShowUnitId->getId() !== $v) {
			$this->aUnitRelatedByVolumeShowUnitId = null;
		}

	} 
	
	public function setTheoricIntensity1($v)
	{

		if ($this->theoric_intensity1 !== $v) {
			$this->theoric_intensity1 = $v;
			$this->modifiedColumns[] = SeasonPeer::THEORIC_INTENSITY1;
		}

	} 
	
	public function setReportedIntensity1($v)
	{

		if ($this->reported_intensity1 !== $v) {
			$this->reported_intensity1 = $v;
			$this->modifiedColumns[] = SeasonPeer::REPORTED_INTENSITY1;
		}

	} 
	
	public function setIntensity1LowLimit($v)
	{

		if ($this->intensity1_low_limit !== $v) {
			$this->intensity1_low_limit = $v;
			$this->modifiedColumns[] = SeasonPeer::INTENSITY1_LOW_LIMIT;
		}

	} 
	
	public function setIntensity1HighLimit($v)
	{

		if ($this->intensity1_high_limit !== $v) {
			$this->intensity1_high_limit = $v;
			$this->modifiedColumns[] = SeasonPeer::INTENSITY1_HIGH_LIMIT;
		}

	} 
	
	public function setTheoricIntensity2($v)
	{

		if ($this->theoric_intensity2 !== $v) {
			$this->theoric_intensity2 = $v;
			$this->modifiedColumns[] = SeasonPeer::THEORIC_INTENSITY2;
		}

	} 
	
	public function setReportedIntensity2($v)
	{

		if ($this->reported_intensity2 !== $v) {
			$this->reported_intensity2 = $v;
			$this->modifiedColumns[] = SeasonPeer::REPORTED_INTENSITY2;
		}

	} 
	
	public function setIntensity2HighLimit($v)
	{

		if ($this->intensity2_high_limit !== $v) {
			$this->intensity2_high_limit = $v;
			$this->modifiedColumns[] = SeasonPeer::INTENSITY2_HIGH_LIMIT;
		}

	} 
	
	public function setTheoricIntensity3($v)
	{

		if ($this->theoric_intensity3 !== $v) {
			$this->theoric_intensity3 = $v;
			$this->modifiedColumns[] = SeasonPeer::THEORIC_INTENSITY3;
		}

	} 
	
	public function setReportedIntensity3($v)
	{

		if ($this->reported_intensity3 !== $v) {
			$this->reported_intensity3 = $v;
			$this->modifiedColumns[] = SeasonPeer::REPORTED_INTENSITY3;
		}

	} 
	
	public function setIntensity3HighLimit($v)
	{

		if ($this->intensity3_high_limit !== $v) {
			$this->intensity3_high_limit = $v;
			$this->modifiedColumns[] = SeasonPeer::INTENSITY3_HIGH_LIMIT;
		}

	} 
	
	public function hydrate(ResultSet $rs, $startcol = 1)
	{
		try {

			$this->id = $rs->getInt($startcol + 0);

			$this->description = $rs->getString($startcol + 1);

			$this->start_at = $rs->getDate($startcol + 2, null);

			$this->last_day_at = $rs->getDate($startcol + 3, null);

			$this->user_id = $rs->getInt($startcol + 4);

			$this->volume_unit_type_id = $rs->getInt($startcol + 5);

			$this->theoric_volume = $rs->getFloat($startcol + 6);

			$this->reported_volume = $rs->getFloat($startcol + 7);

			$this->volume_unit_id = $rs->getInt($startcol + 8);

			$this->volume_show_unit_id = $rs->getInt($startcol + 9);

			$this->theoric_intensity1 = $rs->getFloat($startcol + 10);

			$this->reported_intensity1 = $rs->getFloat($startcol + 11);

			$this->intensity1_low_limit = $rs->getFloat($startcol + 12);

			$this->intensity1_high_limit = $rs->getFloat($startcol + 13);

			$this->theoric_intensity2 = $rs->getFloat($startcol + 14);

			$this->reported_intensity2 = $rs->getFloat($startcol + 15);

			$this->intensity2_high_limit = $rs->getFloat($startcol + 16);

			$this->theoric_intensity3 = $rs->getFloat($startcol + 17);

			$this->reported_intensity3 = $rs->getFloat($startcol + 18);

			$this->intensity3_high_limit = $rs->getFloat($startcol + 19);

			$this->resetModified();

			$this->setNew(false);

						return $startcol + 20; 
		} catch (Exception $e) {
			throw new PropelException("Error populating Season object", $e);
		}
	}

	
	public function delete($con = null)
	{
		if ($this->isDeleted()) {
			throw new PropelException("This object has already been deleted.");
		}

		if ($con === null) {
			$con = Propel::getConnection(SeasonPeer::DATABASE_NAME);
		}

		try {
			$con->begin();
			SeasonPeer::doDelete($this, $con);
			$this->setDeleted(true);
			$con->commit();
		} catch (PropelException $e) {
			$con->rollback();
			throw $e;
		}
	}

	
	public function save($con = null)
	{
		if ($this->isDeleted()) {
			throw new PropelException("You cannot save an object that has been deleted.");
		}

		if ($con === null) {
			$con = Propel::getConnection(SeasonPeer::DATABASE_NAME);
		}

		try {
			$con->begin();
			$affectedRows = $this->doSave($con);
			$con->commit();
			return $affectedRows;
		} catch (PropelException $e) {
			$con->rollback();
			throw $e;
		}
	}

	
	protected function doSave($con)
	{
		$affectedRows = 0; 		if (!$this->alreadyInSave) {
			$this->alreadyInSave = true;


												
			if ($this->aUser !== null) {
				if ($this->aUser->isModified()) {
					$affectedRows += $this->aUser->save($con);
				}
				$this->setUser($this->aUser);
			}

			if ($this->aUnitType !== null) {
				if ($this->aUnitType->isModified() || $this->aUnitType->getCurrentUnitTypeI18N()->isModified()) {
					$affectedRows += $this->aUnitType->save($con);
				}
				$this->setUnitType($this->aUnitType);
			}

			if ($this->aUnitRelatedByVolumeUnitId !== null) {
				if ($this->aUnitRelatedByVolumeUnitId->isModified() || $this->aUnitRelatedByVolumeUnitId->getCurrentUnitI18N()->isModified()) {
					$affectedRows += $this->aUnitRelatedByVolumeUnitId->save($con);
				}
				$this->setUnitRelatedByVolumeUnitId($this->aUnitRelatedByVolumeUnitId);
			}

			if ($this->aUnitRelatedByVolumeShowUnitId !== null) {
				if ($this->aUnitRelatedByVolumeShowUnitId->isModified() || $this->aUnitRelatedByVolumeShowUnitId->getCurrentUnitI18N()->isModified()) {
					$affectedRows += $this->aUnitRelatedByVolumeShowUnitId->save($con);
				}
				$this->setUnitRelatedByVolumeShowUnitId($this->aUnitRelatedByVolumeShowUnitId);
			}


						if ($this->isModified()) {
				if ($this->isNew()) {
					$pk = SeasonPeer::doInsert($this, $con);
					$affectedRows += 1; 										 										 
					$this->setId($pk);  
					$this->setNew(false);
				} else {
					$affectedRows += SeasonPeer::doUpdate($this, $con);
				}
				$this->resetModified(); 			}

			if ($this->collMacrocycles !== null) {
				foreach($this->collMacrocycles as $referrerFK) {
					if (!$referrerFK->isDeleted()) {
						$affectedRows += $referrerFK->save($con);
					}
				}
			}

			$this->alreadyInSave = false;
		}
		return $affectedRows;
	} 
	
	protected $validationFailures = array();

	
	public function getValidationFailures()
	{
		return $this->validationFailures;
	}

	
	public function validate($columns = null)
	{
		$res = $this->doValidate($columns);
		if ($res === true) {
			$this->validationFailures = array();
			return true;
		} else {
			$this->validationFailures = $res;
			return false;
		}
	}

	
	protected function doValidate($columns = null)
	{
		if (!$this->alreadyInValidation) {
			$this->alreadyInValidation = true;
			$retval = null;

			$failureMap = array();


												
			if ($this->aUser !== null) {
				if (!$this->aUser->validate($columns)) {
					$failureMap = array_merge($failureMap, $this->aUser->getValidationFailures());
				}
			}

			if ($this->aUnitType !== null) {
				if (!$this->aUnitType->validate($columns)) {
					$failureMap = array_merge($failureMap, $this->aUnitType->getValidationFailures());
				}
			}

			if ($this->aUnitRelatedByVolumeUnitId !== null) {
				if (!$this->aUnitRelatedByVolumeUnitId->validate($columns)) {
					$failureMap = array_merge($failureMap, $this->aUnitRelatedByVolumeUnitId->getValidationFailures());
				}
			}

			if ($this->aUnitRelatedByVolumeShowUnitId !== null) {
				if (!$this->aUnitRelatedByVolumeShowUnitId->validate($columns)) {
					$failureMap = array_merge($failureMap, $this->aUnitRelatedByVolumeShowUnitId->getValidationFailures());
				}
			}


			if (($retval = SeasonPeer::doValidate($this, $columns)) !== true) {
				$failureMap = array_merge($failureMap, $retval);
			}


				if ($this->collMacrocycles !== null) {
					foreach($this->collMacrocycles as $referrerFK) {
						if (!$referrerFK->validate($columns)) {
							$failureMap = array_merge($failureMap, $referrerFK->getValidationFailures());
						}
					}
				}


			$this->alreadyInValidation = false;
		}

		return (!empty($failureMap) ? $failureMap : true);
	}

	
	public function getByName($name, $type = BasePeer::TYPE_PHPNAME)
	{
		$pos = SeasonPeer::translateFieldName($name, $type, BasePeer::TYPE_NUM);
		return $this->getByPosition($pos);
	}

	
	public function getByPosition($pos)
	{
		switch($pos) {
			case 0:
				return $this->getId();
				break;
			case 1:
				return $this->getDescription();
				break;
			case 2:
				return $this->getStartAt();
				break;
			case 3:
				return $this->getLastDayAt();
				break;
			case 4:
				return $this->getUserId();
				break;
			case 5:
				return $this->getVolumeUnitTypeId();
				break;
			case 6:
				return $this->getTheoricVolume();
				break;
			case 7:
				return $this->getReportedVolume();
				break;
			case 8:
				return $this->getVolumeUnitId();
				break;
			case 9:
				return $this->getVolumeShowUnitId();
				break;
			case 10:
				return $this->getTheoricIntensity1();
				break;
			case 11:
				return $this->getReportedIntensity1();
				break;
			case 12:
				return $this->getIntensity1LowLimit();
				break;
			case 13:
				return $this->getIntensity1HighLimit();
				break;
			case 14:
				return $this->getTheoricIntensity2();
				break;
			case 15:
				return $this->getReportedIntensity2();
				break;
			case 16:
				return $this->getIntensity2HighLimit();
				break;
			case 17:
				return $this->getTheoricIntensity3();
				break;
			case 18:
				return $this->getReportedIntensity3();
				break;
			case 19:
				return $this->getIntensity3HighLimit();
				break;
			default:
				return null;
				break;
		} 	}

	
	public function toArray($keyType = BasePeer::TYPE_PHPNAME)
	{
		$keys = SeasonPeer::getFieldNames($keyType);
		$result = array(
			$keys[0] => $this->getId(),
			$keys[1] => $this->getDescription(),
			$keys[2] => $this->getStartAt(),
			$keys[3] => $this->getLastDayAt(),
			$keys[4] => $this->getUserId(),
			$keys[5] => $this->getVolumeUnitTypeId(),
			$keys[6] => $this->getTheoricVolume(),
			$keys[7] => $this->getReportedVolume(),
			$keys[8] => $this->getVolumeUnitId(),
			$keys[9] => $this->getVolumeShowUnitId(),
			$keys[10] => $this->getTheoricIntensity1(),
			$keys[11] => $this->getReportedIntensity1(),
			$keys[12] => $this->getIntensity1LowLimit(),
			$keys[13] => $this->getIntensity1HighLimit(),
			$keys[14] => $this->getTheoricIntensity2(),
			$keys[15] => $this->getReportedIntensity2(),
			$keys[16] => $this->getIntensity2HighLimit(),
			$keys[17] => $this->getTheoricIntensity3(),
			$keys[18] => $this->getReportedIntensity3(),
			$keys[19] => $this->getIntensity3HighLimit(),
		);
		return $result;
	}

	
	public function setByName($name, $value, $type = BasePeer::TYPE_PHPNAME)
	{
		$pos = SeasonPeer::translateFieldName($name, $type, BasePeer::TYPE_NUM);
		return $this->setByPosition($pos, $value);
	}

	
	public function setByPosition($pos, $value)
	{
		switch($pos) {
			case 0:
				$this->setId($value);
				break;
			case 1:
				$this->setDescription($value);
				break;
			case 2:
				$this->setStartAt($value);
				break;
			case 3:
				$this->setLastDayAt($value);
				break;
			case 4:
				$this->setUserId($value);
				break;
			case 5:
				$this->setVolumeUnitTypeId($value);
				break;
			case 6:
				$this->setTheoricVolume($value);
				break;
			case 7:
				$this->setReportedVolume($value);
				break;
			case 8:
				$this->setVolumeUnitId($value);
				break;
			case 9:
				$this->setVolumeShowUnitId($value);
				break;
			case 10:
				$this->setTheoricIntensity1($value);
				break;
			case 11:
				$this->setReportedIntensity1($value);
				break;
			case 12:
				$this->setIntensity1LowLimit($value);
				break;
			case 13:
				$this->setIntensity1HighLimit($value);
				break;
			case 14:
				$this->setTheoricIntensity2($value);
				break;
			case 15:
				$this->setReportedIntensity2($value);
				break;
			case 16:
				$this->setIntensity2HighLimit($value);
				break;
			case 17:
				$this->setTheoricIntensity3($value);
				break;
			case 18:
				$this->setReportedIntensity3($value);
				break;
			case 19:
				$this->setIntensity3HighLimit($value);
				break;
		} 	}

	
	public function fromArray($arr, $keyType = BasePeer::TYPE_PHPNAME)
	{
		$keys = SeasonPeer::getFieldNames($keyType);

		if (array_key_exists($keys[0], $arr)) $this->setId($arr[$keys[0]]);
		if (array_key_exists($keys[1], $arr)) $this->setDescription($arr[$keys[1]]);
		if (array_key_exists($keys[2], $arr)) $this->setStartAt($arr[$keys[2]]);
		if (array_key_exists($keys[3], $arr)) $this->setLastDayAt($arr[$keys[3]]);
		if (array_key_exists($keys[4], $arr)) $this->setUserId($arr[$keys[4]]);
		if (array_key_exists($keys[5], $arr)) $this->setVolumeUnitTypeId($arr[$keys[5]]);
		if (array_key_exists($keys[6], $arr)) $this->setTheoricVolume($arr[$keys[6]]);
		if (array_key_exists($keys[7], $arr)) $this->setReportedVolume($arr[$keys[7]]);
		if (array_key_exists($keys[8], $arr)) $this->setVolumeUnitId($arr[$keys[8]]);
		if (array_key_exists($keys[9], $arr)) $this->setVolumeShowUnitId($arr[$keys[9]]);
		if (array_key_exists($keys[10], $arr)) $this->setTheoricIntensity1($arr[$keys[10]]);
		if (array_key_exists($keys[11], $arr)) $this->setReportedIntensity1($arr[$keys[11]]);
		if (array_key_exists($keys[12], $arr)) $this->setIntensity1LowLimit($arr[$keys[12]]);
		if (array_key_exists($keys[13], $arr)) $this->setIntensity1HighLimit($arr[$keys[13]]);
		if (array_key_exists($keys[14], $arr)) $this->setTheoricIntensity2($arr[$keys[14]]);
		if (array_key_exists($keys[15], $arr)) $this->setReportedIntensity2($arr[$keys[15]]);
		if (array_key_exists($keys[16], $arr)) $this->setIntensity2HighLimit($arr[$keys[16]]);
		if (array_key_exists($keys[17], $arr)) $this->setTheoricIntensity3($arr[$keys[17]]);
		if (array_key_exists($keys[18], $arr)) $this->setReportedIntensity3($arr[$keys[18]]);
		if (array_key_exists($keys[19], $arr)) $this->setIntensity3HighLimit($arr[$keys[19]]);
	}

	
	public function buildCriteria()
	{
		$criteria = new Criteria(SeasonPeer::DATABASE_NAME);

		if ($this->isColumnModified(SeasonPeer::ID)) $criteria->add(SeasonPeer::ID, $this->id);
		if ($this->isColumnModified(SeasonPeer::DESCRIPTION)) $criteria->add(SeasonPeer::DESCRIPTION, $this->description);
		if ($this->isColumnModified(SeasonPeer::START_AT)) $criteria->add(SeasonPeer::START_AT, $this->start_at);
		if ($this->isColumnModified(SeasonPeer::LAST_DAY_AT)) $criteria->add(SeasonPeer::LAST_DAY_AT, $this->last_day_at);
		if ($this->isColumnModified(SeasonPeer::USER_ID)) $criteria->add(SeasonPeer::USER_ID, $this->user_id);
		if ($this->isColumnModified(SeasonPeer::VOLUME_UNIT_TYPE_ID)) $criteria->add(SeasonPeer::VOLUME_UNIT_TYPE_ID, $this->volume_unit_type_id);
		if ($this->isColumnModified(SeasonPeer::THEORIC_VOLUME)) $criteria->add(SeasonPeer::THEORIC_VOLUME, $this->theoric_volume);
		if ($this->isColumnModified(SeasonPeer::REPORTED_VOLUME)) $criteria->add(SeasonPeer::REPORTED_VOLUME, $this->reported_volume);
		if ($this->isColumnModified(SeasonPeer::VOLUME_UNIT_ID)) $criteria->add(SeasonPeer::VOLUME_UNIT_ID, $this->volume_unit_id);
		if ($this->isColumnModified(SeasonPeer::VOLUME_SHOW_UNIT_ID)) $criteria->add(SeasonPeer::VOLUME_SHOW_UNIT_ID, $this->volume_show_unit_id);
		if ($this->isColumnModified(SeasonPeer::THEORIC_INTENSITY1)) $criteria->add(SeasonPeer::THEORIC_INTENSITY1, $this->theoric_intensity1);
		if ($this->isColumnModified(SeasonPeer::REPORTED_INTENSITY1)) $criteria->add(SeasonPeer::REPORTED_INTENSITY1, $this->reported_intensity1);
		if ($this->isColumnModified(SeasonPeer::INTENSITY1_LOW_LIMIT)) $criteria->add(SeasonPeer::INTENSITY1_LOW_LIMIT, $this->intensity1_low_limit);
		if ($this->isColumnModified(SeasonPeer::INTENSITY1_HIGH_LIMIT)) $criteria->add(SeasonPeer::INTENSITY1_HIGH_LIMIT, $this->intensity1_high_limit);
		if ($this->isColumnModified(SeasonPeer::THEORIC_INTENSITY2)) $criteria->add(SeasonPeer::THEORIC_INTENSITY2, $this->theoric_intensity2);
		if ($this->isColumnModified(SeasonPeer::REPORTED_INTENSITY2)) $criteria->add(SeasonPeer::REPORTED_INTENSITY2, $this->reported_intensity2);
		if ($this->isColumnModified(SeasonPeer::INTENSITY2_HIGH_LIMIT)) $criteria->add(SeasonPeer::INTENSITY2_HIGH_LIMIT, $this->intensity2_high_limit);
		if ($this->isColumnModified(SeasonPeer::THEORIC_INTENSITY3)) $criteria->add(SeasonPeer::THEORIC_INTENSITY3, $this->theoric_intensity3);
		if ($this->isColumnModified(SeasonPeer::REPORTED_INTENSITY3)) $criteria->add(SeasonPeer::REPORTED_INTENSITY3, $this->reported_intensity3);
		if ($this->isColumnModified(SeasonPeer::INTENSITY3_HIGH_LIMIT)) $criteria->add(SeasonPeer::INTENSITY3_HIGH_LIMIT, $this->intensity3_high_limit);

		return $criteria;
	}

	
	public function buildPkeyCriteria()
	{
		$criteria = new Criteria(SeasonPeer::DATABASE_NAME);

		$criteria->add(SeasonPeer::ID, $this->id);

		return $criteria;
	}

	
	public function getPrimaryKey()
	{
		return $this->getId();
	}

	
	public function setPrimaryKey($key)
	{
		$this->setId($key);
	}

	
	public function copyInto($copyObj, $deepCopy = false)
	{

		$copyObj->setDescription($this->description);

		$copyObj->setStartAt($this->start_at);

		$copyObj->setLastDayAt($this->last_day_at);

		$copyObj->setUserId($this->user_id);

		$copyObj->setVolumeUnitTypeId($this->volume_unit_type_id);

		$copyObj->setTheoricVolume($this->theoric_volume);

		$copyObj->setReportedVolume($this->reported_volume);

		$copyObj->setVolumeUnitId($this->volume_unit_id);

		$copyObj->setVolumeShowUnitId($this->volume_show_unit_id);

		$copyObj->setTheoricIntensity1($this->theoric_intensity1);

		$copyObj->setReportedIntensity1($this->reported_intensity1);

		$copyObj->setIntensity1LowLimit($this->intensity1_low_limit);

		$copyObj->setIntensity1HighLimit($this->intensity1_high_limit);

		$copyObj->setTheoricIntensity2($this->theoric_intensity2);

		$copyObj->setReportedIntensity2($this->reported_intensity2);

		$copyObj->setIntensity2HighLimit($this->intensity2_high_limit);

		$copyObj->setTheoricIntensity3($this->theoric_intensity3);

		$copyObj->setReportedIntensity3($this->reported_intensity3);

		$copyObj->setIntensity3HighLimit($this->intensity3_high_limit);


		if ($deepCopy) {
									$copyObj->setNew(false);

			foreach($this->getMacrocycles() as $relObj) {
				$copyObj->addMacrocycle($relObj->copy($deepCopy));
			}

		} 

		$copyObj->setNew(true);

		$copyObj->setId(NULL); 
	}

	
	public function copy($deepCopy = false)
	{
				$clazz = get_class($this);
		$copyObj = new $clazz();
		$this->copyInto($copyObj, $deepCopy);
		return $copyObj;
	}

	
	public function getPeer()
	{
		if (self::$peer === null) {
			self::$peer = new SeasonPeer();
		}
		return self::$peer;
	}

	
	public function setUser($v)
	{


		if ($v === null) {
			$this->setUserId(NULL);
		} else {
			$this->setUserId($v->getId());
		}


		$this->aUser = $v;
	}


	
	public function getUser($con = null)
	{
		if ($this->aUser === null && ($this->user_id !== null)) {
						include_once 'lib/model/om/BaseUserPeer.php';

			$this->aUser = UserPeer::retrieveByPK($this->user_id, $con);

			
		}
		return $this->aUser;
	}

	
	public function setUnitType($v)
	{


		if ($v === null) {
			$this->setVolumeUnitTypeId(NULL);
		} else {
			$this->setVolumeUnitTypeId($v->getId());
		}


		$this->aUnitType = $v;
	}


	
	public function getUnitType($con = null)
	{
		if ($this->aUnitType === null && ($this->volume_unit_type_id !== null)) {
						include_once 'lib/model/om/BaseUnitTypePeer.php';

			$this->aUnitType = UnitTypePeer::retrieveByPK($this->volume_unit_type_id, $con);

			
		}
		return $this->aUnitType;
	}

	
	public function setUnitRelatedByVolumeUnitId($v)
	{


		if ($v === null) {
			$this->setVolumeUnitId(NULL);
		} else {
			$this->setVolumeUnitId($v->getId());
		}


		$this->aUnitRelatedByVolumeUnitId = $v;
	}


	
	public function getUnitRelatedByVolumeUnitId($con = null)
	{
		if ($this->aUnitRelatedByVolumeUnitId === null && ($this->volume_unit_id !== null)) {
						include_once 'lib/model/om/BaseUnitPeer.php';

			$this->aUnitRelatedByVolumeUnitId = UnitPeer::retrieveByPK($this->volume_unit_id, $con);

			
		}
		return $this->aUnitRelatedByVolumeUnitId;
	}

	
	public function setUnitRelatedByVolumeShowUnitId($v)
	{


		if ($v === null) {
			$this->setVolumeShowUnitId(NULL);
		} else {
			$this->setVolumeShowUnitId($v->getId());
		}


		$this->aUnitRelatedByVolumeShowUnitId = $v;
	}


	
	public function getUnitRelatedByVolumeShowUnitId($con = null)
	{
		if ($this->aUnitRelatedByVolumeShowUnitId === null && ($this->volume_show_unit_id !== null)) {
						include_once 'lib/model/om/BaseUnitPeer.php';

			$this->aUnitRelatedByVolumeShowUnitId = UnitPeer::retrieveByPK($this->volume_show_unit_id, $con);

			
		}
		return $this->aUnitRelatedByVolumeShowUnitId;
	}

	
	public function initMacrocycles()
	{
		if ($this->collMacrocycles === null) {
			$this->collMacrocycles = array();
		}
	}

	
	public function getMacrocycles($criteria = null, $con = null)
	{
				include_once 'lib/model/om/BaseMacrocyclePeer.php';
		if ($criteria === null) {
			$criteria = new Criteria();
		}
		elseif ($criteria instanceof Criteria)
		{
			$criteria = clone $criteria;
		}

		if ($this->collMacrocycles === null) {
			if ($this->isNew()) {
			   $this->collMacrocycles = array();
			} else {

				$criteria->add(MacrocyclePeer::SEASON_ID, $this->getId());

				MacrocyclePeer::addSelectColumns($criteria);
				$this->collMacrocycles = MacrocyclePeer::doSelect($criteria, $con);
			}
		} else {
						if (!$this->isNew()) {
												

				$criteria->add(MacrocyclePeer::SEASON_ID, $this->getId());

				MacrocyclePeer::addSelectColumns($criteria);
				if (!isset($this->lastMacrocycleCriteria) || !$this->lastMacrocycleCriteria->equals($criteria)) {
					$this->collMacrocycles = MacrocyclePeer::doSelect($criteria, $con);
				}
			}
		}
		$this->lastMacrocycleCriteria = $criteria;
		return $this->collMacrocycles;
	}

	
	public function countMacrocycles($criteria = null, $distinct = false, $con = null)
	{
				include_once 'lib/model/om/BaseMacrocyclePeer.php';
		if ($criteria === null) {
			$criteria = new Criteria();
		}
		elseif ($criteria instanceof Criteria)
		{
			$criteria = clone $criteria;
		}

		$criteria->add(MacrocyclePeer::SEASON_ID, $this->getId());

		return MacrocyclePeer::doCount($criteria, $distinct, $con);
	}

	
	public function addMacrocycle(Macrocycle $l)
	{
		$this->collMacrocycles[] = $l;
		$l->setSeason($this);
	}

} 