<?php


abstract class BaseSession extends BaseObject  implements Persistent {


	
	protected static $peer;


	
	protected $id;


	
	protected $date;


	
	protected $morning_session;


	
	protected $feedback;


	
	protected $description;


	
	protected $microcycle_id;


	
	protected $wake_up_hr;


	
	protected $theoric_volume;


	
	protected $reported_volume;


	
	protected $theoric_intensity1;


	
	protected $reported_intensity1;


	
	protected $theoric_intensity2;


	
	protected $reported_intensity2;


	
	protected $theoric_intensity3;


	
	protected $reported_intensity3;


	
	protected $new_report;


	
	protected $reported;

	
	protected $aMicrocycle;

	
	protected $alreadyInSave = false;

	
	protected $alreadyInValidation = false;

	
	public function getId()
	{

		return $this->id;
	}

	
	public function getDate($format = 'Y-m-d')
	{

		if ($this->date === null || $this->date === '') {
			return null;
		} elseif (!is_int($this->date)) {
						$ts = strtotime($this->date);
			if ($ts === -1 || $ts === false) { 				throw new PropelException("Unable to parse value of [date] as date/time value: " . var_export($this->date, true));
			}
		} else {
			$ts = $this->date;
		}
		if ($format === null) {
			return $ts;
		} elseif (strpos($format, '%') !== false) {
			return strftime($format, $ts);
		} else {
			return date($format, $ts);
		}
	}

	
	public function getMorningSession()
	{

		return $this->morning_session;
	}

	
	public function getFeedback()
	{

		return $this->feedback;
	}

	
	public function getDescription()
	{

		return $this->description;
	}

	
	public function getMicrocycleId()
	{

		return $this->microcycle_id;
	}

	
	public function getWakeUpHr()
	{

		return $this->wake_up_hr;
	}

	
	public function getTheoricVolume()
	{

		return $this->theoric_volume;
	}

	
	public function getReportedVolume()
	{

		return $this->reported_volume;
	}

	
	public function getTheoricIntensity1()
	{

		return $this->theoric_intensity1;
	}

	
	public function getReportedIntensity1()
	{

		return $this->reported_intensity1;
	}

	
	public function getTheoricIntensity2()
	{

		return $this->theoric_intensity2;
	}

	
	public function getReportedIntensity2()
	{

		return $this->reported_intensity2;
	}

	
	public function getTheoricIntensity3()
	{

		return $this->theoric_intensity3;
	}

	
	public function getReportedIntensity3()
	{

		return $this->reported_intensity3;
	}

	
	public function getNewReport()
	{

		return $this->new_report;
	}

	
	public function getReported()
	{

		return $this->reported;
	}

	
	public function setId($v)
	{

		
		
		if ($v !== null && !is_int($v) && is_numeric($v)) {
			$v = (int) $v;
		}

		if ($this->id !== $v) {
			$this->id = $v;
			$this->modifiedColumns[] = SessionPeer::ID;
		}

	} 
	
	public function setDate($v)
	{

		if ($v !== null && !is_int($v)) {
			$ts = strtotime($v);
			if ($ts === -1 || $ts === false) { 				throw new PropelException("Unable to parse date/time value for [date] from input: " . var_export($v, true));
			}
		} else {
			$ts = $v;
		}
		if ($this->date !== $ts) {
			$this->date = $ts;
			$this->modifiedColumns[] = SessionPeer::DATE;
		}

	} 
	
	public function setMorningSession($v)
	{

		if ($this->morning_session !== $v) {
			$this->morning_session = $v;
			$this->modifiedColumns[] = SessionPeer::MORNING_SESSION;
		}

	} 
	
	public function setFeedback($v)
	{

		
		
		if ($v !== null && !is_string($v)) {
			$v = (string) $v; 
		}

		if ($this->feedback !== $v) {
			$this->feedback = $v;
			$this->modifiedColumns[] = SessionPeer::FEEDBACK;
		}

	} 
	
	public function setDescription($v)
	{

		
		
		if ($v !== null && !is_string($v)) {
			$v = (string) $v; 
		}

		if ($this->description !== $v) {
			$this->description = $v;
			$this->modifiedColumns[] = SessionPeer::DESCRIPTION;
		}

	} 
	
	public function setMicrocycleId($v)
	{

		
		
		if ($v !== null && !is_int($v) && is_numeric($v)) {
			$v = (int) $v;
		}

		if ($this->microcycle_id !== $v) {
			$this->microcycle_id = $v;
			$this->modifiedColumns[] = SessionPeer::MICROCYCLE_ID;
		}

		if ($this->aMicrocycle !== null && $this->aMicrocycle->getId() !== $v) {
			$this->aMicrocycle = null;
		}

	} 
	
	public function setWakeUpHr($v)
	{

		if ($this->wake_up_hr !== $v) {
			$this->wake_up_hr = $v;
			$this->modifiedColumns[] = SessionPeer::WAKE_UP_HR;
		}

	} 
	
	public function setTheoricVolume($v)
	{

		if ($this->theoric_volume !== $v) {
			$this->theoric_volume = $v;
			$this->modifiedColumns[] = SessionPeer::THEORIC_VOLUME;
		}

	} 
	
	public function setReportedVolume($v)
	{

		if ($this->reported_volume !== $v) {
			$this->reported_volume = $v;
			$this->modifiedColumns[] = SessionPeer::REPORTED_VOLUME;
		}

	} 
	
	public function setTheoricIntensity1($v)
	{

		if ($this->theoric_intensity1 !== $v) {
			$this->theoric_intensity1 = $v;
			$this->modifiedColumns[] = SessionPeer::THEORIC_INTENSITY1;
		}

	} 
	
	public function setReportedIntensity1($v)
	{

		if ($this->reported_intensity1 !== $v) {
			$this->reported_intensity1 = $v;
			$this->modifiedColumns[] = SessionPeer::REPORTED_INTENSITY1;
		}

	} 
	
	public function setTheoricIntensity2($v)
	{

		if ($this->theoric_intensity2 !== $v) {
			$this->theoric_intensity2 = $v;
			$this->modifiedColumns[] = SessionPeer::THEORIC_INTENSITY2;
		}

	} 
	
	public function setReportedIntensity2($v)
	{

		if ($this->reported_intensity2 !== $v) {
			$this->reported_intensity2 = $v;
			$this->modifiedColumns[] = SessionPeer::REPORTED_INTENSITY2;
		}

	} 
	
	public function setTheoricIntensity3($v)
	{

		if ($this->theoric_intensity3 !== $v) {
			$this->theoric_intensity3 = $v;
			$this->modifiedColumns[] = SessionPeer::THEORIC_INTENSITY3;
		}

	} 
	
	public function setReportedIntensity3($v)
	{

		if ($this->reported_intensity3 !== $v) {
			$this->reported_intensity3 = $v;
			$this->modifiedColumns[] = SessionPeer::REPORTED_INTENSITY3;
		}

	} 
	
	public function setNewReport($v)
	{

		if ($this->new_report !== $v) {
			$this->new_report = $v;
			$this->modifiedColumns[] = SessionPeer::NEW_REPORT;
		}

	} 
	
	public function setReported($v)
	{

		if ($this->reported !== $v) {
			$this->reported = $v;
			$this->modifiedColumns[] = SessionPeer::REPORTED;
		}

	} 
	
	public function hydrate(ResultSet $rs, $startcol = 1)
	{
		try {

			$this->id = $rs->getInt($startcol + 0);

			$this->date = $rs->getDate($startcol + 1, null);

			$this->morning_session = $rs->getBoolean($startcol + 2);

			$this->feedback = $rs->getString($startcol + 3);

			$this->description = $rs->getString($startcol + 4);

			$this->microcycle_id = $rs->getInt($startcol + 5);

			$this->wake_up_hr = $rs->getFloat($startcol + 6);

			$this->theoric_volume = $rs->getFloat($startcol + 7);

			$this->reported_volume = $rs->getFloat($startcol + 8);

			$this->theoric_intensity1 = $rs->getFloat($startcol + 9);

			$this->reported_intensity1 = $rs->getFloat($startcol + 10);

			$this->theoric_intensity2 = $rs->getFloat($startcol + 11);

			$this->reported_intensity2 = $rs->getFloat($startcol + 12);

			$this->theoric_intensity3 = $rs->getFloat($startcol + 13);

			$this->reported_intensity3 = $rs->getFloat($startcol + 14);

			$this->new_report = $rs->getBoolean($startcol + 15);

			$this->reported = $rs->getBoolean($startcol + 16);

			$this->resetModified();

			$this->setNew(false);

						return $startcol + 17; 
		} catch (Exception $e) {
			throw new PropelException("Error populating Session object", $e);
		}
	}

	
	public function delete($con = null)
	{
		if ($this->isDeleted()) {
			throw new PropelException("This object has already been deleted.");
		}

		if ($con === null) {
			$con = Propel::getConnection(SessionPeer::DATABASE_NAME);
		}

		try {
			$con->begin();
			SessionPeer::doDelete($this, $con);
			$this->setDeleted(true);
			$con->commit();
		} catch (PropelException $e) {
			$con->rollback();
			throw $e;
		}
	}

	
	public function save($con = null)
	{
		if ($this->isDeleted()) {
			throw new PropelException("You cannot save an object that has been deleted.");
		}

		if ($con === null) {
			$con = Propel::getConnection(SessionPeer::DATABASE_NAME);
		}

		try {
			$con->begin();
			$affectedRows = $this->doSave($con);
			$con->commit();
			return $affectedRows;
		} catch (PropelException $e) {
			$con->rollback();
			throw $e;
		}
	}

	
	protected function doSave($con)
	{
		$affectedRows = 0; 		if (!$this->alreadyInSave) {
			$this->alreadyInSave = true;


												
			if ($this->aMicrocycle !== null) {
				if ($this->aMicrocycle->isModified()) {
					$affectedRows += $this->aMicrocycle->save($con);
				}
				$this->setMicrocycle($this->aMicrocycle);
			}


						if ($this->isModified()) {
				if ($this->isNew()) {
					$pk = SessionPeer::doInsert($this, $con);
					$affectedRows += 1; 										 										 
					$this->setId($pk);  
					$this->setNew(false);
				} else {
					$affectedRows += SessionPeer::doUpdate($this, $con);
				}
				$this->resetModified(); 			}

			$this->alreadyInSave = false;
		}
		return $affectedRows;
	} 
	
	protected $validationFailures = array();

	
	public function getValidationFailures()
	{
		return $this->validationFailures;
	}

	
	public function validate($columns = null)
	{
		$res = $this->doValidate($columns);
		if ($res === true) {
			$this->validationFailures = array();
			return true;
		} else {
			$this->validationFailures = $res;
			return false;
		}
	}

	
	protected function doValidate($columns = null)
	{
		if (!$this->alreadyInValidation) {
			$this->alreadyInValidation = true;
			$retval = null;

			$failureMap = array();


												
			if ($this->aMicrocycle !== null) {
				if (!$this->aMicrocycle->validate($columns)) {
					$failureMap = array_merge($failureMap, $this->aMicrocycle->getValidationFailures());
				}
			}


			if (($retval = SessionPeer::doValidate($this, $columns)) !== true) {
				$failureMap = array_merge($failureMap, $retval);
			}



			$this->alreadyInValidation = false;
		}

		return (!empty($failureMap) ? $failureMap : true);
	}

	
	public function getByName($name, $type = BasePeer::TYPE_PHPNAME)
	{
		$pos = SessionPeer::translateFieldName($name, $type, BasePeer::TYPE_NUM);
		return $this->getByPosition($pos);
	}

	
	public function getByPosition($pos)
	{
		switch($pos) {
			case 0:
				return $this->getId();
				break;
			case 1:
				return $this->getDate();
				break;
			case 2:
				return $this->getMorningSession();
				break;
			case 3:
				return $this->getFeedback();
				break;
			case 4:
				return $this->getDescription();
				break;
			case 5:
				return $this->getMicrocycleId();
				break;
			case 6:
				return $this->getWakeUpHr();
				break;
			case 7:
				return $this->getTheoricVolume();
				break;
			case 8:
				return $this->getReportedVolume();
				break;
			case 9:
				return $this->getTheoricIntensity1();
				break;
			case 10:
				return $this->getReportedIntensity1();
				break;
			case 11:
				return $this->getTheoricIntensity2();
				break;
			case 12:
				return $this->getReportedIntensity2();
				break;
			case 13:
				return $this->getTheoricIntensity3();
				break;
			case 14:
				return $this->getReportedIntensity3();
				break;
			case 15:
				return $this->getNewReport();
				break;
			case 16:
				return $this->getReported();
				break;
			default:
				return null;
				break;
		} 	}

	
	public function toArray($keyType = BasePeer::TYPE_PHPNAME)
	{
		$keys = SessionPeer::getFieldNames($keyType);
		$result = array(
			$keys[0] => $this->getId(),
			$keys[1] => $this->getDate(),
			$keys[2] => $this->getMorningSession(),
			$keys[3] => $this->getFeedback(),
			$keys[4] => $this->getDescription(),
			$keys[5] => $this->getMicrocycleId(),
			$keys[6] => $this->getWakeUpHr(),
			$keys[7] => $this->getTheoricVolume(),
			$keys[8] => $this->getReportedVolume(),
			$keys[9] => $this->getTheoricIntensity1(),
			$keys[10] => $this->getReportedIntensity1(),
			$keys[11] => $this->getTheoricIntensity2(),
			$keys[12] => $this->getReportedIntensity2(),
			$keys[13] => $this->getTheoricIntensity3(),
			$keys[14] => $this->getReportedIntensity3(),
			$keys[15] => $this->getNewReport(),
			$keys[16] => $this->getReported(),
		);
		return $result;
	}

	
	public function setByName($name, $value, $type = BasePeer::TYPE_PHPNAME)
	{
		$pos = SessionPeer::translateFieldName($name, $type, BasePeer::TYPE_NUM);
		return $this->setByPosition($pos, $value);
	}

	
	public function setByPosition($pos, $value)
	{
		switch($pos) {
			case 0:
				$this->setId($value);
				break;
			case 1:
				$this->setDate($value);
				break;
			case 2:
				$this->setMorningSession($value);
				break;
			case 3:
				$this->setFeedback($value);
				break;
			case 4:
				$this->setDescription($value);
				break;
			case 5:
				$this->setMicrocycleId($value);
				break;
			case 6:
				$this->setWakeUpHr($value);
				break;
			case 7:
				$this->setTheoricVolume($value);
				break;
			case 8:
				$this->setReportedVolume($value);
				break;
			case 9:
				$this->setTheoricIntensity1($value);
				break;
			case 10:
				$this->setReportedIntensity1($value);
				break;
			case 11:
				$this->setTheoricIntensity2($value);
				break;
			case 12:
				$this->setReportedIntensity2($value);
				break;
			case 13:
				$this->setTheoricIntensity3($value);
				break;
			case 14:
				$this->setReportedIntensity3($value);
				break;
			case 15:
				$this->setNewReport($value);
				break;
			case 16:
				$this->setReported($value);
				break;
		} 	}

	
	public function fromArray($arr, $keyType = BasePeer::TYPE_PHPNAME)
	{
		$keys = SessionPeer::getFieldNames($keyType);

		if (array_key_exists($keys[0], $arr)) $this->setId($arr[$keys[0]]);
		if (array_key_exists($keys[1], $arr)) $this->setDate($arr[$keys[1]]);
		if (array_key_exists($keys[2], $arr)) $this->setMorningSession($arr[$keys[2]]);
		if (array_key_exists($keys[3], $arr)) $this->setFeedback($arr[$keys[3]]);
		if (array_key_exists($keys[4], $arr)) $this->setDescription($arr[$keys[4]]);
		if (array_key_exists($keys[5], $arr)) $this->setMicrocycleId($arr[$keys[5]]);
		if (array_key_exists($keys[6], $arr)) $this->setWakeUpHr($arr[$keys[6]]);
		if (array_key_exists($keys[7], $arr)) $this->setTheoricVolume($arr[$keys[7]]);
		if (array_key_exists($keys[8], $arr)) $this->setReportedVolume($arr[$keys[8]]);
		if (array_key_exists($keys[9], $arr)) $this->setTheoricIntensity1($arr[$keys[9]]);
		if (array_key_exists($keys[10], $arr)) $this->setReportedIntensity1($arr[$keys[10]]);
		if (array_key_exists($keys[11], $arr)) $this->setTheoricIntensity2($arr[$keys[11]]);
		if (array_key_exists($keys[12], $arr)) $this->setReportedIntensity2($arr[$keys[12]]);
		if (array_key_exists($keys[13], $arr)) $this->setTheoricIntensity3($arr[$keys[13]]);
		if (array_key_exists($keys[14], $arr)) $this->setReportedIntensity3($arr[$keys[14]]);
		if (array_key_exists($keys[15], $arr)) $this->setNewReport($arr[$keys[15]]);
		if (array_key_exists($keys[16], $arr)) $this->setReported($arr[$keys[16]]);
	}

	
	public function buildCriteria()
	{
		$criteria = new Criteria(SessionPeer::DATABASE_NAME);

		if ($this->isColumnModified(SessionPeer::ID)) $criteria->add(SessionPeer::ID, $this->id);
		if ($this->isColumnModified(SessionPeer::DATE)) $criteria->add(SessionPeer::DATE, $this->date);
		if ($this->isColumnModified(SessionPeer::MORNING_SESSION)) $criteria->add(SessionPeer::MORNING_SESSION, $this->morning_session);
		if ($this->isColumnModified(SessionPeer::FEEDBACK)) $criteria->add(SessionPeer::FEEDBACK, $this->feedback);
		if ($this->isColumnModified(SessionPeer::DESCRIPTION)) $criteria->add(SessionPeer::DESCRIPTION, $this->description);
		if ($this->isColumnModified(SessionPeer::MICROCYCLE_ID)) $criteria->add(SessionPeer::MICROCYCLE_ID, $this->microcycle_id);
		if ($this->isColumnModified(SessionPeer::WAKE_UP_HR)) $criteria->add(SessionPeer::WAKE_UP_HR, $this->wake_up_hr);
		if ($this->isColumnModified(SessionPeer::THEORIC_VOLUME)) $criteria->add(SessionPeer::THEORIC_VOLUME, $this->theoric_volume);
		if ($this->isColumnModified(SessionPeer::REPORTED_VOLUME)) $criteria->add(SessionPeer::REPORTED_VOLUME, $this->reported_volume);
		if ($this->isColumnModified(SessionPeer::THEORIC_INTENSITY1)) $criteria->add(SessionPeer::THEORIC_INTENSITY1, $this->theoric_intensity1);
		if ($this->isColumnModified(SessionPeer::REPORTED_INTENSITY1)) $criteria->add(SessionPeer::REPORTED_INTENSITY1, $this->reported_intensity1);
		if ($this->isColumnModified(SessionPeer::THEORIC_INTENSITY2)) $criteria->add(SessionPeer::THEORIC_INTENSITY2, $this->theoric_intensity2);
		if ($this->isColumnModified(SessionPeer::REPORTED_INTENSITY2)) $criteria->add(SessionPeer::REPORTED_INTENSITY2, $this->reported_intensity2);
		if ($this->isColumnModified(SessionPeer::THEORIC_INTENSITY3)) $criteria->add(SessionPeer::THEORIC_INTENSITY3, $this->theoric_intensity3);
		if ($this->isColumnModified(SessionPeer::REPORTED_INTENSITY3)) $criteria->add(SessionPeer::REPORTED_INTENSITY3, $this->reported_intensity3);
		if ($this->isColumnModified(SessionPeer::NEW_REPORT)) $criteria->add(SessionPeer::NEW_REPORT, $this->new_report);
		if ($this->isColumnModified(SessionPeer::REPORTED)) $criteria->add(SessionPeer::REPORTED, $this->reported);

		return $criteria;
	}

	
	public function buildPkeyCriteria()
	{
		$criteria = new Criteria(SessionPeer::DATABASE_NAME);

		$criteria->add(SessionPeer::ID, $this->id);

		return $criteria;
	}

	
	public function getPrimaryKey()
	{
		return $this->getId();
	}

	
	public function setPrimaryKey($key)
	{
		$this->setId($key);
	}

	
	public function copyInto($copyObj, $deepCopy = false)
	{

		$copyObj->setDate($this->date);

		$copyObj->setMorningSession($this->morning_session);

		$copyObj->setFeedback($this->feedback);

		$copyObj->setDescription($this->description);

		$copyObj->setMicrocycleId($this->microcycle_id);

		$copyObj->setWakeUpHr($this->wake_up_hr);

		$copyObj->setTheoricVolume($this->theoric_volume);

		$copyObj->setReportedVolume($this->reported_volume);

		$copyObj->setTheoricIntensity1($this->theoric_intensity1);

		$copyObj->setReportedIntensity1($this->reported_intensity1);

		$copyObj->setTheoricIntensity2($this->theoric_intensity2);

		$copyObj->setReportedIntensity2($this->reported_intensity2);

		$copyObj->setTheoricIntensity3($this->theoric_intensity3);

		$copyObj->setReportedIntensity3($this->reported_intensity3);

		$copyObj->setNewReport($this->new_report);

		$copyObj->setReported($this->reported);


		$copyObj->setNew(true);

		$copyObj->setId(NULL); 
	}

	
	public function copy($deepCopy = false)
	{
				$clazz = get_class($this);
		$copyObj = new $clazz();
		$this->copyInto($copyObj, $deepCopy);
		return $copyObj;
	}

	
	public function getPeer()
	{
		if (self::$peer === null) {
			self::$peer = new SessionPeer();
		}
		return self::$peer;
	}

	
	public function setMicrocycle($v)
	{


		if ($v === null) {
			$this->setMicrocycleId(NULL);
		} else {
			$this->setMicrocycleId($v->getId());
		}


		$this->aMicrocycle = $v;
	}


	
	public function getMicrocycle($con = null)
	{
		if ($this->aMicrocycle === null && ($this->microcycle_id !== null)) {
						include_once 'lib/model/om/BaseMicrocyclePeer.php';

			$this->aMicrocycle = MicrocyclePeer::retrieveByPK($this->microcycle_id, $con);

			
		}
		return $this->aMicrocycle;
	}

} 