<?php


abstract class BaseUnit extends BaseObject  implements Persistent {


	
	protected static $peer;


	
	protected $id;


	
	protected $symbol;


	
	protected $unit_type_id;

	
	protected $aUnitType;

	
	protected $collUnitI18Ns;

	
	protected $lastUnitI18NCriteria = null;

	
	protected $collConversionFactorsRelatedByOriginId;

	
	protected $lastConversionFactorRelatedByOriginIdCriteria = null;

	
	protected $collConversionFactorsRelatedByDestinyId;

	
	protected $lastConversionFactorRelatedByDestinyIdCriteria = null;

	
	protected $collSeasonsRelatedByVolumeUnitId;

	
	protected $lastSeasonRelatedByVolumeUnitIdCriteria = null;

	
	protected $collSeasonsRelatedByVolumeShowUnitId;

	
	protected $lastSeasonRelatedByVolumeShowUnitIdCriteria = null;

	
	protected $alreadyInSave = false;

	
	protected $alreadyInValidation = false;

  
  protected $culture;

	
	public function getId()
	{

		return $this->id;
	}

	
	public function getSymbol()
	{

		return $this->symbol;
	}

	
	public function getUnitTypeId()
	{

		return $this->unit_type_id;
	}

	
	public function setId($v)
	{

		
		
		if ($v !== null && !is_int($v) && is_numeric($v)) {
			$v = (int) $v;
		}

		if ($this->id !== $v) {
			$this->id = $v;
			$this->modifiedColumns[] = UnitPeer::ID;
		}

	} 
	
	public function setSymbol($v)
	{

		
		
		if ($v !== null && !is_string($v)) {
			$v = (string) $v; 
		}

		if ($this->symbol !== $v) {
			$this->symbol = $v;
			$this->modifiedColumns[] = UnitPeer::SYMBOL;
		}

	} 
	
	public function setUnitTypeId($v)
	{

		
		
		if ($v !== null && !is_int($v) && is_numeric($v)) {
			$v = (int) $v;
		}

		if ($this->unit_type_id !== $v) {
			$this->unit_type_id = $v;
			$this->modifiedColumns[] = UnitPeer::UNIT_TYPE_ID;
		}

		if ($this->aUnitType !== null && $this->aUnitType->getId() !== $v) {
			$this->aUnitType = null;
		}

	} 
	
	public function hydrate(ResultSet $rs, $startcol = 1)
	{
		try {

			$this->id = $rs->getInt($startcol + 0);

			$this->symbol = $rs->getString($startcol + 1);

			$this->unit_type_id = $rs->getInt($startcol + 2);

			$this->resetModified();

			$this->setNew(false);

						return $startcol + 3; 
		} catch (Exception $e) {
			throw new PropelException("Error populating Unit object", $e);
		}
	}

	
	public function delete($con = null)
	{
		if ($this->isDeleted()) {
			throw new PropelException("This object has already been deleted.");
		}

		if ($con === null) {
			$con = Propel::getConnection(UnitPeer::DATABASE_NAME);
		}

		try {
			$con->begin();
			UnitPeer::doDelete($this, $con);
			$this->setDeleted(true);
			$con->commit();
		} catch (PropelException $e) {
			$con->rollback();
			throw $e;
		}
	}

	
	public function save($con = null)
	{
		if ($this->isDeleted()) {
			throw new PropelException("You cannot save an object that has been deleted.");
		}

		if ($con === null) {
			$con = Propel::getConnection(UnitPeer::DATABASE_NAME);
		}

		try {
			$con->begin();
			$affectedRows = $this->doSave($con);
			$con->commit();
			return $affectedRows;
		} catch (PropelException $e) {
			$con->rollback();
			throw $e;
		}
	}

	
	protected function doSave($con)
	{
		$affectedRows = 0; 		if (!$this->alreadyInSave) {
			$this->alreadyInSave = true;


												
			if ($this->aUnitType !== null) {
				if ($this->aUnitType->isModified() || $this->aUnitType->getCurrentUnitTypeI18N()->isModified()) {
					$affectedRows += $this->aUnitType->save($con);
				}
				$this->setUnitType($this->aUnitType);
			}


						if ($this->isModified()) {
				if ($this->isNew()) {
					$pk = UnitPeer::doInsert($this, $con);
					$affectedRows += 1; 										 										 
					$this->setId($pk);  
					$this->setNew(false);
				} else {
					$affectedRows += UnitPeer::doUpdate($this, $con);
				}
				$this->resetModified(); 			}

			if ($this->collUnitI18Ns !== null) {
				foreach($this->collUnitI18Ns as $referrerFK) {
					if (!$referrerFK->isDeleted()) {
						$affectedRows += $referrerFK->save($con);
					}
				}
			}

			if ($this->collConversionFactorsRelatedByOriginId !== null) {
				foreach($this->collConversionFactorsRelatedByOriginId as $referrerFK) {
					if (!$referrerFK->isDeleted()) {
						$affectedRows += $referrerFK->save($con);
					}
				}
			}

			if ($this->collConversionFactorsRelatedByDestinyId !== null) {
				foreach($this->collConversionFactorsRelatedByDestinyId as $referrerFK) {
					if (!$referrerFK->isDeleted()) {
						$affectedRows += $referrerFK->save($con);
					}
				}
			}

			if ($this->collSeasonsRelatedByVolumeUnitId !== null) {
				foreach($this->collSeasonsRelatedByVolumeUnitId as $referrerFK) {
					if (!$referrerFK->isDeleted()) {
						$affectedRows += $referrerFK->save($con);
					}
				}
			}

			if ($this->collSeasonsRelatedByVolumeShowUnitId !== null) {
				foreach($this->collSeasonsRelatedByVolumeShowUnitId as $referrerFK) {
					if (!$referrerFK->isDeleted()) {
						$affectedRows += $referrerFK->save($con);
					}
				}
			}

			$this->alreadyInSave = false;
		}
		return $affectedRows;
	} 
	
	protected $validationFailures = array();

	
	public function getValidationFailures()
	{
		return $this->validationFailures;
	}

	
	public function validate($columns = null)
	{
		$res = $this->doValidate($columns);
		if ($res === true) {
			$this->validationFailures = array();
			return true;
		} else {
			$this->validationFailures = $res;
			return false;
		}
	}

	
	protected function doValidate($columns = null)
	{
		if (!$this->alreadyInValidation) {
			$this->alreadyInValidation = true;
			$retval = null;

			$failureMap = array();


												
			if ($this->aUnitType !== null) {
				if (!$this->aUnitType->validate($columns)) {
					$failureMap = array_merge($failureMap, $this->aUnitType->getValidationFailures());
				}
			}


			if (($retval = UnitPeer::doValidate($this, $columns)) !== true) {
				$failureMap = array_merge($failureMap, $retval);
			}


				if ($this->collUnitI18Ns !== null) {
					foreach($this->collUnitI18Ns as $referrerFK) {
						if (!$referrerFK->validate($columns)) {
							$failureMap = array_merge($failureMap, $referrerFK->getValidationFailures());
						}
					}
				}

				if ($this->collConversionFactorsRelatedByOriginId !== null) {
					foreach($this->collConversionFactorsRelatedByOriginId as $referrerFK) {
						if (!$referrerFK->validate($columns)) {
							$failureMap = array_merge($failureMap, $referrerFK->getValidationFailures());
						}
					}
				}

				if ($this->collConversionFactorsRelatedByDestinyId !== null) {
					foreach($this->collConversionFactorsRelatedByDestinyId as $referrerFK) {
						if (!$referrerFK->validate($columns)) {
							$failureMap = array_merge($failureMap, $referrerFK->getValidationFailures());
						}
					}
				}

				if ($this->collSeasonsRelatedByVolumeUnitId !== null) {
					foreach($this->collSeasonsRelatedByVolumeUnitId as $referrerFK) {
						if (!$referrerFK->validate($columns)) {
							$failureMap = array_merge($failureMap, $referrerFK->getValidationFailures());
						}
					}
				}

				if ($this->collSeasonsRelatedByVolumeShowUnitId !== null) {
					foreach($this->collSeasonsRelatedByVolumeShowUnitId as $referrerFK) {
						if (!$referrerFK->validate($columns)) {
							$failureMap = array_merge($failureMap, $referrerFK->getValidationFailures());
						}
					}
				}


			$this->alreadyInValidation = false;
		}

		return (!empty($failureMap) ? $failureMap : true);
	}

	
	public function getByName($name, $type = BasePeer::TYPE_PHPNAME)
	{
		$pos = UnitPeer::translateFieldName($name, $type, BasePeer::TYPE_NUM);
		return $this->getByPosition($pos);
	}

	
	public function getByPosition($pos)
	{
		switch($pos) {
			case 0:
				return $this->getId();
				break;
			case 1:
				return $this->getSymbol();
				break;
			case 2:
				return $this->getUnitTypeId();
				break;
			default:
				return null;
				break;
		} 	}

	
	public function toArray($keyType = BasePeer::TYPE_PHPNAME)
	{
		$keys = UnitPeer::getFieldNames($keyType);
		$result = array(
			$keys[0] => $this->getId(),
			$keys[1] => $this->getSymbol(),
			$keys[2] => $this->getUnitTypeId(),
		);
		return $result;
	}

	
	public function setByName($name, $value, $type = BasePeer::TYPE_PHPNAME)
	{
		$pos = UnitPeer::translateFieldName($name, $type, BasePeer::TYPE_NUM);
		return $this->setByPosition($pos, $value);
	}

	
	public function setByPosition($pos, $value)
	{
		switch($pos) {
			case 0:
				$this->setId($value);
				break;
			case 1:
				$this->setSymbol($value);
				break;
			case 2:
				$this->setUnitTypeId($value);
				break;
		} 	}

	
	public function fromArray($arr, $keyType = BasePeer::TYPE_PHPNAME)
	{
		$keys = UnitPeer::getFieldNames($keyType);

		if (array_key_exists($keys[0], $arr)) $this->setId($arr[$keys[0]]);
		if (array_key_exists($keys[1], $arr)) $this->setSymbol($arr[$keys[1]]);
		if (array_key_exists($keys[2], $arr)) $this->setUnitTypeId($arr[$keys[2]]);
	}

	
	public function buildCriteria()
	{
		$criteria = new Criteria(UnitPeer::DATABASE_NAME);

		if ($this->isColumnModified(UnitPeer::ID)) $criteria->add(UnitPeer::ID, $this->id);
		if ($this->isColumnModified(UnitPeer::SYMBOL)) $criteria->add(UnitPeer::SYMBOL, $this->symbol);
		if ($this->isColumnModified(UnitPeer::UNIT_TYPE_ID)) $criteria->add(UnitPeer::UNIT_TYPE_ID, $this->unit_type_id);

		return $criteria;
	}

	
	public function buildPkeyCriteria()
	{
		$criteria = new Criteria(UnitPeer::DATABASE_NAME);

		$criteria->add(UnitPeer::ID, $this->id);

		return $criteria;
	}

	
	public function getPrimaryKey()
	{
		return $this->getId();
	}

	
	public function setPrimaryKey($key)
	{
		$this->setId($key);
	}

	
	public function copyInto($copyObj, $deepCopy = false)
	{

		$copyObj->setSymbol($this->symbol);

		$copyObj->setUnitTypeId($this->unit_type_id);


		if ($deepCopy) {
									$copyObj->setNew(false);

			foreach($this->getUnitI18Ns() as $relObj) {
				$copyObj->addUnitI18N($relObj->copy($deepCopy));
			}

			foreach($this->getConversionFactorsRelatedByOriginId() as $relObj) {
				$copyObj->addConversionFactorRelatedByOriginId($relObj->copy($deepCopy));
			}

			foreach($this->getConversionFactorsRelatedByDestinyId() as $relObj) {
				$copyObj->addConversionFactorRelatedByDestinyId($relObj->copy($deepCopy));
			}

			foreach($this->getSeasonsRelatedByVolumeUnitId() as $relObj) {
				$copyObj->addSeasonRelatedByVolumeUnitId($relObj->copy($deepCopy));
			}

			foreach($this->getSeasonsRelatedByVolumeShowUnitId() as $relObj) {
				$copyObj->addSeasonRelatedByVolumeShowUnitId($relObj->copy($deepCopy));
			}

		} 

		$copyObj->setNew(true);

		$copyObj->setId(NULL); 
	}

	
	public function copy($deepCopy = false)
	{
				$clazz = get_class($this);
		$copyObj = new $clazz();
		$this->copyInto($copyObj, $deepCopy);
		return $copyObj;
	}

	
	public function getPeer()
	{
		if (self::$peer === null) {
			self::$peer = new UnitPeer();
		}
		return self::$peer;
	}

	
	public function setUnitType($v)
	{


		if ($v === null) {
			$this->setUnitTypeId(NULL);
		} else {
			$this->setUnitTypeId($v->getId());
		}


		$this->aUnitType = $v;
	}


	
	public function getUnitType($con = null)
	{
		if ($this->aUnitType === null && ($this->unit_type_id !== null)) {
						include_once 'lib/model/om/BaseUnitTypePeer.php';

			$this->aUnitType = UnitTypePeer::retrieveByPK($this->unit_type_id, $con);

			
		}
		return $this->aUnitType;
	}

	
	public function initUnitI18Ns()
	{
		if ($this->collUnitI18Ns === null) {
			$this->collUnitI18Ns = array();
		}
	}

	
	public function getUnitI18Ns($criteria = null, $con = null)
	{
				include_once 'lib/model/om/BaseUnitI18NPeer.php';
		if ($criteria === null) {
			$criteria = new Criteria();
		}
		elseif ($criteria instanceof Criteria)
		{
			$criteria = clone $criteria;
		}

		if ($this->collUnitI18Ns === null) {
			if ($this->isNew()) {
			   $this->collUnitI18Ns = array();
			} else {

				$criteria->add(UnitI18NPeer::ID, $this->getId());

				UnitI18NPeer::addSelectColumns($criteria);
				$this->collUnitI18Ns = UnitI18NPeer::doSelect($criteria, $con);
			}
		} else {
						if (!$this->isNew()) {
												

				$criteria->add(UnitI18NPeer::ID, $this->getId());

				UnitI18NPeer::addSelectColumns($criteria);
				if (!isset($this->lastUnitI18NCriteria) || !$this->lastUnitI18NCriteria->equals($criteria)) {
					$this->collUnitI18Ns = UnitI18NPeer::doSelect($criteria, $con);
				}
			}
		}
		$this->lastUnitI18NCriteria = $criteria;
		return $this->collUnitI18Ns;
	}

	
	public function countUnitI18Ns($criteria = null, $distinct = false, $con = null)
	{
				include_once 'lib/model/om/BaseUnitI18NPeer.php';
		if ($criteria === null) {
			$criteria = new Criteria();
		}
		elseif ($criteria instanceof Criteria)
		{
			$criteria = clone $criteria;
		}

		$criteria->add(UnitI18NPeer::ID, $this->getId());

		return UnitI18NPeer::doCount($criteria, $distinct, $con);
	}

	
	public function addUnitI18N(UnitI18N $l)
	{
		$this->collUnitI18Ns[] = $l;
		$l->setUnit($this);
	}

	
	public function initConversionFactorsRelatedByOriginId()
	{
		if ($this->collConversionFactorsRelatedByOriginId === null) {
			$this->collConversionFactorsRelatedByOriginId = array();
		}
	}

	
	public function getConversionFactorsRelatedByOriginId($criteria = null, $con = null)
	{
				include_once 'lib/model/om/BaseConversionFactorPeer.php';
		if ($criteria === null) {
			$criteria = new Criteria();
		}
		elseif ($criteria instanceof Criteria)
		{
			$criteria = clone $criteria;
		}

		if ($this->collConversionFactorsRelatedByOriginId === null) {
			if ($this->isNew()) {
			   $this->collConversionFactorsRelatedByOriginId = array();
			} else {

				$criteria->add(ConversionFactorPeer::ORIGIN_ID, $this->getId());

				ConversionFactorPeer::addSelectColumns($criteria);
				$this->collConversionFactorsRelatedByOriginId = ConversionFactorPeer::doSelect($criteria, $con);
			}
		} else {
						if (!$this->isNew()) {
												

				$criteria->add(ConversionFactorPeer::ORIGIN_ID, $this->getId());

				ConversionFactorPeer::addSelectColumns($criteria);
				if (!isset($this->lastConversionFactorRelatedByOriginIdCriteria) || !$this->lastConversionFactorRelatedByOriginIdCriteria->equals($criteria)) {
					$this->collConversionFactorsRelatedByOriginId = ConversionFactorPeer::doSelect($criteria, $con);
				}
			}
		}
		$this->lastConversionFactorRelatedByOriginIdCriteria = $criteria;
		return $this->collConversionFactorsRelatedByOriginId;
	}

	
	public function countConversionFactorsRelatedByOriginId($criteria = null, $distinct = false, $con = null)
	{
				include_once 'lib/model/om/BaseConversionFactorPeer.php';
		if ($criteria === null) {
			$criteria = new Criteria();
		}
		elseif ($criteria instanceof Criteria)
		{
			$criteria = clone $criteria;
		}

		$criteria->add(ConversionFactorPeer::ORIGIN_ID, $this->getId());

		return ConversionFactorPeer::doCount($criteria, $distinct, $con);
	}

	
	public function addConversionFactorRelatedByOriginId(ConversionFactor $l)
	{
		$this->collConversionFactorsRelatedByOriginId[] = $l;
		$l->setUnitRelatedByOriginId($this);
	}

	
	public function initConversionFactorsRelatedByDestinyId()
	{
		if ($this->collConversionFactorsRelatedByDestinyId === null) {
			$this->collConversionFactorsRelatedByDestinyId = array();
		}
	}

	
	public function getConversionFactorsRelatedByDestinyId($criteria = null, $con = null)
	{
				include_once 'lib/model/om/BaseConversionFactorPeer.php';
		if ($criteria === null) {
			$criteria = new Criteria();
		}
		elseif ($criteria instanceof Criteria)
		{
			$criteria = clone $criteria;
		}

		if ($this->collConversionFactorsRelatedByDestinyId === null) {
			if ($this->isNew()) {
			   $this->collConversionFactorsRelatedByDestinyId = array();
			} else {

				$criteria->add(ConversionFactorPeer::DESTINY_ID, $this->getId());

				ConversionFactorPeer::addSelectColumns($criteria);
				$this->collConversionFactorsRelatedByDestinyId = ConversionFactorPeer::doSelect($criteria, $con);
			}
		} else {
						if (!$this->isNew()) {
												

				$criteria->add(ConversionFactorPeer::DESTINY_ID, $this->getId());

				ConversionFactorPeer::addSelectColumns($criteria);
				if (!isset($this->lastConversionFactorRelatedByDestinyIdCriteria) || !$this->lastConversionFactorRelatedByDestinyIdCriteria->equals($criteria)) {
					$this->collConversionFactorsRelatedByDestinyId = ConversionFactorPeer::doSelect($criteria, $con);
				}
			}
		}
		$this->lastConversionFactorRelatedByDestinyIdCriteria = $criteria;
		return $this->collConversionFactorsRelatedByDestinyId;
	}

	
	public function countConversionFactorsRelatedByDestinyId($criteria = null, $distinct = false, $con = null)
	{
				include_once 'lib/model/om/BaseConversionFactorPeer.php';
		if ($criteria === null) {
			$criteria = new Criteria();
		}
		elseif ($criteria instanceof Criteria)
		{
			$criteria = clone $criteria;
		}

		$criteria->add(ConversionFactorPeer::DESTINY_ID, $this->getId());

		return ConversionFactorPeer::doCount($criteria, $distinct, $con);
	}

	
	public function addConversionFactorRelatedByDestinyId(ConversionFactor $l)
	{
		$this->collConversionFactorsRelatedByDestinyId[] = $l;
		$l->setUnitRelatedByDestinyId($this);
	}

	
	public function initSeasonsRelatedByVolumeUnitId()
	{
		if ($this->collSeasonsRelatedByVolumeUnitId === null) {
			$this->collSeasonsRelatedByVolumeUnitId = array();
		}
	}

	
	public function getSeasonsRelatedByVolumeUnitId($criteria = null, $con = null)
	{
				include_once 'lib/model/om/BaseSeasonPeer.php';
		if ($criteria === null) {
			$criteria = new Criteria();
		}
		elseif ($criteria instanceof Criteria)
		{
			$criteria = clone $criteria;
		}

		if ($this->collSeasonsRelatedByVolumeUnitId === null) {
			if ($this->isNew()) {
			   $this->collSeasonsRelatedByVolumeUnitId = array();
			} else {

				$criteria->add(SeasonPeer::VOLUME_UNIT_ID, $this->getId());

				SeasonPeer::addSelectColumns($criteria);
				$this->collSeasonsRelatedByVolumeUnitId = SeasonPeer::doSelect($criteria, $con);
			}
		} else {
						if (!$this->isNew()) {
												

				$criteria->add(SeasonPeer::VOLUME_UNIT_ID, $this->getId());

				SeasonPeer::addSelectColumns($criteria);
				if (!isset($this->lastSeasonRelatedByVolumeUnitIdCriteria) || !$this->lastSeasonRelatedByVolumeUnitIdCriteria->equals($criteria)) {
					$this->collSeasonsRelatedByVolumeUnitId = SeasonPeer::doSelect($criteria, $con);
				}
			}
		}
		$this->lastSeasonRelatedByVolumeUnitIdCriteria = $criteria;
		return $this->collSeasonsRelatedByVolumeUnitId;
	}

	
	public function countSeasonsRelatedByVolumeUnitId($criteria = null, $distinct = false, $con = null)
	{
				include_once 'lib/model/om/BaseSeasonPeer.php';
		if ($criteria === null) {
			$criteria = new Criteria();
		}
		elseif ($criteria instanceof Criteria)
		{
			$criteria = clone $criteria;
		}

		$criteria->add(SeasonPeer::VOLUME_UNIT_ID, $this->getId());

		return SeasonPeer::doCount($criteria, $distinct, $con);
	}

	
	public function addSeasonRelatedByVolumeUnitId(Season $l)
	{
		$this->collSeasonsRelatedByVolumeUnitId[] = $l;
		$l->setUnitRelatedByVolumeUnitId($this);
	}


	
	public function getSeasonsRelatedByVolumeUnitIdJoinUser($criteria = null, $con = null)
	{
				include_once 'lib/model/om/BaseSeasonPeer.php';
		if ($criteria === null) {
			$criteria = new Criteria();
		}
		elseif ($criteria instanceof Criteria)
		{
			$criteria = clone $criteria;
		}

		if ($this->collSeasonsRelatedByVolumeUnitId === null) {
			if ($this->isNew()) {
				$this->collSeasonsRelatedByVolumeUnitId = array();
			} else {

				$criteria->add(SeasonPeer::VOLUME_UNIT_ID, $this->getId());

				$this->collSeasonsRelatedByVolumeUnitId = SeasonPeer::doSelectJoinUser($criteria, $con);
			}
		} else {
									
			$criteria->add(SeasonPeer::VOLUME_UNIT_ID, $this->getId());

			if (!isset($this->lastSeasonRelatedByVolumeUnitIdCriteria) || !$this->lastSeasonRelatedByVolumeUnitIdCriteria->equals($criteria)) {
				$this->collSeasonsRelatedByVolumeUnitId = SeasonPeer::doSelectJoinUser($criteria, $con);
			}
		}
		$this->lastSeasonRelatedByVolumeUnitIdCriteria = $criteria;

		return $this->collSeasonsRelatedByVolumeUnitId;
	}


	
	public function getSeasonsRelatedByVolumeUnitIdJoinUnitType($criteria = null, $con = null)
	{
				include_once 'lib/model/om/BaseSeasonPeer.php';
		if ($criteria === null) {
			$criteria = new Criteria();
		}
		elseif ($criteria instanceof Criteria)
		{
			$criteria = clone $criteria;
		}

		if ($this->collSeasonsRelatedByVolumeUnitId === null) {
			if ($this->isNew()) {
				$this->collSeasonsRelatedByVolumeUnitId = array();
			} else {

				$criteria->add(SeasonPeer::VOLUME_UNIT_ID, $this->getId());

				$this->collSeasonsRelatedByVolumeUnitId = SeasonPeer::doSelectJoinUnitType($criteria, $con);
			}
		} else {
									
			$criteria->add(SeasonPeer::VOLUME_UNIT_ID, $this->getId());

			if (!isset($this->lastSeasonRelatedByVolumeUnitIdCriteria) || !$this->lastSeasonRelatedByVolumeUnitIdCriteria->equals($criteria)) {
				$this->collSeasonsRelatedByVolumeUnitId = SeasonPeer::doSelectJoinUnitType($criteria, $con);
			}
		}
		$this->lastSeasonRelatedByVolumeUnitIdCriteria = $criteria;

		return $this->collSeasonsRelatedByVolumeUnitId;
	}

	
	public function initSeasonsRelatedByVolumeShowUnitId()
	{
		if ($this->collSeasonsRelatedByVolumeShowUnitId === null) {
			$this->collSeasonsRelatedByVolumeShowUnitId = array();
		}
	}

	
	public function getSeasonsRelatedByVolumeShowUnitId($criteria = null, $con = null)
	{
				include_once 'lib/model/om/BaseSeasonPeer.php';
		if ($criteria === null) {
			$criteria = new Criteria();
		}
		elseif ($criteria instanceof Criteria)
		{
			$criteria = clone $criteria;
		}

		if ($this->collSeasonsRelatedByVolumeShowUnitId === null) {
			if ($this->isNew()) {
			   $this->collSeasonsRelatedByVolumeShowUnitId = array();
			} else {

				$criteria->add(SeasonPeer::VOLUME_SHOW_UNIT_ID, $this->getId());

				SeasonPeer::addSelectColumns($criteria);
				$this->collSeasonsRelatedByVolumeShowUnitId = SeasonPeer::doSelect($criteria, $con);
			}
		} else {
						if (!$this->isNew()) {
												

				$criteria->add(SeasonPeer::VOLUME_SHOW_UNIT_ID, $this->getId());

				SeasonPeer::addSelectColumns($criteria);
				if (!isset($this->lastSeasonRelatedByVolumeShowUnitIdCriteria) || !$this->lastSeasonRelatedByVolumeShowUnitIdCriteria->equals($criteria)) {
					$this->collSeasonsRelatedByVolumeShowUnitId = SeasonPeer::doSelect($criteria, $con);
				}
			}
		}
		$this->lastSeasonRelatedByVolumeShowUnitIdCriteria = $criteria;
		return $this->collSeasonsRelatedByVolumeShowUnitId;
	}

	
	public function countSeasonsRelatedByVolumeShowUnitId($criteria = null, $distinct = false, $con = null)
	{
				include_once 'lib/model/om/BaseSeasonPeer.php';
		if ($criteria === null) {
			$criteria = new Criteria();
		}
		elseif ($criteria instanceof Criteria)
		{
			$criteria = clone $criteria;
		}

		$criteria->add(SeasonPeer::VOLUME_SHOW_UNIT_ID, $this->getId());

		return SeasonPeer::doCount($criteria, $distinct, $con);
	}

	
	public function addSeasonRelatedByVolumeShowUnitId(Season $l)
	{
		$this->collSeasonsRelatedByVolumeShowUnitId[] = $l;
		$l->setUnitRelatedByVolumeShowUnitId($this);
	}


	
	public function getSeasonsRelatedByVolumeShowUnitIdJoinUser($criteria = null, $con = null)
	{
				include_once 'lib/model/om/BaseSeasonPeer.php';
		if ($criteria === null) {
			$criteria = new Criteria();
		}
		elseif ($criteria instanceof Criteria)
		{
			$criteria = clone $criteria;
		}

		if ($this->collSeasonsRelatedByVolumeShowUnitId === null) {
			if ($this->isNew()) {
				$this->collSeasonsRelatedByVolumeShowUnitId = array();
			} else {

				$criteria->add(SeasonPeer::VOLUME_SHOW_UNIT_ID, $this->getId());

				$this->collSeasonsRelatedByVolumeShowUnitId = SeasonPeer::doSelectJoinUser($criteria, $con);
			}
		} else {
									
			$criteria->add(SeasonPeer::VOLUME_SHOW_UNIT_ID, $this->getId());

			if (!isset($this->lastSeasonRelatedByVolumeShowUnitIdCriteria) || !$this->lastSeasonRelatedByVolumeShowUnitIdCriteria->equals($criteria)) {
				$this->collSeasonsRelatedByVolumeShowUnitId = SeasonPeer::doSelectJoinUser($criteria, $con);
			}
		}
		$this->lastSeasonRelatedByVolumeShowUnitIdCriteria = $criteria;

		return $this->collSeasonsRelatedByVolumeShowUnitId;
	}


	
	public function getSeasonsRelatedByVolumeShowUnitIdJoinUnitType($criteria = null, $con = null)
	{
				include_once 'lib/model/om/BaseSeasonPeer.php';
		if ($criteria === null) {
			$criteria = new Criteria();
		}
		elseif ($criteria instanceof Criteria)
		{
			$criteria = clone $criteria;
		}

		if ($this->collSeasonsRelatedByVolumeShowUnitId === null) {
			if ($this->isNew()) {
				$this->collSeasonsRelatedByVolumeShowUnitId = array();
			} else {

				$criteria->add(SeasonPeer::VOLUME_SHOW_UNIT_ID, $this->getId());

				$this->collSeasonsRelatedByVolumeShowUnitId = SeasonPeer::doSelectJoinUnitType($criteria, $con);
			}
		} else {
									
			$criteria->add(SeasonPeer::VOLUME_SHOW_UNIT_ID, $this->getId());

			if (!isset($this->lastSeasonRelatedByVolumeShowUnitIdCriteria) || !$this->lastSeasonRelatedByVolumeShowUnitIdCriteria->equals($criteria)) {
				$this->collSeasonsRelatedByVolumeShowUnitId = SeasonPeer::doSelectJoinUnitType($criteria, $con);
			}
		}
		$this->lastSeasonRelatedByVolumeShowUnitIdCriteria = $criteria;

		return $this->collSeasonsRelatedByVolumeShowUnitId;
	}

  public function getCulture()
  {
    return $this->culture;
  }

  public function setCulture($culture)
  {
    $this->culture = $culture;
  }

  public function getDescription()
  {
    $obj = $this->getCurrentUnitI18N();

    return ($obj ? $obj->getDescription() : null);
  }

  public function setDescription($value)
  {
    $this->getCurrentUnitI18N()->setDescription($value);
  }

  protected $current_i18n = array();

  public function getCurrentUnitI18N()
  {
    if (!isset($this->current_i18n[$this->culture]))
    {
      $obj = UnitI18NPeer::retrieveByPK($this->getId(), $this->culture);
      if ($obj)
      {
        $this->setUnitI18NForCulture($obj, $this->culture);
      }
      else
      {
        $this->setUnitI18NForCulture(new UnitI18N(), $this->culture);
        $this->current_i18n[$this->culture]->setCulture($this->culture);
      }
    }

    return $this->current_i18n[$this->culture];
  }

  public function setUnitI18NForCulture($object, $culture)
  {
    $this->current_i18n[$culture] = $object;
    $this->addUnitI18N($object);
  }

} 