<?php
/**
 * File to add static util funcitons to all project
 * 
 * @author Diego Cebrián
 * @package lib
 */

/**
 * Static classe that stores general methods to do things
 *
 * @author Diego Cebrián
 * @package lib
 */
class MyTools{
	
	/**
	 * Method to check if a date is valid 
	 *
	 * @param date $date
	 * @param string $culture
	 * @return boolean
	 */
  public static function isValidDate($date, $culture = null) {
        if (!$date) return false;
        if (!$culture)
            $culture = sfContext::getInstance()->getUser()->getCulture();
        
        $dateFormatInfo = @sfDateTimeFormatInfo::getInstance($culture);
        $dateFormat = $dateFormatInfo->getShortDatePattern();
        
        // We construct the regexp based on date format
        $dateRegexp = preg_replace('/[dmy]+/i', '(\d+)', $dateFormat);
        
        // We parse date format to see where things are (m, d, y)
        $a = array(
            'd' => strpos($dateFormat, 'd'),
            'm' => strpos($dateFormat, 'M'),
            'y' => strpos($dateFormat, 'y'),
        );
        $tmp = array_flip($a);
        ksort($tmp);
        $i = 0;
        $c = array();
        foreach ($tmp as $value) $c[++$i] = $value;
        $datePositions = array_flip($c);
        
        // We find all elements
        preg_match("~$dateRegexp~", $date, $matches);
        
        if (count($matches) < 4)
            return false;
        
        $m = $matches[$datePositions['m']];
        $d = $matches[$datePositions['d']];
        $y = $matches[$datePositions['y']];
        
        if (!checkdate($m, $d, $y))
            return false;
        if((strlen($y)!=2)&&(strlen($y)!=4)){
          return false;
        }
        
        return true;
    }
}
?>